SystemOrganization addCategory: #'GT-Spotter'!
SystemOrganization addCategory: 'GT-Spotter-Announcements'!
SystemOrganization addCategory: 'GT-Spotter-Exceptions'!
SystemOrganization addCategory: 'GT-Spotter-Filters'!
SystemOrganization addCategory: 'GT-Spotter-Iterators'!
SystemOrganization addCategory: 'GT-Spotter-Model'!
SystemOrganization addCategory: 'GT-Spotter-Processors'!
SystemOrganization addCategory: 'GT-Spotter-Renderer'!
SystemOrganization addCategory: 'GT-Spotter-Theme'!
SystemOrganization addCategory: 'GT-Spotter-UI'!
SystemOrganization addCategory: 'GT-Spotter-Utils'!

DoubleLinkedList subclass: #GTSpotterDoubleLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
head

	^ head! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:45'!
head: aDoubleLink

	head := aDoubleLink! !

!GTSpotterDoubleLinkedList methodsFor: 'enumerating' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
linksDo: aBlock
	| current |
	current := head.
	[ current isNil ] 
		whileFalse: [ 
	 		aBlock value: current.
			current := current nextLink ]! !

!GTSpotterDoubleLinkedList methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/15/2014 13:59'!
removeCycledLink: link
	| predecessor successor |
	predecessor := link previousLink.
	successor := link nextLink.
	predecessor
		ifNil: [ head := successor ]
		ifNotNil: [ predecessor nextLink: successor ].
	successor
		ifNil: [ tail := predecessor ]
		ifNotNil: [ successor previousLink: predecessor ].
	link clearLinks.
	
	"I'm the only one left, clear linked list and return"
	(link = head & (link = tail)) ifTrue: [ head := nil. tail := nil. ^ link ].
	
	link = head ifTrue: [ head := successor ].
	link = tail ifTrue: [ tail := predecessor ].
	
	^ link! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
tail

	^ tail! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:45'!
tail: aDoubleLink

	tail := aDoubleLink! !

!BlockClosure methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 2/24/2015 14:21'!
gtFilter
	^ self ! !

!BlockClosure methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/20/2015 16:18'!
gtIterator
	" 1:filter 2:context[optional] "
	self assert: (self numArgs between: 1 and: 2). 
	
	^ GTSpotterBlockIterator new 
		onDo: self;
		yourself! !

!BlockClosure methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/20/2015 11:48'!
hasDynamicItems
	^ self numArgs ~= 0! !

!Collection methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/20/2015 16:15'!
gtIterator
	^ [ :filter | self do: filter ] gtIterator! !

GLMBandBrick subclass: #GTSpotterCategoryBrick
	instanceVariableNames: 'listBrick titleBrick stepModel category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:11'!
category

	^ category! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:14'!
category: aProcessorClass

	category := aProcessorClass! !

!GTSpotterCategoryBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/29/2014 14:54'!
on: aStepModel category: aProcessor

	self stepModel: aStepModel.
	self category: aProcessor.! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/2/2014 16:00'!
setAmountVisible: visible all: all

	self titleBrick setAmountVisible: visible all: all! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:34'!
stepModel
	^ stepModel! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:33'!
stepModel: anObject
	stepModel := anObject.! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:39'!
titleBrick
	^ titleBrick! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/29/2014 14:24'!
titleBrick: aBrick

	titleBrick := aBrick! !

!GLMBrickThemer methodsFor: '*GT-Spotter' stamp: 'AliakseiSyrel 3/17/2015 22:59'!
spotterThemer

	^ self
		registerModule: GTSpotterWidgetThemer new
		to: GTSpotterBrickThemer new! !

GLMBrickThemer subclass: #GTSpotterBrickThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterBrickThemer methodsFor: 'brick-rubric' stamp: 'AliakseiSyrel 3/21/2015 21:35'!
rubricBackgroundColor

	^ self spotterThemer backgroundColor! !

!GTSpotterBrickThemer methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 15:01'!
scrollbarColor

	^ Color lightGray alpha: 0.2! !

!GTSpotterBrickThemer methodsFor: 'brick-scrollpane' stamp: 'AliakseiSyrel 3/21/2015 21:34'!
scrollpaneBackgroundColor

	^ self spotterThemer backgroundColor! !

CustomHelp subclass: #GTSpotterHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter'!

!GTSpotterHelp commentStamp: 'TudorGirba 1/20/2016 16:49' prior: 0!
A helper class containing the help for GT Spotter.!

!GTSpotterHelp class methodsFor: 'accessing' stamp: 'TudorGirba 1/20/2016 16:48'!
bookName 
	^'GT Spotter'! !

!GTSpotterHelp class methodsFor: 'documentation' stamp: 'TudorGirba 1/20/2016 23:23'!
extensions
		
	^ HelpTopic 
		title: 'Extensions'
		contents: 'Spotter allows the developer to define custom search processors in different classes. These custom processors take effect when Spotter reaches an instance of the extended class. Here is the list of extensions from this image

', self extensionsString! !

!GTSpotterHelp class methodsFor: 'documentation' stamp: 'TudorGirba 1/20/2016 23:30'!
extensionsString
	| methods title |
	^ String streamContents: [ :s |
		((GTSpotter spotterExtendingMethods groupedBy: #methodClass) 
		associations sorted: [ :a :b | a key name < b key name ]) 
		do: [ :classMethodsAssociation |
			s nextPutAll: classMethodsAssociation key name; cr.
			methods := classMethodsAssociation value.
			methods do: [ :each | 
				title := each ast allChildren 
					detect: [ :node | node isMessage and: [ node selector = #title: ] ]
					ifFound: [ :node | node arguments first value. ]
					ifNone: [ each selector ].
				title isString ifFalse: [ title := each selector ].
				s 
					nextPutAll: '- '; 
					nextPutAll: title; 
					nextPutAll: ' ('; 
					nextPutAll: each selector; 
					nextPut: $);
					cr ].
			s cr ] ]! !

!GTSpotterHelp class methodsFor: 'documentation' stamp: 'TudorGirba 1/20/2016 20:44'!
keybindings
	^ HelpTopic 
		title: 'Keybindings'
		contents: 
'Cmd+p - open/close the preview pane

Cmd+w / Esc - close Spotter

Up / Down - navigate through the search result list

Cmd+Shift+Up/Down - navigate through the search categories

Enter - triggers the default action on the selected object

Cmd+Right - dive in an object

Cmd+Left / Cmd+Shift+Left - dive out from an object into the previous step

Cmd+Shift+Right - dive in a category to see its elements'! !

!GTSpotterHelp class methodsFor: 'documentation' stamp: 'TudorGirba 1/20/2016 22:43'!
overview
	^ HelpTopic 
		title: 'Overview'
		contents: 
'GT Spotter is a moldable object search tool that is part of Pharo and was developed as part of the Glamorous Toolkit project (http://gt.moosetechnology.org).

Its goal is to help developers find and navigate through all sorts of objects, including packages, classes, methods, code snippets, or menus.'! !

!GTSpotterHelp class methodsFor: 'accessing' stamp: 'TudorGirba 1/20/2016 23:11'!
pages
	^#(overview keybindings extensions)! !

GLMBrickRenderer subclass: #GTSpotterBreadcrumbSeparatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Renderer'!

!GTSpotterBreadcrumbSeparatorRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/26/2015 00:26'!
render: aBrick on: aCanvas
	super renderBackgroundColorOf: aBrick on: aCanvas.
	
	self renderArrow: aBrick on: aCanvas! !

!GTSpotterBreadcrumbSeparatorRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/16/2015 14:16'!
renderArrow: aBrick on: aCanvas
	|height width hW hH aX bX cX aY bY cY a b c overdraw delta|
	
	overdraw := 2.
	delta := 1.
	height := aBrick brickBounds height.
	width := aBrick brickBounds width.
	hH := height / 4.
	hW := width / 2.
	
	aX := (((hW - hH) max: 0) min: width) floor - overdraw - delta.
	bX := (((hW + hH) max: 0) min: width) floor - delta.
	cX := aX.
	
	aY := overdraw negated.
	bY := (hH * 2) floor.
	cY := height + overdraw.
	
	a := aBrick brickBounds topLeft + (aX@aY).
	b := aBrick brickBounds topLeft + (bX@bY).
	c := aBrick brickBounds topLeft + (cX@cY).
	
	aCanvas line: a to: b width: aBrick borderWidth first color: aBrick borderColor first.
	aCanvas line: b to: c width: aBrick borderWidth first color: aBrick borderColor first! !

GLMBrickRenderer subclass: #GTSpotterTriangleRenderer
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Renderer'!

!GTSpotterTriangleRenderer methodsFor: 'mathematical functions' stamp: 'AliakseiSyrel 1/25/2015 13:48'!
findTriangleEdgeLength: anInteger

	^ 2 / 3 * (3 sqrt) * anInteger! !

!GTSpotterTriangleRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:34'!
orientation
	^ orientation ifNil: [ #bottom ]! !

!GTSpotterTriangleRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:34'!
orientation: aSymbol
	"can be #right #bottom #left #top"

	orientation := aSymbol! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 16:52'!
render: aBrick on: aCanvas
	
	self orientation = #right ifTrue: [ self renderRightTriangle: aBrick on: aCanvas ].
	self orientation = #bottom ifTrue: [ self renderBottomTriangle: aBrick on: aCanvas ].
	self orientation = #left ifTrue: [ self renderLeftTriangle: aBrick on: aCanvas ].
	self orientation = #top ifTrue: [ self renderTopTriangle: aBrick on: aCanvas ].! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:05'!
renderBottomTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topLeft + (((width / 2 - height) max: 0) @ 0).
	b := aBrick brickBounds topLeft + (((width / 2 + height) min: width) @ 0).
	c := aBrick brickBounds bottomLeft + (width / 2 @ 0).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:07'!
renderLeftTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topRight + (0 @ ((height / 2 - width) max: 0)).
	b := aBrick brickBounds topRight + (0 @ ((height / 2 + width) min: height)).
	c := aBrick brickBounds topLeft + (0 @ (height / 2)).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/30/2015 23:32'!
renderRightTriangle: aBrick on: aCanvas
	|a b c width height gap|
	
	gap := aBrick themer spotterThemer previewArrowGapHack.
	aCanvas fillRectangle: (aBrick brickBounds withWidth: gap) color: aBrick color.
	
	width := aBrick brickBounds width - gap.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topLeft + (gap @ ((height / 2 - width) max: 0)).
	b := aBrick brickBounds topLeft + (gap @ ((height / 2 + width) min: height)).
	c := aBrick brickBounds topRight + (0 @ (height / 2)).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:06'!
renderTopTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds bottomLeft + (((width / 2 - height) max: 0) @ 0).
	b := aBrick brickBounds bottomLeft + (((width / 2 + height) min: width) @ 0).
	c := aBrick brickBounds topLeft + (width / 2 @ 0).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 13:56'!
renderTriangle: aBrick on: aCanvas with: aCollection

	aCanvas drawPolygon: aCollection color: aBrick color borderWidth: 0 borderColor: Color transparent! !

GLMFoundationBrick subclass: #GTSpotterMorph
	instanceVariableNames: 'focusedMorph breadcrumbBrick paneBrick spotterModel autoHide privacyAgreementNotificationBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterMorph methodsFor: 'actions' stamp: 'StefanReichhart 3/22/2015 18:25'!
actDueTo: anEventType
	self spotterModelDo: [
		self spotterModel isEmpty ifTrue: [ ^self ].
		self spotterModel currentStep isEmpty ifTrue: [ ^ self ].
		self spotterModel currentStep actDueTo: anEventType ]! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/19/2015 20:46'!
autoHide

	^ autoHide ifNil: [ autoHide := true ]! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/19/2015 20:47'!
autoHide: aBoolean

	autoHide := aBoolean! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'VincentBlondeau 7/16/2015 12:18'!
bindingDictionnary
	^ {Character escape -> [ self spotterModel exitDueTo: #keyPressedEscape ].
	$w command -> [ self spotterModel exitDueTo: #keyPressedW ].
	$p command -> [ self togglePreview ].
	Character arrowUp -> [ self selectPreviousCandidateDueTo: #keyPressedArrowUp ].
	Character arrowDown -> [ self selectNextCandidateDueTo: #keyPressedArrowDown ].
	Character arrowUp command -> [ self selectPreviousCandidateDueTo: #keyPressedArrowUp ].
	Character arrowDown command -> [ self selectNextCandidateDueTo: #keyPressedArrowDown ].
	Character arrowUp shift -> [ self selectPreviousCandidateDueTo: #keyPressedArrowUp ].
	Character arrowDown shift -> [ self selectNextCandidateDueTo: #keyPressedArrowDown ].
	Character arrowUp command shift -> [ self selectPreviousCategory ].
	Character arrowDown command shift -> [ self selectNextCategory ].
	Character arrowRight command -> [ self diveInDueTo: #keyPressed ].
	Character arrowLeft command -> [ self diveOut ].
	Character arrowRight command shift -> [ self diveInCategoryDueTo: #keyPressed ].
	Character arrowLeft command shift -> [ self diveOut ].
	Character arrowUp alt -> [ self stepScrollPageUp ].
	Character arrowDown alt -> [ self stepScrollPageDown ].
	Character pageUp -> [ self stepScrollPageUp ].
	Character pageDown -> [ self stepScrollPageDown ].
	Character cr asKeyCombination -> [ self actDueTo: #keyPressed ].
	$p command shift -> [ self exportAsPNGSilently ]}! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 11:49'!
breadcrumbBrick
	
	^ breadcrumbBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
breadcrumbBrick: aBrick

	breadcrumbBrick ifNotNil: [self removeBrick: breadcrumbBrick].
	breadcrumbBrick := aBrick.
	
	breadcrumbBrick announcer weak when: GTSpotterBreadcrumbVisibilityChanged send: #onBreadcrumbVisibilityChanged to: self.
	self themer spotterThemer breadcrumbStyleFor: breadcrumbBrick.
	breadcrumbBrick width: [ self paneBrick contentsBrick width ].
	breadcrumbBrick layout widthDependency: [ self paneBrick contentsBrick ].
	self addBrickBack: breadcrumbBrick! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 2/24/2015 10:29'!
closeSpotter

	self autoHide ifTrue: [ self delete ]! !

!GTSpotterMorph methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 19:57'!
defaultLabel
	^ 'Spotter'! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'StefanReichhart 3/22/2015 18:25'!
diveInCategoryDueTo: anEventType

	self spotterModelDo: [
		self spotterModel isEmpty
			ifFalse: [ self spotterModel currentStep isEmpty 
				ifFalse: [ self spotterModel currentStep diveInCategoryDueTo: anEventType ] ] ]! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'StefanReichhart 3/22/2015 18:25'!
diveInDueTo: anEventType

	self spotterModelDo: [
		self spotterModel isEmpty ifFalse: [ 
			self spotterModel currentStep isEmpty ifFalse: [ 
				self spotterModel currentStep diveInDueTo: anEventType ] ] ]! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'StefanReichhart 3/20/2015 09:10'!
diveOut
	self spotterModelDo: [ 
		self spotterModel popStep ]! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AndreiChis 3/20/2015 19:40'!
handleListenEvent: anEvent
		
	anEvent type = #mouseDown ifTrue: [ 
		((self fullBoundsInWorld containsPoint: anEvent position) not and: [ self autoHide ])
			ifTrue: [ self spotterModel ifNotNil: [ :aModel | aModel exitDueTo: #mouseDown ] ] ].
		
	anEvent type = #keyDown ifTrue: [ 
		self spotterModel
			ifNotNil: [ :s | s shiftPressed: (InputEventSensor default anyModifierKeyPressed not & InputEventSensor default shiftPressed) ] ].! !

!GTSpotterMorph methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/23/2014 19:58'!
handlesMouseDown: evt
	^ true! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
hidePreview
	
	self spotterModel hidePreview! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'AndreiChis 11/8/2015 20:34'!
initialize
	super initialize.
	"setting custom brick themer for the whole spotter"
	self themer: self themer spotterThemer themer.
	
	self initializeListeners.
	self themer spotterThemer spotterStyleFor: self.
	
	self breadcrumbBrick: self newBreadcrumbBrick.
	self paneBrick: self newPaneBrick.
	#GTSpotterEventCollector asClassIfPresent: [ 
		GTSpotter wasOpened ifFalse: [ self privacyAgreementNotificationBrick: self newPrivacyAgreementNotificationBrick ] ].
	
	
	! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'VincentBlondeau 7/16/2015 12:14'!
initializeListeners
	self activeHand addEventListener: self.
	Morph announcer weak when: MorphLostFocus send: #onLostFocus: to: self.
	self bindingDictionnary
		associationsDo: [ :anAssociation | self bindKeyCombination: anAssociation key toAction: anAssociation value ]! !

!GTSpotterMorph methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newBreadcrumbBrick

	^ GTSpotterStepsBreadcrumb new! !

!GTSpotterMorph methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 01:05'!
newPaneBrick

	^ GTSpotterPaneBrick new! !

!GTSpotterMorph methodsFor: 'instance creation' stamp: 'AndreiChis 3/16/2015 17:20'!
newPrivacyAgreementNotificationBrick

	^ GTSpotterPrivacyAgreementNotificationBrick new! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 2/3/2015 23:51'!
onBreadcrumbVisibilityChanged

	self changed.! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'NicolaiHess 6/18/2015 00:57'!
onHidePreview
	|delta|
	self paneBrick isPreviewShown ifFalse: [ ^ self ].
	delta := ((self width - ((self width / 100) * (100 - self themer spotterThemer previewWidthPercent)))@0) negated / 2.
	self bounds: (self bounds expandBy: delta rounded).
	self paneBrick hidePreview.
	self doLayout! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 10/23/2014 20:24'!
onLostFocus: event

	focusedMorph ifNil: [ focusedMorph := event morph ]! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'NicolaiHess 6/18/2015 00:57'!
onShowPreview

	|delta|
	self paneBrick isPreviewShown ifTrue: [ ^ self ].
	delta := (((self width * 100) / (100 - self themer spotterThemer previewWidthPercent) - self width)@0) / 2.
	self bounds: (self bounds expandBy: delta rounded).
	self paneBrick showPreview.
	self doLayout! !

!GTSpotterMorph methodsFor: 'opening' stamp: 'AliakseiSyrel 1/19/2015 20:48'!
openInWindowLabeled: aString inWorld: aWorld
	self autoHide: false.
	^ super openInWindowLabeled: aString inWorld: aWorld! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'StephanEggermont 12/8/2014 15:11'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	self unsubscribeListeners.
	
	self spotterModel ifNotNil: [:m | m terminateProcessors].
	
	"restoring previous focus"
	focusedMorph ifNotNil: [ focusedMorph takeKeyboardFocus ]! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 00:59'!
paneBrick

	^ paneBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
paneBrick: aBrick
	
	paneBrick ifNotNil: [self removeBrick: paneBrick].
	paneBrick := aBrick.
		
	self themer spotterThemer spotterPaneStyleFor: paneBrick.

	self addBrickBack: paneBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AndreiChis 3/16/2015 17:19'!
privacyAgreementNotificationBrick
	^ privacyAgreementNotificationBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/23/2015 01:18'!
privacyAgreementNotificationBrick: aBrick
	
	privacyAgreementNotificationBrick ifNotNil: [self removeBrick: privacyAgreementNotificationBrick].
	privacyAgreementNotificationBrick := aBrick.
	
	self themer spotterThemer privacyAgreementNotificationStyleFor: privacyAgreementNotificationBrick.
	privacyAgreementNotificationBrick layout widthDependency: self.
	privacyAgreementNotificationBrick width: [ self width - (self paneBrick isPreviewShown 
			ifFalse: [self themer spotterThemer previewArrowWidth - (2*self themer spotterThemer previewBorderWidth)] 
			ifTrue: [0])].
	
	self addBrickBack: privacyAgreementNotificationBrick! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:18'!
selectNextCandidateDueTo: anEventType

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectNextDueTo: anEventType ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/19/2014 22:00'!
selectNextCategory

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectNextCategory ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:21'!
selectPreviousCandidateDueTo: anEventType

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectPreviousDueTo: anEventType ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/19/2014 22:00'!
selectPreviousCategory

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectPreviousCategory ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
showPreview
	
	self spotterModel showPreview! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:20'!
spotterModel

	^ spotterModel! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
spotterModel: aSpotter

	spotterModel := aSpotter.
	
	spotterModel announcer weak when: GTSpotterExitAnnouncement send: #closeSpotter to: self.
	spotterModel announcer weak when: GTSpotterShowPreview send: #onShowPreview to: self.
	spotterModel announcer weak when: GTSpotterHidePreview send: #onHidePreview to: self.
	
	self breadcrumbBrick spotterModel: spotterModel.
	self paneBrick spotterModel: spotterModel.
	
	spotterModel class isPreviewVisible ifTrue: [ spotterModel showPreview ].
	
	"expanding drop down pane"
	self spotterModel setText: '' from: nil.
	self spotterModel currentStep process: nil.
	
	
	! !

!GTSpotterMorph methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 09:11'!
spotterModelDo: aBlock
	self spotterModel handleExceptionsDuring: aBlock! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/29/2015 16:08'!
stepScrollPageDown

	self spotterModel currentStep announcer announce: (GTSpotterScrollPageDown new)! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/29/2015 16:08'!
stepScrollPageUp

	self spotterModel currentStep announcer announce: (GTSpotterScrollPageUp new)! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
togglePreview

	self spotterModel togglePreview! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/11/2014 11:52'!
unsubscribeListeners

	self activeHand removeEventListener: self.
	Morph announcer unsubscribe: self.! !

GLMStackedScrollPaneBrick subclass: #GTSpotterResultsBrick
	instanceVariableNames: 'stepModel categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterResultsBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 2/8/2015 16:40'!
addCategory: aProcessor
	|titleBrick categoryBrick|
	
	titleBrick := self newTitleBrick on: self stepModel category: aProcessor.
	self themer spotterThemer categoryTitleStyleFor: titleBrick.
	self addBrickBack: titleBrick.
	
	categoryBrick := (self newCategoryBrick on: self stepModel category: aProcessor) titleBrick: titleBrick.
	self themer spotterThemer categoryStyleFor: categoryBrick .
	self addBrickBack: categoryBrick.
	
	self changed.
	
	^ categoryBrick! !

!GTSpotterResultsBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/25/2015 19:16'!
buildItemFor: aCandidateLink in: aProcessor
	|itemBrick|
	itemBrick := (aCandidateLink renderingProcessor render: aCandidateLink value)
			candidateLink: aCandidateLink;
			stepModel: self stepModel;
			yourself.
	^ itemBrick
	! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/9/2014 13:50'!
categories

	^ categories ifNil: [ categories := Dictionary new ]! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/29/2014 14:50'!
categoryMorphOf: aProcessor

	^ self categories at: aProcessor ifAbsentPut: [ self addCategory: aProcessor ]! !

!GTSpotterResultsBrick methodsFor: 'initialization' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
initialize
	super initialize.
	self band hSpaceFill.
	self announcer weak when: GLMBrickScrollPositionChanged send: #onScrolled to: self! !

!GTSpotterResultsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newCategoryBrick

	^ GTSpotterCategoryBrick new! !

!GTSpotterResultsBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/29/2014 14:17'!
newTitleBrick

	^ GTSpotterCategoryTitleBrick new! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/8/2015 16:48'!
onAllCandidatesAdded: ann
	|categoryMorph|
	ann candidateLinks isEmpty ifTrue: [ ^ self ].
	
	categoryMorph := self categoryMorphOf: ann category.
	categoryMorph
		addAllBricks: (ann candidateLinks collect: [ :each | self buildItemFor: each in: ann category ]).
	categoryMorph
		titleBrick setAmountVisible: (categoryMorph submorphs size) all: self waitingText.
	self changed.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/3/2015 23:52'!
onAllCandidatesRemoved
	
	self removeAllBricks.
	categories := nil.
	
	self band fullReleaseCachedState.
	self band releaseCachedState.
	self changed.
	! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/8/2015 16:49'!
onCandidateAdded: ann
	
	(self categoryMorphOf: ann category)
		addBrickBack: (self buildItemFor: ann candidateLink in: ann category);
		setAmountVisible: ((self categoryMorphOf: ann category) submorphs size) all: self waitingText.
	self changed.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'StefanReichhart 4/10/2015 19:20'!
onCandidateSelected: ann
	self flag: 'version from march 20 - solves the empty category problem on diveout, but may have other side-effects'.
	self scrollTo: ann candidateBrick
	"
	|titleBrick|
	titleBrick := (self categoryMorphOf: ann candidateBrick candidateLink processor) subbrickBefore.
	self scrollTo: ((ann candidateBrick candidateLink isFirst and: [ titleBrick isFirstInOwner ])
		ifTrue: [ titleBrick ]
		ifFalse: [ ann candidateBrick ])
	"! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 20:24'!
onCandidatesAmountChanged: ann
	|categoryMorph|
	
	ann amount < 1 ifTrue: [ ^ self changed ].
	
	categoryMorph := self categoryMorphOf: ann category.
	categoryMorph ifNil: [ ^ self ].
	
	categoryMorph titleBrick setAmountVisible: (categoryMorph submorphs size) all: ann amount.
	! !

!GTSpotterResultsBrick methodsFor: 'brick-structure-events' stamp: 'AliakseiSyrel 1/29/2015 01:29'!
onRemovedFrom: aBrick
	super onRemovedFrom: aBrick.
	
	self stepModel spotter announcer unsubscribe: self.
	self stepModel announcer unsubscribe: self.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 19:34'!
onScrolled

	self stepModel spotter announce: GTSpotterCandidateSelectedMoved new! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/25/2014 14:36'!
stepModel
	^ stepModel! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:31'!
stepModel: aModel
	stepModel := aModel.
	
	stepModel candidates announcer weak when: GTSpotterCandidateAdded send: #onCandidateAdded: to: self.
	stepModel candidates announcer weak when: GTSpotterAllCandidatesRemoved send: #onAllCandidatesRemoved to: self.
	stepModel candidates announcer weak when: GTSpotterAllCandidatesAdded send: #onAllCandidatesAdded: to: self.
	stepModel candidates announcer weak when: GTSpotterCandidatesAmountChanged send: #onCandidatesAmountChanged: to: self.
	stepModel announcer weak when: GTSpotterScrollPageDown send: #scrollPageDown to: self.
	stepModel announcer weak when: GTSpotterScrollPageUp send: #scrollPageUp to: self.
	stepModel spotter announcer weak when: GTSpotterCandidateSelected send: #onCandidateSelected: to: self.! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 00:35'!
waitingText

	^ '...'! !

!DoubleLink methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterDoubleLink
	
	^ GTSpotterCandidateLink value: self value! !

DoubleLink subclass: #GTSpotterCandidateLink
	instanceVariableNames: 'processorLink weight renderingProcessorLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterCandidateLink methodsFor: 'comparing' stamp: 'AliakseiSyrel 11/24/2014 18:11'!
< anotherCandidateLink

	^ self weight < anotherCandidateLink weight! !

!GTSpotterCandidateLink methodsFor: 'comparing' stamp: 'AliakseiSyrel 11/24/2014 18:10'!
> anotherCandidateLink

	^ self weight > anotherCandidateLink weight! !

!GTSpotterCandidateLink methodsFor: 'converting' stamp: 'AliakseiSyrel 11/24/2014 18:48'!
asSpotterCandidateLink

	^ self! !

!GTSpotterCandidateLink methodsFor: 'copying' stamp: 'AliakseiSyrel 12/20/2014 19:04'!
copy
	|link|
	link := self class value: self value.
	link privateProcessorLink: processorLink.
	link privateRenderingProcessorLink: renderingProcessorLink.
	link weight: weight.
	^ link! !

!GTSpotterCandidateLink methodsFor: 'printing' stamp: 'TudorGirba 4/10/2015 13:17'!
gtDisplayOn: stream
	stream nextPutAll: 'Candidate link: '.
	self value gtDisplayOn: stream ! !

!GTSpotterCandidateLink methodsFor: 'testing' stamp: 'AliakseiSyrel 3/21/2015 14:39'!
isFirst

	^ (self previousLink processorLink = self processorLink) not! !

!GTSpotterCandidateLink methodsFor: 'private' stamp: 'AliakseiSyrel 12/20/2014 18:49'!
privateProcessorLink: aLink

	processorLink := aLink! !

!GTSpotterCandidateLink methodsFor: 'private' stamp: 'AliakseiSyrel 12/20/2014 18:49'!
privateRenderingProcessorLink: aLink

	renderingProcessorLink := aLink! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/11/2014 00:10'!
processor

	^ self processorLink value! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:32'!
processorLink
	^ processorLink! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:29'!
processorLink: anObject

	"we set rendering processor only if one is not set. it allows to have a collection of items,
	that have different rendering processors"
	
	processorLink ifNil: [ self renderingProcessor: anObject ].
	processorLink := anObject.
	! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:36'!
renderingProcessor

	renderingProcessorLink ifNil: [ self renderingProcessor: processorLink ].
	^ renderingProcessorLink value! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:40'!
renderingProcessor: aProcessorLink

	renderingProcessorLink ifNil: [ renderingProcessorLink := aProcessorLink processor asSpotterProcessorLink ].
	processorLink ifNil: [ processorLink := aProcessorLink ]! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:10'!
weight

	^ weight! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:11'!
weight: anObject 

	weight := anObject! !

DoubleLink subclass: #GTSpotterProcessorLink
	instanceVariableNames: 'headLink tailLink size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterProcessorLink class methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:41'!
from: aDoubleLink

	! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:48'!
asSpotterProcessorLink

	^ self! !

!GTSpotterProcessorLink methodsFor: 'actions' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
clear

	self
		headLink: nil;
		tailLink: nil.
		
	size := 0.! !

!GTSpotterProcessorLink methodsFor: 'printing' stamp: 'TudorGirba 4/10/2015 11:12'!
gtDisplayOn: stream
	stream 
		nextPutAll: 'Processor link: ';
		nextPutAll: self processor title asString! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
headLink
	^ headLink! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
headLink: anObject
	headLink := anObject! !

!GTSpotterProcessorLink methodsFor: 'actions' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
incrementSize

	size := self size + 1! !

!GTSpotterProcessorLink methodsFor: 'testing' stamp: 'AliakseiSyrel 11/24/2014 20:29'!
isEmpty

	^ self headLink isNil! !

!GTSpotterProcessorLink methodsFor: 'testing' stamp: 'StefanReichhart 3/22/2015 22:00'!
isFull

	^ self size = self processor itemsLimit! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:40'!
processor

	^ self value! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
size

	^ size ifNil: [ size := 0 ]! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
tailLink
	^ tailLink! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
tailLink: anObject
	tailLink := anObject! !

Announcement subclass: #GTSpotterActOn
	instanceVariableNames: 'element eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterActOn methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:58'!
element
	^ element! !

!GTSpotterActOn methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:58'!
element: anObject
	element := anObject! !

!GTSpotterActOn methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:34'!
eventType
	^ eventType! !

!GTSpotterActOn methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:34'!
eventType: anObject
	eventType := anObject! !

Announcement subclass: #GTSpotterAllCandidatesRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterAnnouncement
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

GTSpotterAnnouncement subclass: #GTSpotterAllCandidatesAdded
	instanceVariableNames: 'candidateLinks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
candidateLinks
	^ candidateLinks! !

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
candidateLinks: anObject
	candidateLinks := anObject! !

!GTSpotterAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 6/4/2015 19:48'!
category
	"Return the category (ie the kind of group of elements). This has nothing to do with class category."
	^ category! !

!GTSpotterAnnouncement methodsFor: 'accessing' stamp: 'StephaneDucasse 6/4/2015 19:48'!
category: anObject
	"Set the category (ie the kind of group of elements). This has nothing to do with class category."
	category := anObject! !

GTSpotterAnnouncement subclass: #GTSpotterCandidateAdded
	instanceVariableNames: 'candidateLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:12'!
candidate
	^ candidateLink value! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 13:13'!
candidateLink

	^ candidateLink! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:10'!
candidateLink: anObject
	candidateLink := anObject! !

GTSpotterAnnouncement subclass: #GTSpotterCandidatesAmountChanged
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:04'!
amount
	^ amount! !

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:04'!
amount: anObject
	amount := anObject! !

GTSpotterAnnouncement subclass: #GTSpotterCategorySelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

GTSpotterAnnouncement subclass: #GTSpotterDiveInCategory
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterDiveInCategory methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:30'!
eventType
	^ eventType! !

!GTSpotterDiveInCategory methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:30'!
eventType: anObject
	eventType := anObject! !

Announcement subclass: #GTSpotterBreadcrumbVisibilityChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterCandidateSelected
	instanceVariableNames: 'candidateBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 15:35'!
candidateBrick
	^ candidateBrick! !

!GTSpotterCandidateSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 15:35'!
candidateBrick: anObject
	candidateBrick := anObject! !

Announcement subclass: #GTSpotterCandidateSelectedMoved
	instanceVariableNames: 'candidateBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateSelectedMoved methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:31'!
candidateBrick
	^ candidateBrick! !

!GTSpotterCandidateSelectedMoved methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:31'!
candidateBrick: anObject
	candidateBrick := anObject! !

Announcement subclass: #GTSpotterContextChanged
	instanceVariableNames: 'previous current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterContextChanged methodsFor: 'compatibility' stamp: 'StefanReichhart 2/28/2015 13:46'!
context
	^ self current! !

!GTSpotterContextChanged methodsFor: 'compatibility' stamp: 'StefanReichhart 2/28/2015 13:55'!
context: aSpotterContext
	self current: aSpotterContext! !

!GTSpotterContextChanged methodsFor: 'accessing' stamp: 'StefanReichhart 2/28/2015 13:42'!
current
	^ current! !

!GTSpotterContextChanged methodsFor: 'accessing' stamp: 'StefanReichhart 2/28/2015 13:42'!
current: anObject
	current := anObject! !

!GTSpotterContextChanged methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 2/28/2015 18:41'!
currentText
	^ self current ifNil: [''] ifNotNil: [ self current text ]! !

!GTSpotterContextChanged methodsFor: 'accessing' stamp: 'StefanReichhart 2/28/2015 13:42'!
previous
	^ previous! !

!GTSpotterContextChanged methodsFor: 'accessing' stamp: 'StefanReichhart 2/28/2015 13:42'!
previous: anObject
	previous := anObject! !

!GTSpotterContextChanged methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 2/28/2015 18:41'!
previousText
	^ self previous ifNil: ['']  ifNotNil: [ self previous text ]! !

!GTSpotterContextChanged methodsFor: 'compatibility' stamp: 'StefanReichhart 2/28/2015 13:47'!
text
	^ self currentText! !

Announcement subclass: #GTSpotterCurrentStepChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterDiveInElement
	instanceVariableNames: 'element eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterDiveInElement methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:40'!
element
	^ element! !

!GTSpotterDiveInElement methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:40'!
element: anObject
	element := anObject! !

!GTSpotterDiveInElement methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:43'!
eventType
	^ eventType! !

!GTSpotterDiveInElement methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 18:43'!
eventType: anObject
	eventType := anObject! !

Announcement subclass: #GTSpotterDiveOut
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterDiveOut methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:57'!
element
	^ element! !

!GTSpotterDiveOut methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:57'!
element: anObject
	element := anObject! !

Announcement subclass: #GTSpotterExitAnnouncement
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterExitAnnouncement methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 19:36'!
eventType
	^ eventType! !

!GTSpotterExitAnnouncement methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 19:36'!
eventType: anObject
	eventType := anObject! !

Announcement subclass: #GTSpotterHideHints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterHidePreview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterRevealHints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterScrollPageDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterScrollPageUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterSearchFinished
	instanceVariableNames: 'processors query'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterSearchFinished methodsFor: 'accessing' stamp: 'JurajKubelka 3/6/2015 16:36'!
processors
	^ processors! !

!GTSpotterSearchFinished methodsFor: 'accessing' stamp: 'JurajKubelka 3/6/2015 16:36'!
processors: anObject
	processors := anObject! !

!GTSpotterSearchFinished methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/27/2015 23:19'!
query
	^ query! !

!GTSpotterSearchFinished methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/27/2015 23:19'!
query: anObject
	query := anObject! !

Announcement subclass: #GTSpotterSelectedCandidateChanged
	instanceVariableNames: 'eventType selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 19:09'!
eventType
	^ eventType! !

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AndreiChis 3/20/2015 19:09'!
eventType: anObject
	eventType := anObject! !

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:20'!
selected
	^ selected! !

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:20'!
selected: anObject
	selected := anObject! !

Announcement subclass: #GTSpotterShowPreview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterStepAdded
	instanceVariableNames: 'stepModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterStepAdded methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 13:38'!
stepModel
	^ stepModel! !

!GTSpotterStepAdded methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 13:38'!
stepModel: anObject
	stepModel := anObject! !

Announcement subclass: #GTSpotterStepPopped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

GLMPagerBrick subclass: #GTSpotterDropDownMorph
	instanceVariableNames: 'spotterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterDropDownMorph methodsFor: 'building' stamp: 'AliakseiSyrel 1/30/2015 16:29'!
buildPane: aStepModel
	|pane|
	
	pane := GTSpotterResultsBrick new stepModel: aStepModel.
	self brickThemer spotterThemer resultsPaneStyleFor: pane.
	^ pane! !

!GTSpotterDropDownMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/15/2014 15:50'!
initialize
	super initialize.
	
	self showScrollBarWhenNeeded: false! !

!GTSpotterDropDownMorph methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/10/2014 13:44'!
onStepAdded: ann
	"as soon as step added we need to push it"

	self pushPane: (self buildPane: ann stepModel)! !

!GTSpotterDropDownMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 13:29'!
spotterModel
	^ spotterModel! !

!GTSpotterDropDownMorph methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
spotterModel: aModel 
	spotterModel := aModel.
	
	spotterModel steps do: [ :each | self pushPane: (self buildPane: each) ].
	
	spotterModel announcer when: GTSpotterStepAdded send: #onStepAdded: to: self.! !

GLMVerticalLinearLayout subclass: #GTSpotterStackedLayout
	instanceVariableNames: 'allowedBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterStackedLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/19/2015 10:48'!
allowedBounds
	^ allowedBounds! !

!GTSpotterStackedLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/19/2015 10:48'!
allowedBounds: anObject
	allowedBounds := anObject! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 10:48'!
cutAllowedBoundsBottom: aBrick

	self allowedBounds: (self shrinkBottom: self allowedBounds with: aBrick )! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:15'!
cutAllowedBoundsTop: aBrick

	self allowedBounds: (self shrinkTop: self allowedBounds with: aBrick )! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:15'!
decreaseZindex: aBrick

	aBrick layoutProperties zIndex: 1.! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
deltaBottom: aBrick

	^ aBrick globalOuterBounds corner y -  self allowedBounds corner y! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
deltaTop: aBrick

	^ self allowedBounds origin y - aBrick globalOuterBounds origin y! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
gatherStacked: aBrick
	|list|
	
	list := DoubleLinkedList new.
	aBrick subbricks do: [ :each | each layoutProperties floating = #stack ifTrue: [ list add: each ] ].
	^ list! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
increaseZindex: aBrick

	aBrick layoutProperties zIndex: 2.! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
isAbove: aBrick

	^ aBrick globalOuterBounds origin <= self allowedBounds origin! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
isAbove: aBrick in: aRectangle

	^ aBrick globalOuterBounds origin <= aRectangle origin! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:17'!
isFullyVisible: aBrick
	
	^ self allowedBounds containsRect: aBrick globalOuterBounds! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:18'!
isFullyVisible: aBrick in: aRectangle
	
	^ aRectangle containsRect: aBrick globalOuterBounds! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:18'!
isPartiallyVisibleAbove: aBrick

	^ (self isFullyVisible: aBrick) not & (self isAbove: aBrick)! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:16'!
isVisible: aBrick
	
	^ self allowedBounds containsRect: aBrick globalOuterBounds! !

!GTSpotterStackedLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 2/19/2015 11:18'!
isVisible: aBrick in: aRectangle
	
	^ aRectangle intersects: aBrick globalOuterBounds! !

!GTSpotterStackedLayout methodsFor: 'layout' stamp: 'AliakseiSyrel 2/24/2015 11:56'!
layout: aBrick in: newBounds
	
	^ super layout: aBrick in: newBounds.
	"^ self layoutStacked: aBrick in: newBounds"! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:17'!
layoutAllowedBottom: aBrick

	self
		translate: aBrick by: (self deltaBottom: aBrick) negated;
		increaseZindex: aBrick;
		cutAllowedBoundsBottom: aBrick! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:17'!
layoutAllowedTop: aBrick

	self
		translate: aBrick by: (self deltaTop: aBrick);
		increaseZindex: aBrick;
		cutAllowedBoundsTop: aBrick! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/23/2015 14:21'!
layoutProportional: aCollection in: aBrick position: aSymbol
	| fullWidth eachWidth index |
	aCollection isEmpty ifTrue: [ ^ self ].
	
	fullWidth := aBrick innerBounds width.
	index := 0.
	aCollection inject: aBrick paddingLeft into: [ :leftOffset :each |
		|layoutBounds|
		
		self sendEvent: (GLMBrickLayoutStacked new index: (index + 1); position: aSymbol; yourself) to: each.
		
		eachWidth := ((fullWidth - leftOffset) / (aCollection size - index)) ceiling.
		
		layoutBounds := each wrappedBounds.
		index = 0
			ifTrue: [ layoutBounds width: (((each layout maxWidth brickValue: each) max: eachWidth) min: (fullWidth - leftOffset)) ]
			ifFalse: [				
				(index = (aCollection size - 1))
					ifFalse: [ layoutBounds width: (eachWidth min: (each layout maxWidth brickValue: each)) ]
					ifTrue: [ layoutBounds width: eachWidth ] ].
		
		layoutBounds translateBy: (leftOffset@0).
		each brickBounds: layoutBounds.
		index := index + 1.
		leftOffset + layoutBounds outerBounds width ]! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/23/2015 14:21'!
layoutStacked: aBrick in: newBounds
	| origStackedBricks stackedBricks forward stackedTopBricks stackedBottomBricks stackedTopHeight stackedBottomHeight|
	self flag: 'refactor me'.
	self allowedBounds: newBounds.
	stackedBricks := self gatherStacked: aBrick.
	origStackedBricks := DoubleLinkedList new.
	origStackedBricks addAll: stackedBricks.
	forward := true.
	
	stackedTopHeight := 0.
	stackedBottomHeight := 0.
	stackedTopBricks := OrderedCollection new.
	stackedBottomBricks := OrderedCollection new.
	
	"going from top to bottom"
	[ stackedBricks isEmpty not & forward] whileTrue: [ |brick|
		brick := stackedBricks removeFirst value.
		(self isVisible: brick) ifFalse: [
			(self isAbove: brick) ifTrue: [ |delta|
				delta := (self deltaTop: brick) - stackedTopHeight.
				brick translateX: delta negated.
				self increaseZindex: brick.
				stackedTopBricks isEmpty ifTrue: [
					stackedTopHeight := stackedTopHeight + brick globalOuterBounds height.
					self cutAllowedBoundsTop: brick ].
				stackedTopBricks add: brick.
			] ifFalse: [ forward := false. stackedBricks addFirst: brick ]
		] ifTrue: [
			(self isPartiallyVisibleAbove: brick)
				ifTrue: [ self layoutAllowedTop: brick ]
				ifFalse: [ forward := false. self decreaseZindex: brick.	stackedBricks addFirst: brick ] ] ].

	"going from bottom to top"
	[ stackedBricks isEmpty not ] whileTrue: [ |brick|
		brick := stackedBricks removeLast value.
		(self isVisible: brick) ifFalse: [ |delta|
			delta := (self deltaBottom: brick) - stackedBottomHeight.
			brick translateX: delta negated.
			self increaseZindex: brick.
			stackedBottomBricks isEmpty ifTrue: [
				stackedBottomHeight := stackedBottomHeight + brick globalOuterBounds height.
				self cutAllowedBoundsBottom: brick ].
			stackedBottomBricks add: brick.
		] ifTrue: [
			(self isFullyVisible: brick )
				ifFalse: [ self layoutAllowedBottom: brick ]
				ifTrue: [ self decreaseZindex: brick ] ] ].

	self layoutProportional: stackedTopBricks reverse in: aBrick position: #top.
	self layoutProportional: stackedBottomBricks reverse in: aBrick position: #bottom.
	
	"origStackedBricks do: [ :each | each doLayout ]."
	
	^ allowedBounds! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:17'!
shrinkBottom: aRectangle with: aBrick

	^ aRectangle bottom: (aRectangle bottom - aBrick globalOuterBounds height)! !

!GTSpotterStackedLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/19/2015 11:17'!
shrinkTop: aRectangle with: aBrick

	^ aRectangle top: (aRectangle top + aBrick globalOuterBounds height)! !

GLMBrickThemerModule subclass: #GTSpotterWidgetThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterWidgetThemer commentStamp: 'TudorGirba 11/26/2014 15:15' prior: 0!
This is a themer for all spotter morphs.

To customize it, it has to be subclassed and pointed to from:
ACustomTheme>>spotterWidgetThemer!

GTSpotterWidgetThemer subclass: #GTSpotterWidgetDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 3/21/2015 21:37'!
backgroundColor
	"used as background color for all panes"
	^ Color r: 0.25 g: 0.25 b: 0.25! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 12:59'!
borderColor
	"color that is used for border and dividers of UI parts of Spotter
	for example divider between header and results or between preview and list"
	^ self backgroundColor darker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:20'!
itemActionSelectedBackgroundColor

	^ self itemSelectedBackgroundColor slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:06'!
itemIconAlphaValue

	^ 0.5! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:09'!
itemSelectedBackgroundColor

	^ self backgroundColor slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:13'!
searchFieldTextColor
	
	^ Color white slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:08'!
titleTextColor

	^ self backgroundColor muchLighter! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/24/2014 23:18'!
backgroundColor
	"used as background color for all panes"
	^ Color white! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 12/1/2014 14:25'!
borderColor
	"color that is used for border and dividers of UI parts of Spotter
	for example divider between header and results or between preview and list"
	^ Color r: 180 g: 180 b: 180 range: 255! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 15:39'!
breadcrumbHeight

	^ 26! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 14:07'!
breadcrumbItemBackgroundColor

	^ self borderColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:17'!
breadcrumbItemLabelStyleFor: aBrick

	aBrick
		textPosition: #center;
		padding: { 0 . self outerBorderWidth };
		vSpaceFill;
		hSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:16'!
breadcrumbItemLabelWidgetStyleFor: aBrick

	aBrick
		color: self breadcrumbItemBackgroundColor;
		textColor: self breadcrumbItemTextColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/5/2015 12:32'!
breadcrumbItemStyleFor: aBrick

	aBrick vSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 14:07'!
breadcrumbItemTextColor

	^ Color white! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:18'!
breadcrumbItemTriangleStyleFor: aBrick

	aBrick
		height: self breadcrumbTriangleHeight;
		hSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:54'!
breadcrumbItemTriangleWidgetStyleFor: aBrick

	aBrick
		renderer: (GTSpotterTriangleRenderer new orientation: #bottom).
		
	aBrick owner isTriangleVisible
		ifTrue:[ aBrick color: self breadcrumbItemBackgroundColor ]
		ifFalse: [ aBrick color: Color transparent ]! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 01:02'!
breadcrumbSeparatorColor

	^ self breadcrumbItemBackgroundColor muchLighter slightlyDarker! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 00:49'!
breadcrumbSeparatorLineWidth

	^ 2! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:20'!
breadcrumbSeparatorStyleFor: aBrick

	aBrick
		borderWidth: self breadcrumbSeparatorLineWidth;
		width: self breadcrumbSeparatorWidth;
		height: self breadcrumbHeight + self outerBorderWidth.! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:28'!
breadcrumbSeparatorWidgetStyleFor: aBrick

	aBrick
		color: self breadcrumbItemBackgroundColor;
		borderColor: self breadcrumbSeparatorColor;
		renderer: GTSpotterBreadcrumbSeparatorRenderer new! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 00:52'!
breadcrumbSeparatorWidth

	^ (self breadcrumbHeight + self outerBorderWidth) / 2 + 4 "we need slightly more because of drawing accuracy"! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/10/2015 13:28'!
breadcrumbStyleFor: aBrick
	
	aBrick
		margin: { 0 . 0 };
		marginBottom: self breadcrumbTriangleHeight negated;
		height: self breadcrumbHeight + self breadcrumbTriangleHeight.
		
	aBrick layout
		zIndex: 2.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 15:33'!
breadcrumbTriangleHeight

	^ 16! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 18:12'!
buttonPressedColor

	^ self backgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:32'!
categoryAmountStyleFor: aBrick

	aBrick
		textPosition: #leftCenter.
	
	aBrick label
		familyName: self titleFamilyName.
	
	aBrick
		vSpaceFill;
		width: #approximateWidth;
		marginLeft: self categoryNameMarginRight.! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:32'!
categoryAmountWidgetStyleFor: aBrick

	aBrick
		textColor: self titleTextColor;
		color: self titleBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 12/1/2014 12:02'!
categoryMarginBottom

	^ (self itemHeight * (2/3)) ceiling "pixels"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/27/2014 14:40'!
categoryNameMarginLeft

	^ self itemIconMaxWidth! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/18/2014 23:51'!
categoryNameMarginRight

	^ 10! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/10/2015 14:12'!
categoryStyleFor: aBrick

	aBrick
		marginBottom: self categoryMarginBottom;
		hSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 3/21/2015 23:16'!
categoryTitleBackgroundColor

	^ self backgroundColor alpha: 0.95! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:34'!
categoryTitleNameStyleFor: aBrick

	aBrick
		vSpaceFill;
		textPosition: #leftCenter;
		width: [ :name | (aBrick owner innerBounds width) min: ((name label textSize x) + name label hMargin) ].
	
	aBrick label
		familyName: self titleFamilyName.
	! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:34'!
categoryTitleNameWidgetStyleFor: aBrick

	aBrick
		textColor: self titleTextColor;
		color: self titleBackgroundColor
	! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:15'!
categoryTitleStyleFor: aBrick

	aBrick
		useHorizontalLinearLayout;
		height: 30;
		hSpaceFill;
		paddingLeft: self categoryNameMarginLeft
	
	"aBrick layout
		floating: #stack;
		maxWidth: [ :title |
			aBrick hPadding + 
			(title nameBrick label textSize x )+ title amountBrick label textSize x +
			title nameBrick hPadding + title nameBrick hMargin + 
			title nameBrick label hPadding + title nameBrick label hMargin + 
			title amountBrick hMargin ]"! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:08'!
categoryTitleWidgetStyleFor: aBrick

	aBrick
		normalColor: self categoryTitleBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/23/2015 17:55'!
closeButtonStyleFor: aBrick

	aBrick
		vSpaceFill;
		width: [ :m | m height ];
		margin: 10;
		marginLeft: 0! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:35'!
closeButtonWidgetStyleFor: aBrick

	aBrick
		normalImage: GLMUIThemeExtraIcons glamorousClose;
		pressedColor: self buttonPressedColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 21:29'!
dropDownPaneStyleFor: aBrick

	aBrick
		layoutProperties: GLMBrickLayoutProperties new;
		marginTop: self innerBorderWidth;
		vSpaceFill;
		hSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/24/2014 14:55'!
headerHeight
	"height of the header where user enters search request"
	^ 56! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:12'!
headerStyleFor: aBrick

	aBrick
		hSpaceFill;
		height: self headerHeight! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:12'!
headerWidgetStyleFor: aBrick

	aBrick
		color: self backgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'TudorGirba 1/20/2016 17:57'!
helpButtonStyleFor: aBrick

	aBrick
		vSpaceFill;
		width: [ :m | m height ];
		margin: 10;
		marginLeft: 0! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'TudorGirba 1/20/2016 17:57'!
helpButtonWidgetStyleFor: aBrick

	aBrick
		normalImage: GLMUIThemeExtraIcons glamorousHelp;
		pressedColor: self buttonPressedColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/3/2015 11:22'!
hintHideArrowStyleFor: aBrick

	aBrick ifNil: [ ^ self ].
	(aBrick valueOfProperty: #brickSpotterIsReveal ifAbsent: [ false ])
		ifFalse: [ ^ self ].
	aBrick setProperty: #brickSpotterIsReveal toValue: false.
	
	(aBrick hasProperty: #brickSpotterBackupColor)
		ifTrue: [ aBrick color: (aBrick valueOfProperty: #brickSpotterBackupColor) ].
		
	aBrick changed! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/28/2015 00:45'!
hintHideStyleFor: aBrick

	aBrick ifNil: [ ^ self ].
	(aBrick valueOfProperty: #brickSpotterIsReveal ifAbsent: [ false ])
		ifFalse: [ ^ self ].
	aBrick setProperty: #brickSpotterIsReveal toValue: false.
	
	(aBrick hasProperty: #brickSpotterBackupColor)
		ifTrue: [ aBrick color: (aBrick valueOfProperty: #brickSpotterBackupColor) ].
		
	(aBrick hasProperty: #brickSpotterBackupBorder)
		ifTrue: [ aBrick border: (aBrick valueOfProperty: #brickSpotterBackupBorder) ].
		
	aBrick changed! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'TudorGirba 3/30/2015 22:27'!
hintRevealArrowStyleFor: aBrick
	
	SmalltalkImage current vm canHandleShiftPressed
		ifTrue: [ ^ self ].
	
	aBrick ifNil: [ ^ self ].
	(aBrick valueOfProperty: #brickSpotterIsReveal ifAbsent: [ false ])
		ifTrue: [ ^ self ].
	
	aBrick setProperty: #brickSpotterBackupColor toValue: aBrick color.
	aBrick setProperty: #brickSpotterIsReveal toValue: true.
	
	aBrick color: self themer popupHelpThemer backgroundColor.
	
	aBrick changed! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'TudorGirba 3/30/2015 22:27'!
hintRevealStyleFor: aBrick
	
	SmalltalkImage current vm canHandleShiftPressed
		ifTrue: [ ^ self ].
	
	aBrick ifNil: [ ^ self ].
	(aBrick valueOfProperty: #brickSpotterIsReveal ifAbsent: [ false ])
		ifTrue: [ ^ self ].
	
	aBrick setProperty: #brickSpotterBackupColor toValue: aBrick color.
	aBrick setProperty: #brickSpotterBackupBorder toValue: aBrick border.
	aBrick setProperty: #brickSpotterIsReveal toValue: true.
	
	aBrick color: self themer popupHelpThemer backgroundColor.
	aBrick border: GLMBrickBorder new.
	aBrick borderColor: (self themer popupHelpThemer borderColor alpha: 0.6).
	aBrick borderWidth: self themer popupHelpThemer borderWidth.
	
	aBrick changed! !

!GTSpotterWidgetThemer methodsFor: 'icons' stamp: 'TudorGirba 2/20/2015 08:35'!
iconAct

	^ Smalltalk ui icons glamorousAccept! !

!GTSpotterWidgetThemer methodsFor: 'icons' stamp: 'TudorGirba 2/20/2015 08:35'!
iconDiveIn

	^ Smalltalk ui icons glamorousDiveRightIcon! !

!GTSpotterWidgetThemer methodsFor: 'icons' stamp: 'TudorGirba 2/20/2015 08:35'!
iconDiveInCategory

	^ Smalltalk ui icons glamorousDiveAllRightIcon! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 18:03'!
innerBorderWidth
	"width of the border that separates panes in the spotter"
	^ 1! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:14'!
itemActionButtonStyleFor: aBrick

	aBrick
		width: [ (self itemHeight / 1.1) floor ];
		vSpaceFill;
		margin: #(0 1);
		padding: { 0 . self outerBorderWidth }! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:13'!
itemActionButtonWidgetStyleFor: aBrick

	aBrick
		pressedColor: self itemActionSelectedBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:20'!
itemActionSelectedBackgroundColor

	^ self itemSelectedBackgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/3/2015 11:29'!
itemActionbarStyleFor: aBrick

	aBrick
		useHorizontalLinearLayout;
		hShrinkWrap;
		vSpaceFill;
		marginRight: self outerBorderWidth + 2;
		visible: false! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 3/17/2015 21:35'!
itemHeight

	^  16 + Smalltalk ui theme labelFont height! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 12/1/2014 09:44'!
itemHoveredBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:44'!
itemIconAlphaValue

	^ 0.8! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:20'!
itemIconMaxWidth

	^ 50! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/16/2015 14:36'!
itemIconStyleFor: aBrick
	"icon form must already be set before styling"

	self flag: 'figure out why alpha doesn''t work'.
	aBrick
		"making icon a bit transparent"
		"normalImage: (aBrick normalImage asAlphaImageMorph alpha: self itemIconAlphaValue) imageForm;"
		width: self itemIconMaxWidth;
		vSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 21:01'!
itemLabelStyleFor: aBrick

	aBrick label
		highlightingLogic: [ :aCanvas :aRectangle | |bounds|
			"because font calculates text width wrong"
			bounds := aRectangle translateBy: (-3@0).
			aCanvas line: bounds bottomLeft to: bounds bottomRight width: 1 color: Color lightGray ].
	
	aBrick
		hSpaceFill;
		vSpaceFill;
		marginRight: self outerBorderWidth.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:27'!
itemNormalBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:14'!
itemNormalStyleFor: aBrick

	aBrick
		height: [ self itemHeight ];
		hSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:05'!
itemNormalWidgetStyleFor: aBrick

	aBrick
		normalColor: self itemNormalBackgroundColor;
		selectedColor: self itemHoveredBackgroundColor;
		checkedColor: self itemSelectedBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/19/2014 00:16'!
itemSelectedBackgroundColor

	^ self backgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 20:18'!
outerBorderWidth
	"the width of the border around the whole spotter"
	^ 4! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 23:02'!
previewArrowColor

	^ self itemSelectedBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 3/17/2015 23:20'!
previewArrowGapHack

	^ self themer scrollbarOffset + self themer scrollbarWidth + self outerBorderWidth + 2"pager bug"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 23:30'!
previewArrowWidth

	^ (self itemHeight / 2) + self previewArrowGapHack! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 20:18'!
previewBorderWidth

	^ self outerBorderWidth! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/27/2015 09:41'!
previewPaddingLeft

	^ self previewArrowWidth * 1.2! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 2/22/2015 19:47'!
previewPaddingRight

	^ self previewPaddingLeft

! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 17:48'!
previewWidthPercent

	^ 40! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 3/16/2015 15:24'!
privacyAgreementIsNotSendingDataColor

	^ Color paleRed! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 3/16/2015 15:23'!
privacyAgreementIsSendingDataColor

	^ Color paleGreen! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/26/2015 17:45'!
privacyAgreementNotificationStyleFor: aBrick

	| color |
	color := aBrick sendUsageData 
		ifTrue: [ self privacyAgreementIsSendingDataColor. ]
		ifFalse: [ self privacyAgreementIsNotSendingDataColor. ].
	aBrick messageBrick rubricTextFamilyName: StandardFonts defaultFont familyName.
	aBrick messageBrick rubricTextColor: Color black.
	aBrick
		color: color;
		borderColor: color darker;
		borderWidth: self outerBorderWidth;
		marginTop: 0! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 21:28'!
resultsPaneStyleFor: aBrick

	aBrick
		hSpaceFill: self resultsPaneWidth;
		vSpaceFill;
		with: [ :b | b band layout: GTSpotterStackedLayout new ]! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/25/2014 10:43'!
resultsPaneWidth
	"width in Percents of the results pane"
	^ 100"%"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 11/19/2014 08:40'!
searchFieldFamilyName

	^ 'Source Sans Pro'! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:50'!
searchFieldFontSize

	^ 15! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/25/2014 10:45'!
searchFieldMarginLeft

	^ 20! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/26/2015 16:26'!
searchFieldStyleFor: aBrick
	
	aBrick
		beCentered;
		hSpaceFill;
		vSpaceFill;
		withoutMargins;
		withoutAdornment;
		withoutBorder;
		beTransparent;
		withGhostText: self spotterGhostText;
		autoAccept: true;
		marginLeft: self searchFieldMarginLeft;
		rubricTextFamilyName: self searchFieldFamilyName;
		rubricTextFontSize: self searchFieldFontSize.
	
	aBrick rubric ghostTextRuler
		fontName: self searchFieldFamilyName pointSize: self searchFieldFontSize.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:13'!
searchFieldTextColor
	
	^ Color black! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:40'!
searchFieldWidgetStyleFor: aBrick
	
	aBrick morph
		color: Color transparent;
		textColor: self searchFieldTextColor;
		borderColor: Color transparent.
		
	aBrick morph textArea
		backgroundColor: Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:43'!
settingsButtonStyleFor: aBrick

	aBrick
		vSpaceFill;
		width: [ :m | m height ];
		margin: #(10 0);
		marginRight: 2! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:42'!
settingsButtonWidgetStyleFor: aBrick

	aBrick
		normalImage: Smalltalk ui icons glamorousPreferences;
		pressedColor: self buttonPressedColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 2/27/2015 21:15'!
settingsLabelPadding

	^ 4! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 2/27/2015 21:13'!
settingsLabelSelectedTextColor

	^ Color black! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 2/27/2015 21:13'!
settingsLabelTextColor

	^ Color white! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:44'!
spotterContentsStyleFor: aBrick
	
	aBrick
		useVerticalLinearLayout;
		borderWidth: self outerBorderWidth;
		padding: self outerBorderWidth;
		hSpaceFill;
		vSpaceFill.
	
	aBrick layout
		zIndex: 2
	! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:44'!
spotterContentsWidgetStyleFor: aBrick
	
	aBrick
		borderColor: self borderColor;
		color: self borderColor
	! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 3/2/2015 15:56'!
spotterGhostText

	^ 'Search'! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/8/2015 17:41'!
spotterPaneStyleFor: aBrick
	
	aBrick
		useHorizontalLinearLayout;
		hSpaceFill;
		vSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/10/2015 14:14'!
spotterPreviewArrowContainerStyleFor: aBrick

	aBrick
		useVerticalLinearLayout;
		vSpaceFill;
		width: self previewArrowWidth;
		margin: {
			self headerHeight + self innerBorderWidth + self previewBorderWidth.
			0.
			self previewBorderWidth.
			self previewArrowGapHack negated }.
		
	aBrick layout
		zIndex: 4.! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/4/2015 19:33'!
spotterPreviewArrowStyleFor: aBrick

	aBrick
		hSpaceFill;
		renderer: (GTSpotterTriangleRenderer new orientation: #right);
		height: [ (self previewArrowWidth - self previewArrowGapHack ) * 2 ]! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 23:00'!
spotterPreviewArrowWidgetStyleFor: aBrick

	aBrick owner isTriangleVisible
		ifTrue: [ aBrick color: self previewArrowColor ]
		ifFalse: [ aBrick color: Color transparent ]! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'TudorGirba 2/26/2015 07:25'!
spotterPreviewCompositeStyleFor: aBrick

	aBrick
		hSpaceFill;
		vSpaceFill;
		margin: self previewBorderWidth;
		paddingLeft: self previewPaddingLeft! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 3/21/2015 22:46'!
spotterPreviewStyleFor: aBrick
	
	aBrick
		borderWidth: self previewBorderWidth;
		hSpaceFill: self previewWidthPercent;
		vSpaceFill;
		margin: { self headerHeight + self innerBorderWidth. 0 . 0};
		marginLeft: (self previewBorderWidth + self previewArrowWidth) negated.
	
	aBrick layout
		zIndex: 1! !

!GTSpotterWidgetThemer methodsFor: 'styles-widget' stamp: 'AliakseiSyrel 3/21/2015 22:46'!
spotterPreviewWidgetStyleFor: aBrick
	
	aBrick
		borderColor: self borderColor;
		color: self backgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 2/8/2015 17:43'!
spotterStyleFor: aBrick

	aBrick brickRoot useVerticalLinearLayout! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 11/17/2014 22:02'!
titleBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:38'!
titleFamilyName
	^ 'Open Sans'.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/18/2014 23:52'!
titleMarginLeft
	^ 20! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 3/23/2015 17:45'!
titleTextColor

	^ self themer textLightColor! !

Notification subclass: #GTCurrentSpotterExceptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Exceptions'!

!GTCurrentSpotterExceptionHandler class methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 4/1/2015 09:50'!
defaultValue
	^ nil! !

!GTCurrentSpotterExceptionHandler class methodsFor: 'evaluating' stamp: 'StefanReichhart 3/18/2015 12:33'!
use: anObject during: aBlock
	
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!GTCurrentSpotterExceptionHandler class methodsFor: 'evaluating' stamp: 'StefanReichhart 3/18/2015 12:42'!
value
	^ self signal! !

!GTCurrentSpotterExceptionHandler methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/18/2015 12:32'!
defaultAction
	^ self class defaultValue! !

Error subclass: #GTSpotterExceptionHandlerNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Exceptions'!

GLMBrick subclass: #GTSpotterContentsBrick
	instanceVariableNames: 'headerBrick dropDownBrick spotterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
dropDownBrick
	^ dropDownBrick! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/8/2015 14:28'!
dropDownBrick: aBrick
	dropDownBrick ifNotNil: [self removeBrick: dropDownBrick].
	dropDownBrick := aBrick asBrick.
	
	dropDownBrick morph pagerModel: self spotterModel pagerModel.
	self themer spotterThemer dropDownPaneStyleFor: dropDownBrick.
	
	self addBrickBack: dropDownBrick
	"aBrick openInWindow"! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
headerBrick
	^ headerBrick! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
headerBrick: aBrick
	
	headerBrick ifNotNil: [self removeBrick: headerBrick].
	headerBrick := aBrick.
	
	self themer spotterThemer headerStyleFor: headerBrick.
	
	self addBrickBack: headerBrick! !

!GTSpotterContentsBrick methodsFor: 'initialization' stamp: 'AndreiChis 3/15/2015 23:50'!
initialize
	super initialize.
		
	self headerBrick: self newHeaderBrick.
	"#GTSpotterEventRecorderSettings asClassIfPresent: [ 
		self privacyAgreementBrick: self newPrivacyAgreementBrick ]."! !

!GTSpotterContentsBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
isDropDownPaneVisible

	^ self dropDownBrick isNotNil! !

!GTSpotterContentsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:35'!
newDropDownMorph

	^ GTSpotterDropDownMorph new! !

!GTSpotterContentsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newHeaderBrick

	^ GTSpotterHeaderBrick new! !

!GTSpotterContentsBrick methodsFor: 'events-processing' stamp: 'AliakseiSyrel 11/20/2014 23:29'!
onStepAdded
	"as soon as step added I need to show drop down pane"
	self isDropDownPaneVisible ifTrue: [ ^ self ].
	
	self showDropDownPane! !

!GTSpotterContentsBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 22:45'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer spotterContentsWidgetStyleFor: self! !

!GTSpotterContentsBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/8/2015 14:39'!
showDropDownPane

	self dropDownBrick: self newDropDownMorph.
	self dropDownBrick spotterModel: self spotterModel.! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:35'!
spotterModel

	^ spotterModel! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
spotterModel: aModel

	spotterModel := aModel.
	self headerBrick spotterModel: spotterModel.
	
	spotterModel steps isEmpty ifFalse: [ spotterModel currentStep isEmpty ifFalse: [ self showDropDownPane ] ].

	spotterModel announcer when: GTSpotterStepAdded send: #onStepAdded to: self.! !

GLMBrick subclass: #GTSpotterHeaderBrick
	instanceVariableNames: 'stepsBrick searchField closeButton spotterModel settingsButton helpButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/3/2015 11:31'!
closeButton

	^ closeButton! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/23/2015 17:51'!
closeButton: aBrick

	closeButton ifNotNil: [self removeBrick: closeButton].
	closeButton := aBrick.
	
	self themer spotterThemer closeButtonWidgetStyleFor: closeButton.
	self themer spotterThemer closeButtonStyleFor: closeButton.
	
	closeButton
		hintTitle: 'Close Spotter';
		hintText: '<escape>';
		action: [ self spotterModel exitDueTo: #actionButton ].
	
	self addBrickBack: closeButton! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'TudorGirba 1/20/2016 19:21'!
helpButton: aBrick

	helpButton ifNotNil: [self removeBrick: helpButton].
	helpButton := aBrick.
	
	self themer spotterThemer helpButtonWidgetStyleFor: helpButton.
	self themer spotterThemer helpButtonStyleFor: helpButton.
	
	helpButton
		hintTitle: 'Spotter help';
		action: [ 
			self spotterModel exitDueTo: #actionButton.
			HelpBrowser openOn: GTSpotterHelp ].
	
	self addBrickBack: helpButton! !

!GTSpotterHeaderBrick methodsFor: 'initialization' stamp: 'TudorGirba 1/20/2016 16:55'!
initialize
	super initialize.
	
	self searchField: self newSearchField.
	#GTEventRecorderSettings asClassIfPresent: [ 
		self settingsButton: self newSettingsButton ].
	self helpButton: self newHelpButton.
	self closeButton: self newCloseButton.
	! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/13/2015 00:58'!
newCloseButton

	^ GLMHintableActionButtonBrick new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'TudorGirba 1/20/2016 16:53'!
newHelpButton

	^ GLMHintableActionButtonBrick new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 3/26/2015 16:23'!
newSearchField

	^ GLMRubTextFieldBrick new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'TudorGirba 2/28/2015 14:52'!
newSettingsButton

	^ GLMHintableActionButtonBrick new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 17:33'!
newStepsBand

	^ GLMBrick new! !

!GTSpotterHeaderBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/26/2015 17:54'!
onCurrentStepChanged

	self searchField rubric updateTextWith: self spotterModel currentStep context text.
	self searchField rubric selectFrom: self searchField rubric text size + 1 to: self searchField rubric text size! !

!GTSpotterHeaderBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/3/2015 11:32'!
onHideHints

	self themer spotterThemer hintHideStyleFor: self settingsButton.
	self themer spotterThemer hintHideStyleFor: self closeButton.! !

!GTSpotterHeaderBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/3/2015 11:33'!
onRevealHints

	self themer spotterThemer hintRevealStyleFor: self settingsButton.
	self themer spotterThemer hintRevealStyleFor: self closeButton! !

!GTSpotterHeaderBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/23/2015 17:51'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer headerWidgetStyleFor: self.
	self themer spotterThemer closeButtonWidgetStyleFor: self closeButton.
	self themer spotterThemer searchFieldWidgetStyleFor: self searchField.
	self themer spotterThemer settingsButtonWidgetStyleFor: self settingsButton! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 14:13'!
openSettingsBrowser
	GTSpotterPrivacyAgreementNotificationBrick openSettingsBrowser.
	self spotterModel exitDueTo: #openSettingsBrowser.! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:29'!
searchField

	^ searchField! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/26/2015 16:23'!
searchField: aBrick

	searchField := aBrick.
	
	self themer spotterThemer searchFieldStyleFor: searchField.
	
	searchField morph takeKeyboardFocus.
	
	self addBrickBack: searchField! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/3/2015 11:31'!
settingsButton

	^ settingsButton! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/23/2015 17:50'!
settingsButton: aBrick

	settingsButton ifNotNil: [self removeBrick: settingsButton].
	settingsButton := aBrick.
	
	self themer spotterThemer settingsButtonWidgetStyleFor: settingsButton.
	self themer spotterThemer settingsButtonStyleFor: settingsButton.
	
	settingsButton
		hintTitle: 'Settings';
		hintText: 'Shows the settings UI';
		action: [ self openSettingsBrowser ].
	
	self addBrickBack: settingsButton! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:15'!
spotterModel

	^ spotterModel! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
spotterModel: aModel 

	spotterModel := aModel.
	self searchField morph on: spotterModel.

	spotterModel announcer weak when: GTSpotterCurrentStepChanged send: #onCurrentStepChanged to: self.
	
	self spotterModel announcer weak when: GTSpotterRevealHints send: #onRevealHints to: self.
	self spotterModel announcer weak when: GTSpotterHideHints send: #onHideHints to: self.! !

GLMBrick subclass: #GTSpotterItemActionbarBrick
	instanceVariableNames: 'stepModel diveInButton actOnButton candidateLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:06'!
actOnButton
	^ actOnButton! !

!GTSpotterItemActionbarBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 3/22/2015 11:52'!
addActActionButton

	actOnButton := (self newActionButtonBrick
			icon: self themer spotterThemer iconAct;
			hintTitle: 'Default action';
			hintText: '<enter>';
			action: [ self owner beSelected. self stepModel actDueTo: #actionButton ];
			yourself).

	self addActionButton: actOnButton.! !

!GTSpotterItemActionbarBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 3/21/2015 22:14'!
addActionButton: anActionButton

	self themer spotterThemer itemActionButtonStyleFor: anActionButton.
	self themer spotterThemer itemActionButtonWidgetStyleFor: anActionButton.
		
	self addBrickBack: anActionButton.
	
	self stepModel spotter isShiftPressed
		ifTrue: [ self themer spotterThemer hintRevealStyleFor: anActionButton ].! !

!GTSpotterItemActionbarBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 3/22/2015 11:52'!
addDiveInActionButton
			
	(self stepModel canDiveIn: self candidate) ifTrue: [
		diveInButton := (self newActionButtonBrick
			icon: self themer spotterThemer iconDiveIn;
			hintTitle: 'Dive in';
			hintText: '<cmd+right>';
			action: [ self owner beSelected. self stepModel diveInDueTo: #actionButton ];
			yourself).
		
		self addActionButton: diveInButton ]! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:13'!
candidate

	^ self candidateLink value! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:13'!
candidateLink
	^ candidateLink! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:13'!
candidateLink: anObject
	candidateLink := anObject! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:06'!
diveInButton
	^ diveInButton! !

!GTSpotterItemActionbarBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/28/2015 00:05'!
newActionButtonBrick

	^ GLMHintableActionButtonBrick new! !

!GTSpotterItemActionbarBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/28/2015 00:56'!
onHideHints

	self visible ifFalse: [ ^ self ].
	self themer spotterThemer hintHideStyleFor: self diveInButton.
	self themer spotterThemer hintHideStyleFor: self actOnButton.! !

!GTSpotterItemActionbarBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/28/2015 00:57'!
onRevealHints

	self visible ifFalse: [ ^ self ].
	self themer spotterThemer hintRevealStyleFor: self diveInButton.
	self themer spotterThemer hintRevealStyleFor: self actOnButton! !

!GTSpotterItemActionbarBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 22:14'!
onThemerChanged
	super onThemerChanged.
	
	self subbricks do: [ :each | self themer spotterThemer itemActionButtonWidgetStyleFor: each ]! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:04'!
stepModel
	^ stepModel! !

!GTSpotterItemActionbarBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
stepModel: anObject
	stepModel := anObject.
	
	self stepModel spotter announcer weak when: GTSpotterRevealHints send: #onRevealHints to: self.
	self stepModel spotter announcer weak when: GTSpotterHideHints send: #onHideHints to: self.
	
	self
		addActActionButton;
		addDiveInActionButton! !

!GTSpotterItemActionbarBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/28/2015 00:11'!
toggleHints

	self visible ifFalse: [ ^ self ].
	self stepModel spotter isShiftPressed
		ifTrue: [ self onRevealHints ]
		ifFalse: [ self onHideHints ]! !

!GTSpotterItemActionbarBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/28/2015 00:11'!
visible: aBoolean
	super visible: aBoolean.
	
	self toggleHints
	
	! !

GLMBrick subclass: #GTSpotterPaneBrick
	instanceVariableNames: 'contentsBrick previewBrick arrowBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 18:30'!
arrowBrick

	^ arrowBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
arrowBrick: aBrick

	arrowBrick := aBrick.
	self themer spotterThemer spotterPreviewArrowContainerStyleFor: self arrowBrick.
	self addBrickBack: self arrowBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 00:58'!
contentsBrick

	^ contentsBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
contentsBrick: aBrick
	
	contentsBrick ifNotNil: [self removeBrick: contentsBrick].
	contentsBrick := aBrick.
		
	self themer spotterThemer spotterContentsStyleFor: contentsBrick.

	self addBrickBack: contentsBrick! !

!GTSpotterPaneBrick methodsFor: 'action' stamp: 'AliakseiSyrel 2/3/2015 23:52'!
hidePreview

	self isPreviewShown ifFalse: [ ^ self ].

	self removeBrick: self previewBrick.
	self contentsBrick layout hSpaceFill.
	self changed.! !

!GTSpotterPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 18:30'!
initialize
	super initialize.
	
	self contentsBrick: self newContentsBrick.
	self arrowBrick: self newArrowBrick.
	self previewBrick: self newPreviewBrick! !

!GTSpotterPaneBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 1/25/2015 17:15'!
isPreviewShown

	^ self hasSubbrick: self previewBrick! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 18:29'!
newArrowBrick

	^ GTSpotterPreviewArrowBrick new! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 00:58'!
newContentsBrick

	^ GTSpotterContentsBrick new! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 01:13'!
newPreviewBrick

	^ GTSpotterPreviewBrick new! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 01:14'!
previewBrick

	^ previewBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
previewBrick: aBrick

	previewBrick ifNotNil: [self removeBrick: aBrick].
	previewBrick := aBrick.
	
	self themer spotterThemer spotterPreviewStyleFor: previewBrick! !

!GTSpotterPaneBrick methodsFor: 'action' stamp: 'AliakseiSyrel 2/9/2015 22:16'!
showPreview
	
	self isPreviewShown ifTrue: [ ^ self ].
	
	self addBrickBack: self previewBrick.
	self previewBrick spotterModel ifNotNil: [
		self previewBrick updatePreviewWith: self previewBrick spotterModel currentStep selectedCandidate ].
	
	self contentsBrick hSpaceFill: (100 - self previewBrick layout hPercent).
	self changed.! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:20'!
spotterModel: aSpotter

	self contentsBrick spotterModel: aSpotter.
	self arrowBrick spotterModel: aSpotter.
	self previewBrick spotterModel: aSpotter! !

GLMBrick subclass: #GTSpotterPreviewArrowBrick
	instanceVariableNames: 'triangleBrick selectedItemBrick spotterModel isTriangleVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 3/21/2015 22:59'!
hideTriangle

	isTriangleVisible := false.
	self themer spotterThemer spotterPreviewArrowWidgetStyleFor: self triangleBrick.
	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 19:00'!
initialize
	super initialize.
	
	self triangleBrick: self newTriangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 3/24/2015 00:54'!
isTriangleVisible

	^ isTriangleVisible ifNil: [ isTriangleVisible := false ]! !

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/10/2015 14:19'!
moveTo: anItemBrick
	|itemBounds delta selfBounds|
	anItemBrick ifNil: [ ^ self ].
	
	itemBounds := anItemBrick globalBounds.
	selfBounds := self globalBounds.
	
	delta := ((itemBounds top - selfBounds top) max: 0) min: (selfBounds height - self triangleBrick height).
	self triangleBrick brickBounds top = delta ifTrue: [ ^ self ].
	
	self triangleBrick marginTop: delta.
	self triangleBrick doLayoutForce.
	self owner changed
	! !

!GTSpotterPreviewArrowBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/13/2015 00:58'!
newTriangleBrick

	^ GLMHintableActionButtonBrick new! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/29/2015 01:15'!
onAllCandidatesRemoved

	self selectedItemBrick: nil! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/10/2015 14:31'!
onCandidateMoved

	self moveTo: self selectedItemBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/10/2015 14:31'!
onCandidateSelected: ann

	self selectedItemBrick: ann candidateBrick.
	self moveTo: self selectedItemBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'brick-drawing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
onDraw: aCanvas
	super onDraw: aCanvas.
	
		aCanvas
			fillRectangle: ((self brickBounds withWidth: self themer spotterThemer outerBorderWidth) translateBy: (self themer scrollbarWidth + self themer scrollbarOffset + 1)@0)
			color: (self spotterModel isPreviewVisible
				ifTrue: [ self themer spotterThemer backgroundColor ]
				ifFalse: [ Color transparent ])
	
	! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/3/2015 11:28'!
onHideHints

	self themer spotterThemer hintHideArrowStyleFor: self triangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/26/2015 15:59'!
onHidePreview

	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/3/2015 11:28'!
onRevealHints

	self themer spotterThemer hintRevealArrowStyleFor: self triangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/26/2015 15:59'!
onShowPreview

	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
onStepAdded
	
	self selectedItemBrick: nil.
	self spotterModel steps last candidates announcer when: GTSpotterAllCandidatesRemoved send: #onAllCandidatesRemoved to: self.! !

!GTSpotterPreviewArrowBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 23:00'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer spotterPreviewArrowWidgetStyleFor: self triangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:37'!
selectedItemBrick
	
	^ selectedItemBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:43'!
selectedItemBrick: aBrick
	
	selectedItemBrick isNil & aBrick isNotNil ifTrue: [ self showTriangle ].
	selectedItemBrick isNotNil & aBrick isNil ifTrue: [ self hideTriangle ].
	
	selectedItemBrick := aBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 3/21/2015 23:00'!
showTriangle

	isTriangleVisible := true.
	self themer spotterThemer spotterPreviewArrowWidgetStyleFor: self triangleBrick.
	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 20:10'!
spotterModel

	^ spotterModel! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
spotterModel: aSpotterModel

	spotterModel := aSpotterModel.
	
	self spotterModel announcer weak when: GTSpotterCandidateSelected send: #onCandidateSelected: to: self.
	self spotterModel announcer weak when: GTSpotterCandidateSelectedMoved send: #onCandidateMoved to: self.
	self spotterModel announcer weak when: GTSpotterStepAdded send: #onStepAdded to: self.
	self spotterModel announcer weak when: GTSpotterShowPreview send: #onShowPreview to: self.
	self spotterModel announcer weak when: GTSpotterHidePreview send: #onHidePreview to: self.
	
	self spotterModel announcer weak when: GTSpotterRevealHints send: #onRevealHints to: self.
	self spotterModel announcer weak when: GTSpotterHideHints send: #onHideHints to: self.! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 18:58'!
triangleBrick

	^ triangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/22/2015 11:52'!
triangleBrick: aBrick

	triangleBrick := aBrick.
	self triangleBrick
		hintTitle: 'Toggle preview';
		hintText: '<cmd+p>';
		action: [ self spotterModel togglePreview ].
	self themer spotterThemer spotterPreviewArrowStyleFor: self triangleBrick.
	self addBrickBack: self triangleBrick
	! !

GLMBrick subclass: #GTSpotterPreviewBrick
	instanceVariableNames: 'compositeBrick spotterModel asyncTask previewObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/13/2015 00:52'!
asyncTask

	^ asyncTask ifNil: [ asyncTask := GLMAsyncTask new ]! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 12:45'!
compositeBrick

	^ compositeBrick! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 19:53'!
compositeBrick: aBrick

	self compositeBrick ifNotNil: [ self removeBrick: self compositeBrick ].
	compositeBrick := aBrick.
	self themer spotterThemer spotterPreviewCompositeStyleFor: self compositeBrick.
	self addBrickBack: self compositeBrick.
	self doLayoutForce! !

!GTSpotterPreviewBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/25/2015 14:24'!
defaultNotAvailableText

	^ 'Preview is not available :('! !

!GTSpotterPreviewBrick methodsFor: 'updating' stamp: 'AndreiChis 7/4/2015 14:55'!
handleException: exception forComposite: composite 

	('[Spotter] Exception while building the preview content: ', exception asString) logCr.
	composite removeAllBricks.! !

!GTSpotterPreviewBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/20/2015 12:50'!
initialize
	super initialize.
	
	self compositeBrick: self newCompositeBrick! !

!GTSpotterPreviewBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 12:47'!
newCompositeBrick

	^ GLMCompositeBrick new! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/20/2015 13:18'!
onCandidateSelected: ann

	self updatePreviewWith: ann selected! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 3/24/2015 00:44'!
onSearchFinished

	self spotterModel currentStep candidates isEmpty
		ifTrue: [ self updatePreviewWithEmpty ]! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/26/2015 08:28'!
onStepAdded

	previewObject := nil.
	self updatePreviewWithLoading! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/20/2015 13:21'!
onStepPopped

	self updatePreviewWith: self spotterModel steps last selectedCandidate! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/21/2015 22:47'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer spotterPreviewWidgetStyleFor: self! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 13:18'!
spotterModel

	^ spotterModel! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:30'!
spotterModel: aSpotter
	
	spotterModel := aSpotter.
	aSpotter announcer weak when: GTSpotterSelectedCandidateChanged send: #onCandidateSelected: to: self.
	aSpotter announcer weak when: GTSpotterStepPopped send: #onStepPopped to: self.
	aSpotter announcer weak when: GTSpotterStepAdded send: #onStepAdded to: self.
	aSpotter announcer weak when: GTSpotterSearchFinished send: #onSearchFinished to: self.
	
	! !

!GTSpotterPreviewBrick methodsFor: 'updating' stamp: 'AndreiChis 7/4/2015 14:52'!
updatePreviewWith: anObject
	|wasNil|
	self spotterModel isPreviewVisible ifFalse: [ ^ self ].
	
	wasNil := previewObject isNil.
	previewObject = anObject ifTrue: [ ^ self ].
	previewObject := anObject.
	previewObject ifNil: [ ^ self updatePreviewWithEmpty ].
	wasNil ifTrue: [ self updatePreviewWithLoading ].
	
	self asyncTask
		execute: [ :composite :entity |
				[ entity spotterPreviewIn: composite inContext: self spotterModel ]
					on: Error
					do: [ :exception |
						self spotterModel exceptionHandler 
							handleException: exception 
							do: [ self handleException: exception forComposite: composite ] ].
				 composite ]
		withArguments: { self newCompositeBrick . anObject }
		callback: [ :composite |
			self compositeBrick: composite.
			self changed ]
		priority: Processor userBackgroundPriority
		delay: 50! !

!GTSpotterPreviewBrick methodsFor: 'updating' stamp: 'AliakseiSyrel 2/25/2015 14:24'!
updatePreviewWithEmpty

	self removeAllBricks.
	self asyncTask
		execute: [ | emptyBrick |
			emptyBrick := GLMLabelBrick new
				text: self defaultNotAvailableText;
				textPosition: #center;
				textColor: Color lightGray;
					with: [ :b | b label
					customFont;
					fontSize: 14 ] ]
		withArguments: {  }
		callback: [ :brick | self compositeBrick: brick ]
		priority: Processor userBackgroundPriority
		delay: 50! !

!GTSpotterPreviewBrick methodsFor: 'updating' stamp: 'AliakseiSyrel 2/26/2015 08:28'!
updatePreviewWithLoading

	self compositeBrick: (
		GLMLabelBrick new
			text: 'Loading...';
			textPosition: #center;
			textColor: Color lightGray;
				with: [ :b | b label
				customFont;
				fontSize: 14 ])! !

GLMBrick subclass: #GTSpotterPrivacyAgreementNotificationBrick
	instanceVariableNames: 'messageBrick settingsButtonBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPrivacyAgreementNotificationBrick class methodsFor: 'examples' stamp: 'StefanReichhart 4/9/2015 12:36'!
exampleOpen

	(GLMBrick new
		hSpaceFill;
		vSpaceFill;
		addBrickBack: (
			self gtExample
				padding: 2;
				borderColor: Color lightGray;
				borderWidth: 2;
				margin: 10;
				hSpaceFill;
				vShrinkWrap;
				yourself);
		yourself)
			openInBrickWindow
			extent: 600@400! !

!GTSpotterPrivacyAgreementNotificationBrick class methodsFor: 'examples' stamp: 'StefanReichhart 9/6/2015 17:23'!
gtExample
	<gtExample>
	<label: 'Simple agreement'>
	
	^ self new! !

!GTSpotterPrivacyAgreementNotificationBrick class methodsFor: 'utils' stamp: 'JurajKubelka 10/30/2015 14:56'!
openSettingsBrowser
	| settingsBrowser window node nodePath |
	settingsBrowser := SettingBrowser new 
		changePackageSet: (RPackage organizer packageNamed: 'GT-EventRecorder') asOrderedCollection;
		yourself.
	window := settingsBrowser open.
	window position: Display extent - window extent // 2.
	settingsBrowser expandAll.
	node := settingsBrowser treeHolder nodeNamed: #sendDiagnosticsAndUsageData.
	nodePath := Array 
		with: (settingsBrowser treeHolder nodeNamed: node parentName)
		with: node.
	settingsBrowser selection: (MorphTreeMorphSingleSelection new selectedNodePath: nodePath).! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'initialization' stamp: 'AndreiChis 3/16/2015 11:52'!
initialize
	super initialize.
	
	self useHorizontalLinearLayout.
	self hSpaceFill.
	self vShrinkWrap.
	self messageBrick: self newTitleBrick.
	self settingsButtonBrick: self newButtonBrick.! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AndreiChis 3/15/2015 23:24'!
messageBrick
	^ messageBrick! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AndreiChis 3/16/2015 11:48'!
messageBrick: anObject

	messageBrick := anObject.
	self messageBrick
		hSpaceFill;
		margin:10;
		text: self privacyMessage.

	self addBrickBack: self messageBrick.! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'instance creation' stamp: 'AndreiChis 3/15/2015 23:11'!
newButtonBrick

	^ GLMButtonBrick new! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'instance creation' stamp: 'AndreiChis 3/15/2015 23:11'!
newTitleBrick

	^ GLMRubTextAreaBrick new! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'actions' stamp: 'AndreiChis 3/18/2015 15:40'!
openSettingsBrowser
	self class openSettingsBrowser.
	self owner owner closeSpotter.! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AndreiChis 11/8/2015 20:29'!
privacyMessage

	^ self sendUsageData 
		ifTrue: [ 'You are sending diagnostic and usage data to help us improve Pharo. Thanks!!' ]
		ifFalse: 	['No diagnostic and usage data is being sent. Would you like to send diagnostic and usage data to help us improve Pharo?']! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'preferences' stamp: 'JurajKubelka 10/11/2015 16:22'!
sendUsageData
	| settingsClass |
	settingsClass := #Privacy asClassIfAbsent: [ ^ false ].
	^ settingsClass sendDiagnosticsAndUsageData! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AndreiChis 3/15/2015 23:27'!
settingsButtonBrick
	^ settingsButtonBrick! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/23/2015 01:13'!
settingsButtonBrick: anObject
	settingsButtonBrick := anObject.
	
	self settingsButtonBrick
		text: self settingsButtonLabel;
		hShrinkWrap;
		vAlign: #center;
		margin:10;
		when: #onClicked do: [ self openSettingsBrowser ].
	
	self addBrickBack: self settingsButtonBrick! !

!GTSpotterPrivacyAgreementNotificationBrick methodsFor: 'accessing' stamp: 'AndreiChis 3/16/2015 00:16'!
settingsButtonLabel
	
	^ self sendUsageData 
		ifTrue: [ 'Change preferences' ]
		ifFalse: [  'Go to settings' ]! !

GLMBrick subclass: #GTSpotterStepsBreadcrumb
	instanceVariableNames: 'spotterModel items band animation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 2/10/2015 13:47'!
addItem: aBrick

	aBrick width: [ :itemBrick | self calculateItemWidth: itemBrick ].
	aBrick layout widthDependency: self.
	
	self items size = 1 ifTrue: [
		self items first labelBrick paddingLeft: self themer spotterThemer breadcrumbSeparatorWidth / 2 ].
	
	self items addLast: aBrick.
	self band addBrickBack: aBrick.
	self items do: [ :b | b wrappedBounds markWidthDirty ].
	self band doLayoutForce.! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 3/21/2015 22:27'!
addSeparator
	|separator|
	separator := self newSeparator.
	self themer spotterThemer breadcrumbSeparatorStyleFor: separator.
	self themer spotterThemer breadcrumbSeparatorWidgetStyleFor: separator.
	self band addBrickBack: separator! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 11:56'!
animation

	^ animation! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 14:12'!
band

	^ band! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/8/2015 17:40'!
band: aBrick

	band := aBrick.
	band
		useHorizontalLinearLayout;
		hShrinkWrap;
		vSpaceFill.
	
	self band data: 0.
	self addBrickBack: band.! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/10/2015 14:06'!
calculateItemWidth: aBrick
	|sWidth bWidth singleWidth lastWidth|
	sWidth := self themer spotterThemer breadcrumbSeparatorWidth.
	bWidth := self width.
	lastWidth := ((aBrick labelBrick approximateWidth min: (bWidth / 2)) max: ((bWidth - ((self maxNumberOfSteps - 1) * sWidth)) / self maxNumberOfSteps)) floor.
	singleWidth := ((bWidth - lastWidth - ((self maxNumberOfSteps - 1) * sWidth)) / (self maxNumberOfSteps - 1)) floor.
	
	"width of other bricks depends on the width of the last one"
	^ aBrick isLastInOwner
		ifTrue: [
			self items size >= self maxNumberOfSteps ifTrue: [ |fullWidth delta|
				fullWidth := lastWidth + ((self maxNumberOfSteps - 1) * (sWidth + singleWidth)).
				delta := bWidth - fullWidth.
				lastWidth := lastWidth + delta ].
			lastWidth ]
		ifFalse: [ singleWidth ]
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
defaultBreadcrumbHeight

	^ self themer spotterThemer breadcrumbHeight + self themer spotterThemer breadcrumbTriangleHeight! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/18/2015 12:31'!
glmAnimateBrickBounds: aValue duration: anInteger callback: aBlock

	self animation ifNotNil: #terminate.
	animation := GLMAnimation new
		linear;
		duration: anInteger;
		from: self band brickBounds left;
		to: self band brickBounds left + aValue;
		onCompleted: aBlock;
		animation: [ :b :v | b changedWith: [ b translateXTo: v asInteger; data: b brickBounds left ] ];
		animate: self band! !

!GTSpotterStepsBreadcrumb methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/10/2015 13:31'!
initialize
	super initialize.
	
	self band: self newBand! !

!GTSpotterStepsBreadcrumb methodsFor: 'testing' stamp: 'AliakseiSyrel 11/21/2014 00:55'!
isVisible

	^ self items isEmpty not! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 13:28'!
items

	^ items ifNil: [ items := OrderedCollection new ]! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 11:47'!
maxNumberOfSteps
	^ 5! !

!GTSpotterStepsBreadcrumb methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/20/2014 14:13'!
newBand

	^ GLMBrick new! !

!GTSpotterStepsBreadcrumb methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/26/2015 00:22'!
newSeparator

	^ GLMBrick new! !

!GTSpotterStepsBreadcrumb methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:35'!
notifyBreadcrumbVisibilityChanged

	self announcer announce: GTSpotterBreadcrumbVisibilityChanged new! !

!GTSpotterStepsBreadcrumb methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/18/2015 12:32'!
onChildrenLayouted
	super onChildrenLayouted.
	
	self band translateXTo: (self band data ifNil: [ 0 ]).
	self scrollToTheLastOne! !

!GTSpotterStepsBreadcrumb methodsFor: 'events-processing' stamp: 'TudorGirba 2/21/2015 22:42'!
onStepAdded: ann
	|step origin previousStep selectedCandidate|
	
	self spotterModel steps size <= 1 ifTrue: [
		^ self push: (GTSpotterStepBreadcrumbItem new
						text: self spotterModel steps first origin gtDisplayString;
						stepModel: self spotterModel steps first) ].
	
	step := ann stepModel.
	previousStep := (step spotter steps at: step spotter steps size - 1).
	selectedCandidate := previousStep selectedCandidate.
	origin := step origin.
	
	self push: (GTSpotterStepBreadcrumbItem new
		stepModel: step;
		text: ((selectedCandidate = origin)
			ifTrue: [ (previousStep selected renderingProcessor render: selectedCandidate) labelBrick text ]
			ifFalse: [ (origin isKindOf: Collection) ifTrue: [ previousStep selected processor title ] ifFalse: [ origin gtDisplayString] ]))! !

!GTSpotterStepsBreadcrumb methodsFor: 'events-processing' stamp: 'AliakseiSyrel 11/20/2014 13:39'!
onStepPopped

	self pop
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 22:30'!
onThemerChanged
	super onThemerChanged.
	
	self band subbricks withIndexDo: [ :each :index | index even ifTrue: [ self themer spotterThemer breadcrumbSeparatorWidgetStyleFor: each ] ]! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 2/17/2015 19:39'!
pop
	
	self band layoutAfter: [
		self band removeBrick: self items removeLast.
		self items size = 1 ifTrue: [
			self items first labelBrick paddingLeft: 0 ].
		self items isEmpty ifFalse: [ self popSeparator ].
		self items do: [ :b | b wrappedBounds markWidthDirty ] ].
	
	"optimization. if last item was popped we need to update root to reposition all brick,
	otherwise only I need to be updated"
	self items size = 0
		ifTrue: [ self notifyBreadcrumbVisibilityChanged ]
		ifFalse: [
			self items last showTriangle.
			self scrollToTheLastOne.
			self changed ]! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/26/2015 00:09'!
popSeparator

	self band removeBrick: self band lastSubbrick! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 2/17/2015 19:41'!
push: aBrick

	self themer spotterThemer breadcrumbItemStyleFor: aBrick.
	
	self band layoutAfter: [
		self items isEmpty ifFalse: [
			self items last hideTriangle.
			self addSeparator ].
		self addItem: aBrick ].
	
	"optimization. if first item was added we need to update root to reposition all bricks,
	otherwise only I need to be updated"
	self items size = 1
		ifTrue: [ self notifyBreadcrumbVisibilityChanged ]
		ifFalse: [
			self scrollToTheLastOne.
			self changed ].
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 2/18/2015 12:29'!
scrollToTheLastOne
	|leftDelta rightDelta delta|
	self items isEmpty ifTrue: [ ^ self ].
	
	rightDelta := self globalBounds right - self band globalBounds right.
	leftDelta := self globalBounds left - self band globalBounds left.
			
	"all visible, return"
	(leftDelta = 0  and: [ self items size <= self maxNumberOfSteps ]) ifTrue: [ ^ self ].
	
	delta := (self items size <= self maxNumberOfSteps) ifTrue: [ leftDelta ] ifFalse: [ rightDelta ].
	delta := self band brickBounds left + delta - self band data.
	
	self
		glmAnimateBrickBounds: delta
		duration: 400
		callback: nil.
	
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 20:38'!
spotterModel
	^ spotterModel! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:31'!
spotterModel: aSpotterModel
	
	spotterModel := aSpotterModel.
	
	spotterModel announcer weak when: GTSpotterStepAdded send: #onStepAdded: to: self.
	spotterModel announcer weak when: GTSpotterStepPopped send: #onStepPopped to: self.! !

!GLMBrickDarkThemer methodsFor: '*GT-Spotter' stamp: 'AliakseiSyrel 3/17/2015 22:59'!
spotterThemer

	^ self
		registerModule: GTSpotterWidgetDarkThemer new
		to: GTSpotterBrickDarkThemer new! !

GLMBrickDarkThemer subclass: #GTSpotterBrickDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterBrickDarkThemer methodsFor: 'brick-rubric' stamp: 'AliakseiSyrel 3/21/2015 21:37'!
rubricBackgroundColor

	^ self spotterThemer backgroundColor! !

!GTSpotterBrickDarkThemer methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 15:01'!
scrollbarColor

	^ Color black alpha: 0.5! !

!GTSpotterBrickDarkThemer methodsFor: 'brick-scrollpane' stamp: 'AliakseiSyrel 3/21/2015 21:37'!
scrollpaneBackgroundColor

	^ self spotterThemer backgroundColor! !

KMCategory subclass: #GTSpotterGlobalShortcut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterGlobalShortcut commentStamp: 'TudorGirba 11/18/2014 02:57' prior: 0!
KMRepository reset!

!GTSpotterGlobalShortcut class methodsFor: 'testing' stamp: 'TudorGirba 11/17/2014 22:30'!
isGlobalCategory
	^ true! !

!GTSpotterGlobalShortcut class methodsFor: 'accessing' stamp: 'JurajKubelka 11/17/2015 13:02'!
openGlobalSpotter
	| spotterModel |
		
	self reset.
	spotterModel := GTSpotter new.
	(Smalltalk hasClassNamed: #GTSpotterEventCollector) ifTrue: [ 
		#GTSpotterEventCollector asClass new
			perform: #occupant: with: spotterModel;
			perform: #category: with: #spotter;
			register;
			perform: #linkToSpotter: with: spotterModel;
			perform: #recordSpotterOpenEvent ].
	
	GTSpotterMorph new
		extent: (World width / 2.4 @ (World height / 1.6)) asIntegerPoint;
		spotterModel: spotterModel;
		doLayout;
		openCenteredInWorld.
		
	spotterModel class markOpened.! !

!GTSpotterGlobalShortcut class methodsFor: 'accessing' stamp: 'StefanReichhart 4/1/2015 19:50'!
openGlobalSpotterDebug

	GTSpotterMorph new
		extent: (World width / 2.25 @ (World height / 1.25)) asIntegerPoint;
		spotterModel: (GTSpotter new
			beDebugging;
			yourself);
		openInWindowLabeled: 'Spotter Debug Mode';
		showPreview! !

!GTSpotterGlobalShortcut class methodsFor: 'cleanup' stamp: 'JurajKubelka 3/30/2015 14:17'!
reset
	
	(World findA: GTSpotterMorph) ifNotNil: [ :aSpotterMorph | aSpotterMorph spotterModel exitDueTo: #reset ]! !

!GTSpotterGlobalShortcut methodsFor: 'shortcuts' stamp: 'AndreiChis 3/26/2015 15:51'!
keymapToggle
	"KMRepository reset"
	<shortcut>
	^ KMKeymap
			shortcut: Character cr shift
			action: [ self class openGlobalSpotter ]! !

!GTSpotterGlobalShortcut methodsFor: 'shortcuts' stamp: 'StefanReichhart 4/1/2015 19:43'!
keymapToggleDebug
	"KMRepository reset"
	<shortcut>
	^ KMKeymap
			shortcut: Character cr shift command
			action: [ self class openGlobalSpotterDebug ]! !

Object subclass: #GTFilter
	instanceVariableNames: 'context filteredItems streamed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilter commentStamp: 'AndreiChis 7/17/2015 13:48' prior: 0!
I am the root class of the hierarchy of filter objects  that can be used by Spotter. 

The main entry point is the #value method that performs and returns the list of filtered items.
Subclasses should return the list of filtered elements in sorted order based on the filtering criteria.!

!GTFilter class methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 14:21'!
gtFilter
	^ self new! !

!GTFilter class methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 16:58'!
gtListFilter
	^ self new! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 2/24/2015 13:54'!
addItem: anItem
	self context addItem: anItem! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 2/24/2015 13:54'!
addItems: aCollection
	self context addItems: aCollection! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 3/22/2015 22:02'!
allItems
	^ self processor allItemsIn: self context! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 3/22/2015 17:15'!
allItemsDo: aBlock
	self allItems do: aBlock! !

!GTFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:29'!
applyFilter
	^ self filteredItems! !

!GTFilter methodsFor: 'private' stamp: 'StefanReichhart 2/24/2015 13:54'!
applyFilterInContext: aSpotterContext
	self prepareFilterInContext: aSpotterContext.
	^ self applyFilter! !

!GTFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 18:00'!
applyFilterInContext: aSpotterContext error: anException
	('[Spotter] Exception in filter <', self class name, '>: ', anException asString) logCr.
	^ self defaultFilteredItems! !

!GTFilter methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:52'!
context
	^ context! !

!GTFilter methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:53'!
context: anObject
	context := anObject! !

!GTFilter methodsFor: 'accessing-defaults' stamp: 'AndreiChis 7/16/2015 18:01'!
defaultFilteredItems
	^ OrderedCollection new! !

!GTFilter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/23/2015 13:26'!
defaultStreamed
	^ true! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 4/1/2015 09:56'!
exceptionHandler
	self flag: 'Bloc -> overrides doesNotUnderstand discarding the current exception context'.
	^ GTCurrentSpotterExceptionHandler value ifNil: [ self context exceptionHandler ]! !

!GTFilter methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2015 17:29'!
filteredItems
	^ filteredItems! !

!GTFilter methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2015 17:30'!
filteredItems: aCollection
	filteredItems := aCollection! !

!GTFilter methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 14:21'!
gtFilter
	^ self! !

!GTFilter methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 16:58'!
gtListFilter
	^ self! !

!GTFilter methodsFor: 'testing' stamp: 'AndreiChis 7/16/2015 17:50'!
hasFilteredItems
	^ self filteredItems isEmptyOrNil not! !

!GTFilter methodsFor: 'private-model' stamp: 'AndreiChis 7/17/2015 13:39'!
itemFilterNameFor: anItem
	"I return the string/text representation of an item used by the filter."
	
	^ self processor itemFilterNameFor: anItem! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 2/24/2015 18:36'!
itemsLimit
	^ self context itemsLimit! !

!GTFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 18:27'!
prepareFilterInContext: aSpotterContext
	"I provide a hook for preprocessing the query once before performing a search."
	
	self context: aSpotterContext.
	self filteredItems: self defaultFilteredItems.! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 2/24/2015 13:53'!
processor
	^ self context processor! !

!GTFilter methodsFor: 'private-model' stamp: 'StefanReichhart 3/17/2015 15:29'!
step
	^ self context step! !

!GTFilter methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 13:25'!
streamed
	^ streamed ifNil: [ streamed := self defaultStreamed ]! !

!GTFilter methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 13:25'!
streamed: anObject
	streamed := anObject! !

!GTFilter methodsFor: 'public' stamp: 'StefanReichhart 11/1/2015 16:53'!
value: aSpotterContext
	"I provide an entry point for performing a search that is 
	polymorphic with BlockClosure>>value:. I return the list of
	filtered items."
	
	^ [ [ self applyFilterInContext: aSpotterContext ]
		on: Error
		do: [ :exception | 
			self exceptionHandler 
				handleException: exception 
				do: [ self applyFilterInContext: aSpotterContext error: exception ] ] ] 
		ensure: [ context := nil " release the context after search is completed " ] ! !

GTFilter subclass: #GTStringFilter
	instanceVariableNames: 'caseSensitive query'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTStringFilter commentStamp: 'AndreiChis 7/17/2015 13:46' prior: 0!
I provide the functionality for filtering items based on a query.

I return the list of all items that match the filter but my subclasses should only send to the processor the first  #itemsLimit items .
!

GTStringFilter subclass: #GTNullFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTNullFilter class methodsFor: 'public' stamp: 'StefanReichhart 3/12/2015 18:36'!
gtListFilter
	^ GTFilterSubstring new! !

!GTNullFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:34'!
applyFilterWithQuery
	self streamed 
		ifTrue: [
			" this will be more responsive (faster) for very large collections and/or expensive filters "
			| allItems |
			self filteredItems: (allItems := OrderedCollection new).
			self allItems withIndexDo: [ :each :index |
				allItems add: each.
				index <= self itemsLimit ifTrue: [ 
					self addItem: each ] ] ]
		ifFalse: [
			" this will be much much faster for small collections and/or very quick filters " 
			self filteredItems: self allItems.
			self addItems: (self allItems first: (self itemsLimit min: self allItems size)) ]! !

!GTNullFilter methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 16:59'!
gtListFilter
	^ GTFilterSubstring new! !

GTStringFilter subclass: #GTOrderedFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

GTOrderedFilter subclass: #GTFilterAlike
	instanceVariableNames: 'lowerThreshold upperThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterAlike methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:39'!
applyFilterWithQuery
	| allItemsPrepocessed allItemsPrepocessedAndSorted alikeMatches otherMatches upper lower |
	alikeMatches := OrderedCollection  new.
	otherMatches := OrderedCollection new.	
	" calculate the <similarity> of all items and throw away everything that is below the lower threshold (irrelevant) "			
	allItemsPrepocessed := OrderedCollection streamContents: [ :allItems | 
		lower := lowerThreshold * query size.
		self allItemsDo: [ :each | 
			| weight |
			(weight :=  (self itemFilterNameFor: each) alike: query) > lower ifTrue: [
				allItems nextPut: (Array with: weight with: each) ] ] ].
	" sort all items using <similarity> "
	allItemsPrepocessedAndSorted := allItemsPrepocessed asSortedCollection: [ :a :b | a first > b first ].
	" calculate the upper threshold "
	upper := allItemsPrepocessed isEmpty 
		ifTrue: [ upperThreshold ]
		ifFalse: [ (allItemsPrepocessedAndSorted collect: [ :each | each first ]) median " try an adaptive threshold (slow if not presorted) " ].
	" stream all items based on upper and lower threshold "
	allItemsPrepocessedAndSorted do: [ :each | 
		each first >= upper 
			ifTrue: [
				alikeMatches add: each last.
				alikeMatches size > self itemsLimit ifFalse: [ 
					self addItem: each ] ]
			ifFalse:[ otherMatches add: each last ] ].
	" push less relevant matches onto the result "
	(alikeMatches size < self itemsLimit) ifTrue: [ 
		(otherMatches first: ((self itemsLimit - alikeMatches size) min: otherMatches size)) do: [ :each |
			self addItem: each ] ].
	self filteredItems: alikeMatches , otherMatches ! !

!GTFilterAlike methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 18:39'!
defaultLowerThreshold
	" lower threshold: to cut off the large irrelevent chunk before sorting/filtering is appplied "
	^ 0.33! !

!GTFilterAlike methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 18:39'!
defaultUpperThreshold
	" upper threshold: to keep a reasonably sized set of interesting matches "
	^ 0.45! !

!GTFilterAlike methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 15:22'!
lowerThreshold
	^ lowerThreshold! !

!GTFilterAlike methodsFor: 'accessing' stamp: 'StefanReichhart 2/19/2015 15:54'!
lowerThreshold: anObject
	lowerThreshold := anObject! !

!GTFilterAlike methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:27'!
prepareFilterInContext: aSpotterContext
	super prepareFilterInContext: aSpotterContext.
	
	lowerThreshold ifNil: [ lowerThreshold := self defaultLowerThreshold ]. " performance optimization "
	upperThreshold ifNil: [ upperThreshold := self defaultUpperThreshold ]. " performance optimization "! !

!GTFilterAlike methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 15:22'!
upperThreshold
	^ upperThreshold! !

!GTFilterAlike methodsFor: 'accessing' stamp: 'StefanReichhart 2/19/2015 15:54'!
upperThreshold: anObject
	upperThreshold := anObject! !

GTOrderedFilter subclass: #GTFilterSubstring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterSubstring methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:40'!
applyFilterWithQuery
	| prefixMatches otherMatches |
	prefixMatches := OrderedCollection  new.
	otherMatches := OrderedCollection new.
	self allItemsDo: [ :each | 
		| index |
		index := self indexForItem: each.
		index >= 1 ifTrue: [
			index = 1 
				ifTrue: [ 
						prefixMatches add: each.
						prefixMatches size > self itemsLimit ifFalse: [ 
							self addItem: each  ] ]
				ifFalse: [ otherMatches add: each ] ] ].
	(prefixMatches size < self itemsLimit) ifTrue: [ 
		(otherMatches first: ((self itemsLimit - prefixMatches size) min: otherMatches size)) do: [ :each |
			self addItem: each ] ].
	self filteredItems: prefixMatches , otherMatches! !

!GTFilterSubstring methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 17:16'!
indexForItem: each
	^ (self itemFilterNameFor: each) findString: (self queryForItem: each) startingAt: 1 caseSensitive: self caseSensitive! !

!GTFilterSubstring methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 16:41'!
queryForItem: each
	^ query " performance optimization "! !

!GTStringFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:31'!
applyFilter
	self hasQuery ifFalse: [ 
		self applyFilterWithoutQuery.
		^ self allItems. " return the unfiltered items (all) - used for divein (no filtering appied) "  ].
	self applyFilterWithQuery.
	^ self filteredItems " return the filtered items only "! !

!GTStringFilter methodsFor: 'private' stamp: 'StefanReichhart 2/19/2015 15:04'!
applyFilterWithQuery
	! !

!GTStringFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:32'!
applyFilterWithoutQuery
	" WARNING: this is not a copy of GTNullFilter>>#applyFilterWithoutQuery !!!!!! "
	self streamed 
		ifTrue: [
			" this will be more responsive (faster) for very large collections and/or expensive filters "
			| reducedItems |
			self filteredItems: (reducedItems := OrderedCollection new).
			self allItems withIndexDo: [ :each :index |
				index <= self itemsLimit ifTrue: [ 
					reducedItems add: each.
					self addItem: each ] ] ]
		ifFalse: [
			" this will be much much faster for small collections and/or very quick filters " 
			self filteredItems: (self allItems first: (self itemsLimit min: self allItems size)).
			self addItems: self filteredItems ]! !

!GTStringFilter methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 15:18'!
caseSensitive
	^ caseSensitive! !

!GTStringFilter methodsFor: 'accessing' stamp: 'StefanReichhart 2/19/2015 16:16'!
caseSensitive: anObject
	caseSensitive := anObject! !

!GTStringFilter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/19/2015 16:16'!
defaultCaseSensitive
	^ false! !

!GTStringFilter methodsFor: 'testing' stamp: 'StefanReichhart 2/19/2015 13:34'!
hasQuery
	^ self query isEmptyOrNil not! !

!GTStringFilter methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:27'!
prepareFilterInContext: aSpotterContext
	super prepareFilterInContext: aSpotterContext.
	
	caseSensitive ifNil: [ caseSensitive := self defaultCaseSensitive ]. " performance optimization "
	self query: (caseSensitive " performance optimization "
		ifTrue: [ self context textTrimmed ]
		ifFalse: [ self context textLowercase ])! !

!GTStringFilter methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:53'!
query
	^ query! !

!GTStringFilter methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 12:57'!
query: anObject
	query := anObject! !

GTStringFilter subclass: #GTUnorderedFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

GTUnorderedFilter subclass: #GTFilterBlock
	instanceVariableNames: 'matcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterBlock methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:26'!
isMatchedItem: anItem
	^ self matcher 
		ifNotNil: [ self matcher value: anItem value: self context ]
		ifNil: [ (self itemFilterNameFor: anItem) includesSubstring: query caseSensitive: caseSensitive ]
		! !

!GTFilterBlock methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 15:31'!
matcher
	^ matcher! !

!GTFilterBlock methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 15:31'!
matcher: anObject
	matcher := anObject! !

GTUnorderedFilter subclass: #GTFilterRegex
	instanceVariableNames: 'regex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterRegex methodsFor: 'private' stamp: 'StefanReichhart 2/24/2015 13:01'!
applyFilterInContext: aSpotterContext error: exception
	super applyFilterInContext: aSpotterContext error: exception.
	^ (GTFilterSubstrings new
		caseSensitive: self caseSensitive;
		yourself) value: aSpotterContext! !

!GTFilterRegex methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 12:20'!
isMatchedItem: anItem
	^ self regex matches: (self itemFilterNameFor: anItem)! !

!GTFilterRegex methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:27'!
prepareFilterInContext: aSpotterContext
	super prepareFilterInContext: aSpotterContext.
	
	self regex: (caseSensitive " performance optimization "
		ifTrue: [ self query asRegex ] 
		ifFalse: [ self query asRegexIgnoringCase ])! !

!GTFilterRegex methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:10'!
regex
	^ regex! !

!GTFilterRegex methodsFor: 'accessing' stamp: 'StefanReichhart 2/19/2015 15:31'!
regex: anObject
	regex := anObject! !

GTUnorderedFilter subclass: #GTFilterStringMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterStringMatch methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:26'!
isMatchedItem: anItem
	^ query match: (self itemFilterNameFor: anItem)! !

GTUnorderedFilter subclass: #GTFilterSubstrings
	instanceVariableNames: 'separators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Filters'!

!GTFilterSubstrings methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/19/2015 16:04'!
defaultSeparators
	^ ' '! !

!GTFilterSubstrings methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:26'!
isMatchedItem: anItem
	| itemName |
	itemName := self itemFilterNameFor: anItem.
	^ query allSatisfy: [ :fragment | 
		itemName includesSubstring: fragment caseSensitive: self caseSensitive ]! !

!GTFilterSubstrings methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 15:27'!
prepareFilterInContext: aSpotterContext
	super prepareFilterInContext: aSpotterContext.
	
	separators ifNil: [  separators := self defaultSeparators  ]. " performance optimization "
	self query: (self query substrings: self separators) asSet asArray! !

!GTFilterSubstrings methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 15:20'!
separators
	^ separators! !

!GTFilterSubstrings methodsFor: 'accessing' stamp: 'StefanReichhart 2/19/2015 16:04'!
separators: anObject
	separators := anObject! !

!GTUnorderedFilter methodsFor: 'private' stamp: 'AndreiChis 7/16/2015 17:41'!
applyFilterWithQuery
	| unorderedMatchedItems |
	unorderedMatchedItems := OrderedCollection new.
	self allItemsDo: [ :each | 
		(self isMatchedItem: each)
				ifTrue: [
					unorderedMatchedItems isEmpty 
						ifTrue: [ 
							" this was done in the nil-fallback of GTSpotterCandidatesProcessor>>doFilter:on: - seems not to be harmful  "
							Processor activeProcess priority: Processor userSchedulingPriority ]. 
					unorderedMatchedItems add: each.
					unorderedMatchedItems size > self itemsLimit 
						ifTrue: [ 
							" this was done in the nil-fallback of GTSpotterCandidatesProcessor>>doFilter:on: - seems not to be harmful  "
							Processor activeProcess priority: Processor userBackgroundPriority ]
						ifFalse: [ self addItem: each ] ] ].
	self filteredItems: unorderedMatchedItems! !

!GTUnorderedFilter methodsFor: 'private' stamp: 'StefanReichhart 2/21/2015 10:28'!
isMatchedItem: anItem
	^ false! !

Object subclass: #GTSpotter
	instanceVariableNames: 'foundationOrigin steps announcer currentStep pagerModel text isPreviewVisible isShiftPressed exceptionHandler history processorsFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

GTSpotter class
	instanceVariableNames: 'history isPreviewVisible wasOpened'!

!GTSpotter commentStamp: 'AndreiChis 7/30/2015 17:33' prior: 0!
I am  the main model class.

I handle the list of current search steps and provide the main functionality for spawning new search steps or removing old ones.
I maintain search steps as a stack.
 
I  trigger a search when the user enters a query (#setText:from:) and maintain the search text.

To avoid crashes due to exceptions in search processors I can install an exception handler that prints exceptions to the transcript instead of opening a debugger (#beDeployment). Afternatively I can install an exception handler that  propagates exceptions (#beDeployment)!

GTSpotter class
	instanceVariableNames: 'history isPreviewVisible wasOpened'!

!GTSpotter class methodsFor: 'cleanup' stamp: 'TudorGirba 1/9/2016 23:15'!
cleanUp
	self resetHistory.
	wasOpened := false! !

!GTSpotter class methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/29/2015 02:52'!
dontShowPreview

	isPreviewVisible := false! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleInWindow
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: self new;
		openInWindow! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleMC
	"self exampleMC"
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: (self on: MCWorkingCopy allManagers);
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'example' stamp: 'StefanReichhart 10/17/2015 11:53'!
exampleSpotterWithoutMorph
	<gtExample>
	<label: 'A GTSpotter without UI'>
	
	^ self new! !

!GTSpotter class methodsFor: 'example' stamp: 'TudorGirba 2/19/2015 23:52'!
exampleWithPreview
	^ GTSpotterMorph new
		extent: (World width / 2.5 @ (World height / 1.5)) asIntegerPoint;
		spotterModel: self new;
		showPreview;
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleWorldMenu
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: (self on: World worldMenu);
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'example' stamp: 'AndreiChis 9/24/2015 19:10'!
gtExamplesProvider

	^ GTSpotterExamples ! !

!GTSpotter class methodsFor: 'inspecting' stamp: 'TudorGirba 11/27/2014 06:57'!
gtInspectorExtensionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Extensions';
		display: [ self spotterExtendingMethods ];
		showOnly: 50;
		format: [ :each | each gtDisplayString ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!GTSpotter class methodsFor: 'accessing' stamp: 'TudorGirba 12/1/2014 23:59'!
history
	^ history ifNil: [ history := WeakOrderedCollection new ]! !

!GTSpotter class methodsFor: 'testing' stamp: 'AliakseiSyrel 1/29/2015 02:53'!
isPreviewVisible

	^ isPreviewVisible ifNil: [ isPreviewVisible := false ]! !

!GTSpotter class methodsFor: 'accessing' stamp: 'AndreiChis 3/18/2015 15:50'!
markOpened

	wasOpened := true! !

!GTSpotter class methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 16:37'!
on: anObject
	
	^ self new foundationOrigin: anObject! !

!GTSpotter class methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 10:34'!
resetHistory
	"
	self resetHistory
	"
	^ history := nil! !

!GTSpotter class methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/29/2015 02:57'!
showPreview

	isPreviewVisible := true! !

!GTSpotter class methodsFor: 'inspecting' stamp: 'TudorGirba 11/27/2014 06:57'!
spotterExtendingMethods
	^(Object withAllSubclasses
		flatCollect: [ :each | 
			(Pragma allNamed: #spotterOrder: in: each) 
				collect: [ :p | p method asRingDefinition ] ])
		sorted! !

!GTSpotter class methodsFor: 'testing' stamp: 'AndreiChis 3/18/2015 15:50'!
wasOpened

	^ wasOpened ifNil: [ false ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:03'!
addStep: aStepModel

	self steps add: aStepModel.
	self notifyStepAdded: aStepModel! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:32'!
after: afterBlock do: doBlock ifTrue: conditionBlock
	|value|
	value := conditionBlock brickValue: self.
	afterBlock brickValue: self.
	value ifTrue: [ doBlock brickValue: value ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:30'!
after: afterBlock do: doBlock with: withBlock
	|value|
	value := withBlock brickValue: self.
	afterBlock brickValue: self.
	doBlock brickValue: value! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 1/25/2015 19:15'!
announce: anAnnouncement
	
	self announcer announce: anAnnouncement! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
announcer

	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotter methodsFor: 'accessing-convenience' stamp: 'StefanReichhart 4/1/2015 19:39'!
beDebugging
	self exceptionHandler: GTSpotterDebuggingExceptionHandler new! !

!GTSpotter methodsFor: 'accessing-convenience' stamp: 'StefanReichhart 4/1/2015 19:39'!
beDeployment
	self exceptionHandler: GTSpotterDeploymentExceptionHandler new! !

!GTSpotter methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 11:33'!
currentStep
	
	^ currentStep ifNil: [ 
			self isEmpty 
				ifTrue: [ self newStep origin: self foundationOrigin ]
				ifFalse: [ currentStep := self steps last ] ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 15:34'!
currentStep: aStepModel
	
	currentStep := aStepModel.
	self notifyCurrentStepChanged! !

!GTSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 18:32'!
defaultExceptionHandler
	^ GTSpotterDeploymentExceptionHandler new! !

!GTSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 16:44'!
defaultPagerModel
	^ GLMPagerModel new! !

!GTSpotter methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 14:30'!
defaultStep
	^ GTSpotterStep new! !

!GTSpotter methodsFor: 'accessing' stamp: 'StefanReichhart 3/17/2015 15:30'!
exceptionHandler
	^ exceptionHandler ifNil: [ exceptionHandler := self defaultExceptionHandler ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'StefanReichhart 3/17/2015 15:14'!
exceptionHandler: anObject
	exceptionHandler := anObject! !

!GTSpotter methodsFor: 'actions api' stamp: 'AndreiChis 3/20/2015 19:36'!
exit

	self exitDueTo: #unknown! !

!GTSpotter methodsFor: 'actions api' stamp: 'AndreiChis 3/20/2015 19:38'!
exitDueTo: anEventType

	self notifySpotterExitFor: anEventType! !

!GTSpotter methodsFor: 'filtering' stamp: 'AndreiChis 9/24/2015 18:54'!
filterByMethods: aCollection
	| filter |
	
	filter := GTSpotterMethodListProcessorFilter new.
	aCollection  do: [ :aMethod |
		filter allowProcessorsFrom: aMethod ].
	self processorsFilter: filter
		! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 17:12'!
foundationOrigin
	
	^ foundationOrigin ifNil: [ foundationOrigin := self ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 16:36'!
foundationOrigin: anObject
	
	foundationOrigin := anObject! !

!GTSpotter methodsFor: 'model access' stamp: 'AliaskeiSyrel 11/13/2014 21:22'!
getText

	^ self text! !

!GTSpotter methodsFor: 'printing' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
gtDisplayOn: stream

	stream nextPutAll: 'Spotter'! !

!GTSpotter methodsFor: 'printing' stamp: 'AndreiChis 9/24/2015 19:31'!
gtDisplaySpotterMorphOn: aComposite
	<gtInspectorPresentationOrder: 50>
	
	aComposite morph 
		title: 'Live';
		display: [ 
			GLMBrick new 
				hSpaceFill;
				vSpaceFill;
				addMorphBack: 
					(GTSpotterMorph new
						spotterModel: self);
				yourself ]! !

!GTSpotter methodsFor: 'inspecting' stamp: 'TudorGirba 4/10/2015 10:51'!
gtInspectorStepsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Steps';
		display: [ self steps ];
		when: [ self steps notEmpty ]! !

!GTSpotter methodsFor: 'event handling' stamp: 'StefanReichhart 3/18/2015 14:23'!
handleExceptionsDuring: aBlock
	self exceptionHandler handleExceptionsDuring: aBlock! !

!GTSpotter methodsFor: 'testing' stamp: 'AndreiChis 7/8/2015 14:38'!
hasMultipleSteps

	^ self steps size > 1! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:01'!
hidePreview

	self isPreviewVisible ifFalse: [ ^ self ].
	isPreviewVisible := false.
	self class dontShowPreview.
	self notifyHidePreview
	! !

!GTSpotter methodsFor: 'actions api' stamp: 'TudorGirba 4/10/2015 13:23'!
historize: target

	(target = self or: [ target isNil ])
		ifFalse: [ 
			self history removeAllSuchThat: [ :each | each value = target value ] .
			self history addFirst: target ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'TudorGirba 4/10/2015 13:23'!
history
	^ history ifNil: [ self class history ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'TudorGirba 4/10/2015 13:23'!
history: aWeakCollection
	history := aWeakCollection! !

!GTSpotter methodsFor: 'initialization' stamp: 'AndreiChis 7/7/2015 16:09'!
initialize
	super initialize.
	
	processorsFilter := GTSpotterNullProcessorFilter new! !

!GTSpotter methodsFor: 'testing' stamp: 'AliaskeiSyrel 11/13/2014 20:41'!
isEmpty

	^ self steps isEmpty! !

!GTSpotter methodsFor: 'testing' stamp: 'AliakseiSyrel 1/26/2015 15:51'!
isPreviewVisible

	^ isPreviewVisible ifNil: [ isPreviewVisible := false ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/19/2015 10:53'!
isShiftPressed

	^ isShiftPressed ifNil: [ isShiftPressed := false ]! !

!GTSpotter methodsFor: 'protocol' stamp: 'AliakseiSyrel 2/24/2015 12:06'!
menu

	^ nil! !

!GTSpotter methodsFor: 'instance creation' stamp: 'StefanReichhart 3/12/2015 14:30'!
newStep

	^ self defaultStep
		spotter: self! !

!GTSpotter methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 18:35'!
notifyActOn: anObject for: anEventType

	self announce: (GTSpotterActOn new 
		element: anObject;
		eventType: anEventType)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 19:09'!
notifyCandidateSelected: anObject for: anEventType

	self announce: (GTSpotterSelectedCandidateChanged new 
		selected: anObject;
		eventType: anEventType)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:27'!
notifyCategorySelected: aProcessor

	self announce: (GTSpotterCategorySelected new category: aProcessor)! !

!GTSpotter methodsFor: 'notifying' stamp: 'StefanReichhart 2/28/2015 19:39'!
notifyContextChangedFrom: aPreviousContext to: aCurrentContext
	self announce: (GTSpotterContextChanged new
		previous: aPreviousContext;
		current: aCurrentContext;
		yourself)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:04'!
notifyCurrentStepChanged

	self announce: GTSpotterCurrentStepChanged new! !

!GTSpotter methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 18:42'!
notifyDiveIn: anObject for: anEventType

	self announce: (GTSpotterDiveInElement new 
		element: anObject;
		eventType: anEventType )! !

!GTSpotter methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 18:29'!
notifyDiveInCategory: aProcessor for: anEventType

	self announce: (GTSpotterDiveInCategory new 
		category: aProcessor;
		eventType: anEventType)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:04'!
notifyDiveOut: anObject

	self announce: (GTSpotterDiveOut new element: anObject)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/27/2015 23:17'!
notifyHideHints

	self announce: GTSpotterHideHints new! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
notifyHidePreview

	self announce: GTSpotterHidePreview new! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/27/2015 23:17'!
notifyRevealHints

	self announce: GTSpotterRevealHints new! !

!GTSpotter methodsFor: 'notifying' stamp: 'JurajKubelka 3/6/2015 16:35'!
notifySearchFinishedFor: aString processors: aCollectionOfProcessors

	self announce: (GTSpotterSearchFinished new 
								query: aString;
								processors: aCollectionOfProcessors;
								yourself)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
notifyShowPreview

	self announce: GTSpotterShowPreview new

	! !

!GTSpotter methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 19:38'!
notifySpotterExitFor: anEventType

	self announce: (GTSpotterExitAnnouncement new
		eventType: anEventType)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
notifyStepAdded: aStep

	self announce: (GTSpotterStepAdded new stepModel: aStep)! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/24/2015 12:05'!
notifyStepPopped

	self announce: GTSpotterStepPopped new! !

!GTSpotter methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/15/2014 16:21'!
onPagePopped
	
	self steps size > 0 ifTrue: [
		self currentStep: self steps last ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
pagerModel

	^ pagerModel ifNil: [
		pagerModel := self defaultPagerModel defaultNumberOfVisiblePages: 1.
		pagerModel announcer when: GLMPagePoped send: #onPagePopped to: self.
		pagerModel ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:12'!
popStep

	"there always should be minimum one step left"
	(self steps size > 1)
		ifTrue: [
			self
				after: [ self steps removeLast ]
				do: [ :o | self notifyDiveOut: o ]
				with: self currentStep origin.
			self notifyStepPopped.
			"perform pane popping only after we scrolled to the penultimate pane, so user doesn't see blinking"
			self pagerModel
				scrollToPane: self steps size
				callback: [ self pagerModel popPane: false ] ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/18/2015 14:18'!
popUntil: aStep

	[ self steps last = aStep ]
		whileFalse: [ self popStep ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AndreiChis 7/7/2015 16:08'!
processorsFilter

	^ processorsFilter! !

!GTSpotter methodsFor: 'accessing' stamp: 'AndreiChis 7/7/2015 16:40'!
processorsFilter: aFilter
   "Set the filter for determining whether or not processors get added to a step."

	processorsFilter := aFilter! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 11/15/2014 15:40'!
pushStep: stepModel
	
	self addStep: stepModel.
	"updating current step"
	self currentStep: stepModel! !

!GTSpotter methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/24/2015 12:21'!
requestNextCategoryStepWith: aProcessorLink
	|collection|
	
	collection := aProcessorLink processor allFilteredCandidates
		collect: [ :each | each asSpotterCandidateLink renderingProcessor: aProcessorLink ].
		
	self requestNextStepWith: collection! !

!GTSpotter methodsFor: 'event handling' stamp: 'AliakseiSyrel 2/24/2015 12:04'!
requestNextStepWith: origin

	text := ''.
	self pushStep: (self newStep origin: origin; yourself).
	self steps last process: nil! !

!GTSpotter methodsFor: 'model access' stamp: 'AndreiChis 7/30/2015 17:34'!
setText: aText from: aView
	"I am the main entry point for triggering a new search in the current step."
	
	self steps isEmpty
		"by default there are no steps, so we need to create one based on foundation origin"
		ifTrue: [ self addStep: ( self newStep origin: self foundationOrigin ) ].

	(aText asString isEmpty and: [ self text isEmpty not ])
		ifTrue: [ self currentStep process: nil ]
		ifFalse: [ self currentStep process: aText asString ].
	
	text := aText asString asText.
	^ true! !

!GTSpotter methodsFor: 'actions api' stamp: 'TudorGirba 3/30/2015 22:27'!
shiftPressed: aBoolean

	self isShiftPressed = aBoolean ifTrue: [ ^ self ].
	
	isShiftPressed := aBoolean.
	
	SmalltalkImage current vm canHandleShiftPressed
		ifTrue: [ ^ isShiftPressed := false ].

	self isShiftPressed
		ifTrue: [ self notifyRevealHints ]
		ifFalse: [ self notifyHideHints ]

	! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 2/24/2015 12:02'!
showPreview

	self isPreviewVisible ifTrue: [ ^ self ].
	isPreviewVisible := true.
	self class showPreview.
	self notifyShowPreview
	! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 21:20'!
steps

	^ steps ifNil: [ steps := OrderedCollection new ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 11/21/2014 23:50'!
terminateProcessors

	self steps do: [ :each | each terminateProcessors ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 21:21'!
text

	^ text ifNil: [ text := '' asText ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 1/26/2015 15:53'!
togglePreview

	self isPreviewVisible
		ifTrue: [ self hidePreview ]
		ifFalse: [ self showPreview ]! !

Object subclass: #GTSpotterCandidatesList
	instanceVariableNames: 'categories candidates announcer processorLinksMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterCandidatesList commentStamp: 'TudorGirba 11/26/2014 15:08' prior: 0!
A model utility class that provides a way to handle the list of candidates shown in the spotter result.

The candidates are stored in a linked list.!

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'TudorGirba 11/28/2014 11:47'!
addAllCandidates: aCollection in: aProcessor
	| allLinks |
	allLinks := OrderedCollection new.
	aCollection
		do: [ :each | 
			| processorLink candidateLink |
			processorLink := self getProcessorLink: aProcessor.
			candidateLink := each asSpotterCandidateLink processorLink: processorLink.	"if head is nil, it means there are no candidates yet"
			candidateLink := processorLink isEmpty
				ifTrue: [ self privateAddCandidate: candidateLink inEmpty: processorLink ]
				ifFalse: [ self privateAddCandidate: candidateLink inNotEmpty: processorLink ].
			self updateCycleConnectionFor: candidateLink.
			allLinks add: candidateLink ].
	self announcer announce:
			(GTSpotterAllCandidatesAdded new
				candidateLinks: allLinks;
				category: aProcessor;
				yourself)! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/24/2014 22:24'!
addCandidate: anObjectOrLink in: aProcessor
	"before adding candidates we need to define all categories, because their order is important"
	|processorLink candidateLink|
	
	"processorLink is DoubleLink"
	processorLink := self getProcessorLink: aProcessor.
	
	candidateLink := anObjectOrLink asSpotterCandidateLink processorLink: processorLink.
	
	"if head is nil, it means there are no candidates yet"
	candidateLink := (processorLink isEmpty)
		ifTrue: [ self privateAddCandidate: candidateLink inEmpty: processorLink ]
		ifFalse: [ self privateAddCandidate: candidateLink inNotEmpty: processorLink ].
		
	self updateCycleConnectionFor: candidateLink.
	
	self notifyCandidateAdded: candidateLink in: aProcessor.
	
	^ candidateLink
	! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/29/2014 14:28'!
addProcessor: aProcessor
	|processorLink|
	
	processorLink := aProcessor asSpotterProcessorLink.
	"linking processor with it's link"
	self processorLinksMap add: (aProcessor -> processorLink).
	self processors addLast: processorLink.
	
	^ processorLink! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 21:33'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
candidates

	^ candidates ifNil: [ candidates := GTSpotterDoubleLinkedList new ]! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:35'!
getCandidateLink: aCandiate in: aProcessor
	"returns a corresponding candidateLink, that belongs to a processor"
	(self getCandidateLinks: (self getProcessorLink: aProcessor))
		do: [ :each | each value = aCandiate ifTrue: [ ^ each ] ].
	
	^ nil
	! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:36'!
getCandidateLinks: aProcessorLink
	"returns all candidate links that belongs to a processor link"
	|list head tail current|
	
	head := aProcessorLink headLink.
	tail := aProcessorLink tailLink.
	
	list := OrderedCollection new.
	head ifNil: [ ^ list ].
	(head = tail) ifTrue: [ list add: head. ^ list ].
	
	current := head.
	
	[ current = tail ] whileFalse: [
		list add: current.
		current := current nextLink ].
	"adding last one"
	list add: current.
	
	^ list
	! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:28'!
getProcessorLink: aProcessor

	^ self processorLinksMap at: aProcessor ifAbsent: [ nil ]! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:38'!
getProcessorLinkByCandidateLink: aCandidateLink

	^ aCandidateLink processorLink! !

!GTSpotterCandidatesList methodsFor: 'testing' stamp: 'AliakseiSyrel 2/25/2015 14:28'!
hasOnlyOneItem

	self isEmpty ifTrue: [ ^ self ].
	^ self head = self tail! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/14/2014 15:54'!
head

	^ self candidates head! !

!GTSpotterCandidatesList methodsFor: 'testing' stamp: 'AliakseiSyrel 11/14/2014 15:49'!
isEmpty

	^ self candidates isEmpty! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
nextProcessorLinkOf: aProcessorLink
	"returns next processor link, that has more than zero candidates.
	if passed processor is the last one, will continue searching from the beginning"
	|current|
	aProcessorLink ifNil: [ ^ aProcessorLink ].
	
	current := aProcessorLink nextLink.
	current ifNil: [ current := self processors head ].
	
	[ current = aProcessorLink ] whileFalse: [
		(current isEmpty) ifFalse: [ ^ current ].
		current := current nextLink.
		current ifNil: [ current := self processors head ].
	].

	^ aProcessorLink
	! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'AliakseiSyrel 11/29/2014 14:40'!
notifyAllCandidatesRemoved

	self announcer announce: (GTSpotterAllCandidatesRemoved new)! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyAmountChanged: anInteger in: aProcessor
	
	self announcer announce: (GTSpotterCandidatesAmountChanged new amount: anInteger; category: aProcessor; yourself)! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyCandidateAdded: aCandidateLink in: aProcessor

	self announcer announce: (GTSpotterCandidateAdded new candidateLink: aCandidateLink; category: aProcessor; yourself).! !

!GTSpotterCandidatesList methodsFor: 'stream handling' stamp: 'TudorGirba 11/26/2014 14:34'!
onAmountChanged: anInteger in: aProcessor
	
	self announcer announce: (GTSpotterCandidatesAmountChanged new amount: anInteger; category: aProcessor; yourself)! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
previousProcessorLinkOf: aProcessorLink
	"returns previous processor link, that has more than zero candidates.
	if passed processor is the first one, will continue searching from the end"
	|current|
	aProcessorLink ifNil: [ ^ aProcessorLink ].
	
	current := aProcessorLink previousLink.
	current ifNil: [ current := self processors tail ].
	
	[ current = aProcessorLink ] whileFalse: [
		(current isEmpty) ifFalse: [ ^ current ].
		current := current previousLink.
		current ifNil: [ current := self processors tail ].
	].

	^ aProcessorLink
	! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:31'!
privateAddCandidate: aCandidateLink inEmpty: aProcessorLink
	| head current |
		
	current := aProcessorLink.	"not nil"
	head := nil.						"nil"
	[ head isNil and: [ current isNotNil ]] whileTrue: [	
		current := current nextLink.	"next category"
		"head of next category if not nil break loop"
		current ifNotNil: [ head := current headLink ] ifNil: [ nil ] ].
	
	"means all next categories are empty, just add to the end"
	current
		ifNil: [ self candidates addLast: aCandidateLink ]
		ifNotNil: [ self candidates add: aCandidateLink beforeLink: head ].
		aProcessorLink
			headLink: aCandidateLink;
			tailLink: aCandidateLink.
			
		aProcessorLink incrementSize.
		
	^ aCandidateLink! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 23:31'!
privateAddCandidate: aCandidateLink inNotEmpty: aProcessorLink
	
	"aCandidateLink weight
		ifNotNil: [ ^ self privateAddCandidate: aCandidateLink weightedIn: aProcessorLink ]."
	
	self candidates add: aCandidateLink afterLink: (aProcessorLink tailLink).
	aProcessorLink incrementSize.
	"updating category tail"
	aProcessorLink tailLink: aCandidateLink.
	^ aCandidateLink! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:36'!
privateAddCandidate: aCandidateLink weightedIn: aProcessorLink

	^ aProcessorLink isFull
		ifTrue: [ self privateAddCandidate: aCandidateLink weightedInFull: aProcessorLink ]
		ifFalse: [ self privateAddCandidate: aCandidateLink weightedInNotFull: aProcessorLink ]! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:34'!
privateAddCandidate: aCandidateLink weightedInFull: aProcessorLink

	! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:54'!
privateAddCandidate: aCandidateLink weightedInNotFull: aProcessorLink
	|head tail|
	
	head := aProcessorLink headLink.
	tail := aProcessorLink tailLink.

	"fast check if we need to add it before first"
	(aCandidateLink weight > head weight)
		ifTrue: [ head := self candidates add: aCandidateLink beforeLink: head ]
		ifFalse: [
	"fast check if we need to add it after the last"
	(aCandidateLink weight > tail weight)
		ifFalse: [ tail := self candidates add: aCandidateLink afterLink: tail ]
		ifTrue: [  ] ]! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/9/2014 13:51'!
processorLinksMap

	^ processorLinksMap ifNil: [ processorLinksMap := Dictionary new ]
	! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
processors

	^ categories ifNil: [ categories := GTSpotterDoubleLinkedList new ].! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/29/2015 01:39'!
removeAllCandidates

	self processors linksDo: [ :each | each clear ].
	self candidates removeAll.
	self notifyAllCandidatesRemoved! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/29/2014 14:41'!
removeAllCandidatesOf: aProcessor
	|processorLink head tail current|
	
	processorLink := self getProcessorLink: aProcessor.
	
	(processorLink isEmpty) ifTrue: [ ^ self ].
	
	head := processorLink headLink.
	tail := processorLink tailLink.
		
	(head = tail) ifTrue: [
		self candidates removeCycledLink: head.
		processorLink clear. ].
	
	current := head.
	[ current = tail ] whileFalse: [ |nextCurrent|
		nextCurrent := current nextLink.
		self candidates removeCycledLink: current.
		current := nextCurrent ].
	
	self candidates removeCycledLink: current.
	
	processorLink clear.
	
	
	
	
	
	! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/15/2014 13:08'!
tail

	^ self candidates tail! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:53'!
updateCycleConnectionFor: aCandidateLink

	"if link is the last setting nextLink to head"
	(self candidates tail = aCandidateLink) ifTrue: [
		aCandidateLink nextLink: self candidates head.
		self candidates head previousLink: aCandidateLink ].
	
	"if link is the first setting previousLink to tail"
	(self candidates head = aCandidateLink) ifTrue: [
		aCandidateLink previousLink: self candidates tail.
		self candidates tail nextLink: aCandidateLink ].! !

Object subclass: #GTSpotterContext
	instanceVariableNames: 'step stream text textTrimmed textLowercase processor cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 13:48'!
addItem: anObject
	self stream addObject: anObject inProcessor: self processor! !

!GTSpotterContext methodsFor: 'public' stamp: 'AliakseiSyrel 2/26/2015 00:56'!
addItems: aCollection

	self stream addObjects: aCollection inProcessor: self processor! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 15:27'!
cache
	^ cache ifNil: [ cache := self defaultCache ]! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 15:27'!
cache: anObject
	cache := anObject! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 15:28'!
cacheAt: aSymbol
	^ self cacheAt: aSymbol ifAbsent: [ nil ]! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 15:39'!
cacheAt: aSymbol ifAbsent: aBlock
	^ self cache at: aSymbol ifAbsent: aBlock! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 15:39'!
cacheAt: aSymbol ifAbsentPut: aBlock
	^ self cache at: aSymbol ifAbsentPut: aBlock! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 3/20/2015 16:52'!
cacheAt: aSymbol put: anObject
	^ self cache at: aSymbol put: anObject! !

!GTSpotterContext methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 15:28'!
defaultCache
	^ IdentityDictionary new ! !

!GTSpotterContext methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 10:57'!
defaultText
	^ ''! !

!GTSpotterContext methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 15:46'!
defaultTextLowercase
	^ self textTrimmed asLowercase! !

!GTSpotterContext methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 2/24/2015 12:35'!
defaultTextTrimmed
	^ self text trimBoth! !

!GTSpotterContext methodsFor: 'comparing' stamp: 'AndreiChis 2/28/2015 18:36'!
equals: aContext
	aContext ifNil: [ ^ false ].
   ^ self matches: aContext text! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 4/1/2015 09:56'!
exceptionHandler
	self flag: 'Bloc -> overrides doesNotUnderstand discarding the current exception context'.
	^ GTCurrentSpotterExceptionHandler value ifNil: [ self step exceptionHandler ]! !

!GTSpotterContext methodsFor: 'testing' stamp: 'StefanReichhart 2/24/2015 11:04'!
isEmpty
	^ self text isNil
		or: [ self text isEmpty ]! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 22:00'!
itemsLimit
	^ self processor itemsLimit! !

!GTSpotterContext methodsFor: 'testing' stamp: 'StefanReichhart 2/24/2015 11:04'!
matches: aString
	^ self isEmpty not
		and: [ self text = aString ]! !

!GTSpotterContext methodsFor: 'testing' stamp: 'StefanReichhart 2/24/2015 11:06'!
notEmpty
	^ self isEmpty not! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:45'!
processor
	^ processor! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 13:45'!
processor: anObject
	processor := anObject! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 3/20/2015 16:58'!
removeCacheAt: aSymbol
	^ self cache removeKey: aSymbol ifAbsent: [ nil ]! !

!GTSpotterContext methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/18/2015 13:56'!
spotter
	^ self step spotter! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 11:33'!
step
	^ step! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 11:33'!
step: anObject
	step := anObject! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 12:01'!
stream
	^ stream! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 12:01'!
stream: anObject
	stream := anObject! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 12:35'!
text
	^ text ifNil: [ text := self defaultText ]! !

!GTSpotterContext methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 10:57'!
text: anObject
	text := anObject! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 15:45'!
textLowercase
	^ textLowercase ifNil: [ textLowercase := self defaultTextLowercase ]! !

!GTSpotterContext methodsFor: 'public' stamp: 'StefanReichhart 2/24/2015 12:35'!
textTrimmed
	^ textTrimmed ifNil: [ textTrimmed := self defaultTextTrimmed ]! !

Object subclass: #GTSpotterExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterExamples commentStamp: 'AndreiChis 9/24/2015 19:54' prior: 0!
I provide examples for the class GTSpotter as class side methods.

!

!GTSpotterExamples class methodsFor: 'examples - basic' stamp: 'AndreiChis 9/24/2015 19:48'!
gtExampleBasic
	<gtExample>
	<label: 'Basic Spotter object'>
	^ GTSpotter new! !

!GTSpotterExamples class methodsFor: 'examples - filtering' stamp: 'AndreiChis 9/24/2015 23:49'!
gtExampleCustomImplementorsSearchOn: aSpotter
	<gtExample>
	<label: 'Custom implementors search'>
	<description: 'A spotter for searching through the implementors of a 
	method that overrides properties of the search step.'>
	<depends: #gtExampleOnCompliedMethod>
	
	^ aSpotter
		processorsFilter: (GTSpotterMethodListProcessorFilter new 
			allowProcessorsFrom: CompiledMethod>>#spotterForImplementorsFor: 
			configuredWith: [ :aProcessor | aProcessor
				actLogic: [ :aMethod :step | 
					step exit.
					aMethod inform: aMethod name ];
				candidatesLimit: 50 ])! !

!GTSpotterExamples class methodsFor: 'examples - filtering' stamp: 'AndreiChis 9/24/2015 23:50'!
gtExampleCustomImplementorsSearchWithNavigationOn: aSpotter
	<gtExample>
	<label: 'Custom implementors search with navigation'>
	<description: 'A spotter for searching through the implementors of a method that 
	overrides properties of the search step and enables the Collection 
	processor for items (to allow dive in).'>
	<depends: #gtExampleOnCompliedMethod>
	
	^ aSpotter
		processorsFilter: (GTSpotterMethodListProcessorFilter new 
			allowProcessorsFrom: Collection>>#spotterItemsFor:;
			allowProcessorsFrom: CompiledMethod>>#spotterForImplementorsFor: 
			configuredWith: [ :aProcessor | aProcessor
				actLogic: [ :aMethod :step | 
					step exit.
					aMethod inform: aMethod name ];
				candidatesLimit: 50 ])! !

!GTSpotterExamples class methodsFor: 'examples - filtering' stamp: 'AndreiChis 9/24/2015 23:49'!
gtExampleHelpSearchOn: aSpotter
	<gtExample>
	<label: 'Help search'>
	<description: 'A spotter for searching through help pages.'>
	<depends: #gtExampleBasic>
	
	^ aSpotter
		filterByMethods: {
			GTSpotter>>#spotterForHelpTopicFor:.
			HelpTopic>>#spotterForHelpTopicFor:}! !

!GTSpotterExamples class methodsFor: 'examples - filtering' stamp: 'AndreiChis 9/24/2015 23:49'!
gtExampleImplementorsSearchOn: aSpotter
	<gtExample>
	<label: 'Implementors search on single method'>
	<description: 'A spotter for searching through the implementors of a method.'>
	<depends: #gtExampleOnCompliedMethod>
	
	^ aSpotter
		filterByMethods: {
			CompiledMethod>>#spotterForImplementorsFor:}! !

!GTSpotterExamples class methodsFor: 'examples - basic' stamp: 'AndreiChis 9/24/2015 19:48'!
gtExampleOnCompliedMethod
	<gtExample>
	<label: 'Spotter on compiled method'>
	^ GTSpotter on: Object>>#copy! !

!GTSpotterExamples class methodsFor: 'examples - basic' stamp: 'AndreiChis 9/24/2015 19:49'!
gtExampleWithOneStepFrom: aSpotter
	<gtExample>
	<label: 'Spotter object with one step'>
	<depends: #gtExampleBasic>
	| step |
	step := GTSpotterStep new spotter: aSpotter.
	aSpotter steps add: step.
	aSpotter currentStep: step.
	^ aSpotter! !

!GTSpotterExamples class methodsFor: 'examples - filtering' stamp: 'AndreiChis 9/24/2015 23:49'!
gtExampleWorldMenuSearchOn: aSpotter
	<gtExample>
	<label: 'World menu search'>
	<description: 'A spotter for searching through the world menu'>
	<depends: #gtExampleBasic>

	^ aSpotter
		filterByMethods: {
			GTSpotter>>#spotterWorldMenuFor:}
	
	! !

!GTSpotterExamples class methodsFor: 'examples' stamp: 'AndreiChis 9/24/2015 19:11'!
gtExamplesSource
	^ GTSpotter! !

Object subclass: #GTSpotterExceptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Exceptions'!

GTSpotterExceptionHandler subclass: #GTSpotterDebuggingExceptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Exceptions'!

!GTSpotterDebuggingExceptionHandler methodsFor: 'public' stamp: 'StefanReichhart 3/17/2015 15:36'!
handleException: anException do: aBlock
	anException pass.
	^ super handleException: anException do: aBlock.
	
	! !

GTSpotterExceptionHandler subclass: #GTSpotterDeploymentExceptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Exceptions'!

!GTSpotterExceptionHandler methodsFor: 'public' stamp: 'StefanReichhart 3/17/2015 16:01'!
handleException: anException
	^ self handleException: anException do: [ 
		('[Spotter] Exception: ', anException asString) logCr ]! !

!GTSpotterExceptionHandler methodsFor: 'public' stamp: 'StefanReichhart 3/17/2015 16:00'!
handleException: anException do: aBlock
	^ aBlock value! !

!GTSpotterExceptionHandler methodsFor: 'public' stamp: 'StefanReichhart 3/17/2015 15:42'!
handleException: anException with: anObject
	^ self handleException: anException do: [ anObject ]! !

!GTSpotterExceptionHandler methodsFor: 'handling' stamp: 'StefanReichhart 3/22/2015 18:58'!
handleExceptionsDuring: aBlock
	[ GTCurrentSpotterExceptionHandler use: self during: aBlock ] 
		on: self 
		do: [ :exception | 
			[ self handleException: exception ] " handle any exception during aBlock "
				on: Error
				do: [ :fatalException | self handleFatalException: fatalException ] ] " handle exception caused while handling an exception "! !

!GTSpotterExceptionHandler methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 18:58'!
handleFatalException: anException
	('[Spotter] Fatal Exception: ', anException asString) logCr! !

Object subclass: #GTSpotterIterator
	instanceVariableNames: 'context items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Iterators'!

GTSpotterIterator subclass: #GTSpotterBlockIterator
	instanceVariableNames: 'onDo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Iterators'!

!GTSpotterBlockIterator methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 15:47'!
itemDo: aBlock 
	self onDo 
		cull: aBlock
		cull: self context ! !

!GTSpotterBlockIterator methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 15:49'!
onDo
	^ onDo ifNil: [ onDo := [ :anItemBlock :aContext | " do nothing " ] ]! !

!GTSpotterBlockIterator methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 11:06'!
onDo: anObject
	onDo := anObject! !

!GTSpotterIterator class methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 11:21'!
gtIterator
	^ self new! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 23:00'!
allSatisfy: aBlock
	self do: [ :each | (aBlock value: each) ifFalse: [ ^ false ] ].
	^ true! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 23:00'!
anySatisfy: aBlock
	self do: [ :each | (aBlock value: each) ifTrue: [ ^ true ] ].
	^ false! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/20/2015 16:04'!
asArray
	^ self items asArray! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/22/2015 22:39'!
asOrderedCollection
	^ self items copy " we must not expose the internal representation !! "! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/22/2015 22:47'!
asSet
	^ self items asSet! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:57'!
collect: aBlock
	^ self collect: aBlock as: self defaultItemsClass! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:53'!
collect: aBlock as: aCollectionClass
	| collection |
	collection := self newAs: aCollectionClass.
	self do: [ :each | 
		collection add: (aBlock value: each) ].
	^ collection! !

!GTSpotterIterator methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 15:11'!
context
	^ context! !

!GTSpotterIterator methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 22:22'!
context: aContext
	" we assume that if the context changes, so will the result of the iterator - so we reset the internal collection "
	context := aContext.
	self reset.! !

!GTSpotterIterator methodsFor: 'public' stamp: 'StefanReichhart 3/20/2015 15:18'!
cull: aContext
	self context: aContext! !

!GTSpotterIterator methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 22:56'!
defaultItems
	^ self defaultItemsClass new ! !

!GTSpotterIterator methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 22:56'!
defaultItemsClass
	^ OrderedCollection ! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 23:02'!
detect: aBlock
	^ self detect: aBlock ifNone: [ NotFound signalFor: aBlock ]! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 23:04'!
detect: aBlock ifFound: aBlock2 ifNone: aBlock3
	self do: [ :each | aBlock value ifTrue: [ ^ aBlock2 value: each ] ].
	^ aBlock3 value! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 23:04'!
detect: aBlock ifNone: aBlock2
	^ self detect: aBlock ifFound: [ :each | each ] ifNone: aBlock2! !

!GTSpotterIterator methodsFor: 'mimic enumerating' stamp: 'StefanReichhart 3/22/2015 22:57'!
do: aBlock
	" the iterator must keep an internal collection of items being iterated. This guarantees that the iteration is not done multiple times in case somebody sends multiple subsequent messages like #size, #items or #first:. This will slightly decrease performance while iterating "
	items 
		ifNotNil: [ 
			items do: aBlock ]
		ifNil: [ 
			items := self defaultItems.
			self itemDo: [ :each | 
				items add: each.
				aBlock value: each ] ]! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/22/2015 22:29'!
first: anInteger
	^ self items copyFrom: 1 to: (self size min: (anInteger max: 0))! !

!GTSpotterIterator methodsFor: 'public' stamp: 'StefanReichhart 3/20/2015 11:19'!
gtIterator
	^ self! !

!GTSpotterIterator methodsFor: 'testing' stamp: 'StefanReichhart 3/20/2015 11:48'!
hasDynamicItems
	^ true! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/20/2015 13:14'!
isEmpty
	^ self items isEmpty! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/20/2015 16:01'!
isEmptyOrNil
	^ self items isEmptyOrNil! !

!GTSpotterIterator methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 15:41'!
itemDo: aBlock
	self subclassResponsibility! !

!GTSpotterIterator methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 22:57'!
items
	^ items ifNil: [ 
		items := self defaultItems.
		self itemDo: [ :each | 
			items add: each ] ]! !

!GTSpotterIterator methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 13:14'!
items: anObject
	items := anObject! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/22/2015 22:29'!
last: anInteger
	^ self items last: (self size min: (anInteger max: 0))! !

!GTSpotterIterator methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 22:49'!
newAs: aCollectionClass
	^ items 
		ifNil: [ aCollectionClass new ] 
		ifNotNil: [ aCollectionClass new: self size ]! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/22/2015 22:30'!
notEmpty
	^ self isEmpty not! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:59'!
reject: aBlock
	^ self reject: aBlock as: self defaultItemsClass! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:59'!
reject: aBlock as: aCollectionClass
	| collection |
	collection := self newAs: aCollectionClass.
	self do: [ :each | 
		(aBlock value: each) 
			ifFalse: [ collection add: each ] ].
	^ collection! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:58'!
reject: aBlock thenCollect: aBlock2 as: aCollectionClass
	| collection |
	collection := self newAs: aCollectionClass.
	self reject: aBlock thenDo: [ :each | 
		collection add: (aBlock2 value: each) ].
	^ collection! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:58'!
reject: aBlock thenDo: aBlock2
	self do: [ :each | 
		(aBlock value: each) 
			ifFalse: [ aBlock2 value: each ] ]! !

!GTSpotterIterator methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 22:22'!
reset
	items := nil.! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:57'!
select: aBlock
	^ self select: aBlock as: self defaultItemsClass! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:50'!
select: aBlock as: aCollectionClass
	| collection |
	collection := self newAs: aCollectionClass.
	self do: [ :each | 
		(aBlock value: each) 
			ifTrue: [ collection add: each ] ].
	^ collection! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:57'!
select: aBlock thenCollect: aBlock2
	^ self select: aBlock thenCollect: aBlock2 as: self defaultItemsClass! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:53'!
select: aBlock thenCollect: aBlock2 as: aCollectionClass
	| collection |
	collection := self newAs: aCollectionClass.
	self select: aBlock thenDo: [ :each | 
		collection add: (aBlock2 value: each) ].
	^ collection! !

!GTSpotterIterator methodsFor: 'mimic various enumerating' stamp: 'StefanReichhart 3/22/2015 22:50'!
select: aBlock thenDo: aBlock2
	self do: [ :each | 
		(aBlock value: each) 
			ifTrue: [ aBlock2 value: each ] ]! !

!GTSpotterIterator methodsFor: 'mimic collection' stamp: 'StefanReichhart 3/20/2015 12:59'!
size
	^ self items size! !

!GTSpotterIterator methodsFor: 'public' stamp: 'StefanReichhart 3/20/2015 15:18'!
value: aContext
	self context: aContext! !

!GTSpotterIterator methodsFor: 'mimic enumerating' stamp: 'StefanReichhart 3/23/2015 10:27'!
withIndexDo: aBlock
	| index |
	index := 0.
	self do: [ :each | aBlock cull: each cull: (index := index + 1) ]! !

Object subclass: #GTSpotterProcessor
	instanceVariableNames: 'allFilteredCandidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterProcessor commentStamp: 'TudorGirba 11/26/2014 15:12' prior: 0!
This is the abstract class that models a processor that is associated with a spotter category. It can spot items to be displayed in that category by reacting to a filter: message. !

GTSpotterProcessor subclass: #GTSpotterCandidatesProcessor
	instanceVariableNames: 'origin allCandidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterCandidatesProcessor commentStamp: 'TudorGirba 11/30/2014 22:12' prior: 0!
This processor adds the ability of computing and caching all possible candidates. It is useful when we know all candidates upfront.!

GTSpotterCandidatesProcessor subclass: #GTSpotterCandidatesListProcessor
	instanceVariableNames: 'allCandidatesBlock candidatesLimit queryMatchingBlock title itemNameBlock itemIconBlock actBlock wantsToDisplayOnEmptyQuery filterBlock itemFilterNameBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterCandidatesListProcessor commentStamp: 'TudorGirba 11/30/2014 22:12' prior: 0!
This is a candidates processor that can be parameterized via blocks.!

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/30/2015 08:37'!
actLogic
	^ actBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'AliakseiSyrel 11/21/2014 13:56'!
actLogic: aBlockWithTwoArguments

	actBlock := aBlockWithTwoArguments! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'AliakseiSyrel 11/21/2014 13:57'!
actOn: anObject for: aStep
	
	actBlock
		ifNil: [ super actOn: anObject for: aStep ]
		ifNotNil: [ actBlock cull: anObject cull: aStep ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 21:54'!
allCandidates: aBlockWithOneArgument
	self items: aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 22:03'!
candidatesLimit: anInteger
	self itemsLimit: anInteger! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 22:04'!
computeAllItemsIn: aContext
	^ allCandidatesBlock cull: aContext! !

!GTSpotterCandidatesListProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 22:06'!
defaultCandidatesLimit
	^ self defaultItemsLimit! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/22/2015 22:00'!
defaultItemsLimit
	^ 5! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'StefanReichhart 2/24/2015 17:04'!
doFilterInContext: aSpotterContext
	^ filterBlock gtFilter value: aSpotterContext! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/8/2015 13:11'!
filter
	^ filterBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'StefanReichhart 3/22/2015 21:56'!
filter: aGTFilterOrBlockWithOneArgument
	filterBlock := aGTFilterOrBlockWithOneArgument ! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'StefanReichhart 3/20/2015 18:24'!
filter: aGTFilter item: aGTSpotterIterator 
	self filter: aGTFilter.
	self items: aGTSpotterIterator gtIterator.
	! !

!GTSpotterCandidatesListProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 2/24/2015 22:44'!
filterUsing: aFilter
	self filter: aFilter! !

!GTSpotterCandidatesListProcessor methodsFor: 'testing' stamp: 'StefanReichhart 3/22/2015 17:15'!
hasDynamicItems
	^ allCandidatesBlock hasDynamicItems! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/20/2015 12:19'!
itemFilterName
	^ itemFilterNameBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'StefanReichhart 3/20/2015 12:46'!
itemFilterName: aBlockWithOneArgument
	itemFilterNameBlock := aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 12:18'!
itemFilterNameFor: anObject
	^ itemFilterNameBlock isNil
		ifTrue: [ super itemFilterNameFor: anObject ]
		ifFalse: [ itemFilterNameBlock cull: anObject ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/23/2015 11:18'!
itemIcon
	^ itemIconBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/21/2014 11:14'!
itemIcon: aBlockWithOneArgument
	itemIconBlock := aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'AliakseiSyrel 11/21/2014 13:33'!
itemIconFor: anObject
	^ itemIconBlock isNil
		ifTrue: [ super itemIconFor: anObject ]
		ifFalse: [ itemIconBlock cull: anObject ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/8/2015 13:11'!
itemName
	^ itemNameBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/17/2014 23:26'!
itemName: aBlockWithOneArgument
	itemNameBlock := aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'private' stamp: 'AliakseiSyrel 11/21/2014 13:34'!
itemNameFor: anObject
	^ itemNameBlock isNil
		ifTrue: [ super itemNameFor: anObject ]
		ifFalse: [ itemNameBlock cull: anObject ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'StefanReichhart 3/20/2015 11:44'!
items: aBlock
	allCandidatesBlock := aBlock! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 21:59'!
itemsLimit
	^ candidatesLimit ifNil: [ self defaultItemsLimit ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'StefanReichhart 3/22/2015 22:03'!
itemsLimit: anInteger
	candidatesLimit := anInteger! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:52'!
match: aBlockWithTwoArguments
	self filter: (GTFilterBlock new 
		matcher: aBlockWithTwoArguments;
		yourself)! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:49'!
matchAlike
	self filter: GTFilterAlike! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:51'!
matchRegex
	self filter: GTFilterRegex! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:51'!
matchString
	self filter: GTFilterStringMatch! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:45'!
matchSubstring
	self filter: GTFilterSubstring! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting-convenience' stamp: 'StefanReichhart 2/24/2015 22:48'!
matchSubstrings
	self filter: GTFilterSubstrings! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:23'!
title
	^ title ifNil: [ super title ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/26/2014 14:23'!
title: aString
	title := aString! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2014 22:42'!
wantsToDisplayOnEmptyQuery
	^ wantsToDisplayOnEmptyQuery ifNil: [ super wantsToDisplayOnEmptyQuery ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/25/2014 22:40'!
wantsToDisplayOnEmptyQuery: anObject
	wantsToDisplayOnEmptyQuery := anObject! !

!GTSpotterCandidatesProcessor class methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 11:06'!
on: anObject

	^ self new origin: anObject! !

!GTSpotterCandidatesProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 22:07'!
allCandidatesIn: aContext
	^ self allItemsIn: aContext! !

!GTSpotterCandidatesProcessor methodsFor: 'public' stamp: 'StefanReichhart 3/22/2015 22:01'!
allItemsIn: aContext

	^ allCandidates ifNil: [ allCandidates := (self computeAllItemsIn: aContext) copy ].! !

!GTSpotterCandidatesProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 22:05'!
candidatesLimit
	^ self itemsLimit! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 22:04'!
computeAllItemsIn: aContext

	^ OrderedCollection new
	! !

!GTSpotterCandidatesProcessor methodsFor: 'compatibility' stamp: 'StefanReichhart 3/22/2015 22:04'!
computeCandidatesIn: aContext

	^ self computeAllItemsIn: aContext! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'StefanReichhart 2/24/2015 17:04'!
doFilterInContext: aSpotterContext
	^ GTFilterBlock gtFilter value: aSpotterContext! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 12:19'!
itemFilterNameFor: anObject
	^ self itemNameFor: anObject! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'TudorGirba 11/27/2014 10:42'!
itemIconFor: anObject
	^ nil! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'TudorGirba 11/26/2014 14:19'!
itemNameFor: anObject
	^ anObject gtDisplayString! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 22:01'!
itemsLimit
	"Return the maximal number of elements that can be found during search.
	Default implementation returns infinity, so the number of element is not limited."
	^ Float infinity! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 09:19'!
origin

	^ origin! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/1/2014 20:13'!
origin: anObject

	origin := anObject! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/20/2015 11:48'!
prepareProcessorInContext: aContext
	super prepareProcessorInContext: aContext.
	
	self hasDynamicItems ifTrue: [ allCandidates := nil ]! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'TudorGirba 11/26/2014 14:34'!
render: anObject
	^ GTSpotterItemBrick new
		icon: (self itemIconFor: anObject);
		text: (self itemNameFor: anObject)! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:20'!
title
	^ 'undefined'! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'StefanReichhart 3/23/2015 18:36'!
actOn: anObject for: aStep
	anObject spotterActDefault: aStep! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'TudorGirba 11/24/2014 23:51'!
allFilteredCandidates
	^ allFilteredCandidates ifNil: [ allFilteredCandidates := OrderedCollection new ]! !

!GTSpotterProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/23/2015 00:25'!
basicFilterInContext: aSpotterContext
	
	self prepareProcessorInContext: aSpotterContext.
	(self shouldFilterInContext: aSpotterContext) ifTrue: [
		allFilteredCandidates := self doFilterInContext: aSpotterContext ].
	aSpotterContext stream 
		performSymbol: #onAmountChanged:in: 
		withArguments: { self allFilteredCandidates size . self }! !

!GTSpotterProcessor methodsFor: 'private' stamp: 'StefanReichhart 2/24/2015 17:04'!
doFilterInContext: aSpotterContext
	"override this method to:
	- add items to the stream
	- return all found items at the end"
	self subclassResponsibility! !

!GTSpotterProcessor methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 4/1/2015 09:56'!
exceptionHandler
	self flag: 'Bloc -> overrides doesNotUnderstand discarding the current exception context'.
	^ GTCurrentSpotterExceptionHandler value ifNil: [ GTSpotterExceptionHandlerNotFound signal ]! !

!GTSpotterProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/18/2015 14:56'!
filterInContext: aSpotterContext
	[ self basicFilterInContext: aSpotterContext ]
		on: Error 
		do: [ :exception | 
			self exceptionHandler 
				handleException: exception 
				do: [ ('[Spotter] Exception in processor <', self title asString, '>: ', exception asString) logCr ] ]! !

!GTSpotterProcessor methodsFor: 'printing' stamp: 'TudorGirba 4/10/2015 10:58'!
gtDisplayOn: stream
	stream 
		nextPutAll: 'Processor: ';
		nextPutAll: self title asString! !

!GTSpotterProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/8/2015 14:38'!
prepareProcessorInContext: aContext
	allFilteredCandidates := nil! !

!GTSpotterProcessor methodsFor: 'private' stamp: 'TudorGirba 11/26/2014 14:34'!
render: anObject
	^ GTSpotterItemBrick new
		icon: (nil);
		text: (anObject gtDisplayString)! !

!GTSpotterProcessor methodsFor: 'testing' stamp: 'StefanReichhart 3/22/2015 22:15'!
shouldFilterInContext: aSpotterContext
	^ aSpotterContext notEmpty 
		or: [ self wantsToDisplayOnEmptyQuery ]! !

!GTSpotterProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:20'!
title
	self subclassResponsibility! !

!GTSpotterProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2014 14:19'!
wantsToDisplayOnEmptyQuery
	^ true! !

Object subclass: #GTSpotterProcessorFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterProcessorFilter commentStamp: 'AndreiChis 9/24/2015 18:16' prior: 0!
I am the root class for filters that decide what processors can be loaded in a step. I have no conection whatsoever with the GTFilter hierarchy.

Subclasses need to implement #shouldEnableProcessorsCreateBy: to indicate whether or not a given processor should be enabled.

Subclasses can return a configuration block from #configurationBlockForProcessorsCreatedBy: if they want to customize a certain processor.!

GTSpotterProcessorFilter subclass: #GTSpotterMethodListProcessorFilter
	instanceVariableNames: 'selectedMethodSignatures configurationBlocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterMethodListProcessorFilter commentStamp: 'AndreiChis 9/24/2015 18:17' prior: 0!
I implement a filtering strategy for processors based on method signatures (method selector and class).

I only allow processors created by a method currently added to the filter.

I can attach to each processor a configuration block.

For examples view my class side methods in teh category 'example'!

!GTSpotterMethodListProcessorFilter methodsFor: 'adding' stamp: 'AndreiChis 9/24/2015 18:54'!
allowProcessorsFrom: aMethod
	|signature|
	
	signature := self signatureFor: aMethod.
	(selectedMethodSignatures includes: signature) ifFalse: [ selectedMethodSignatures add: signature ].
	! !

!GTSpotterMethodListProcessorFilter methodsFor: 'adding' stamp: 'AndreiChis 11/11/2015 11:39'!
allowProcessorsFrom: aMethod configuredWith: aBlock
	
	self allowProcessorsFrom: aMethod.
	configurationBlocks at: aMethod printString put: aBlock.
	! !

!GTSpotterMethodListProcessorFilter methodsFor: 'accessing' stamp: 'AndreiChis 11/11/2015 11:39'!
configurationBlockForProcessorsCreatedBy: aMethod
	
	^ configurationBlocks at: aMethod printString ifAbsent: [ self nullConfigurationBlock ]! !

!GTSpotterMethodListProcessorFilter methodsFor: 'initialization' stamp: 'AndreiChis 9/24/2015 17:26'!
initialize
	super initialize.

	selectedMethodSignatures := OrderedCollection new.
	configurationBlocks := Dictionary new.! !

!GTSpotterMethodListProcessorFilter methodsFor: 'accessing' stamp: 'AndreiChis 9/24/2015 17:32'!
nullConfigurationBlock

	^ [ :processor | ]! !

!GTSpotterMethodListProcessorFilter methodsFor: 'printing' stamp: 'AndreiChis 7/7/2015 15:45'!
printSignature: aSignature

	^ aSignature first name, '>>', aSignature second asString! !

!GTSpotterMethodListProcessorFilter methodsFor: 'testing' stamp: 'AndreiChis 7/7/2015 16:22'!
shouldEnableProcessorsCreateBy: aMethod

	^ selectedMethodSignatures anySatisfy: [ :aSignature | 
		aSignature first = aMethod methodClass and: [ aSignature second = aMethod selector ] ]! !

!GTSpotterMethodListProcessorFilter methodsFor: 'accessing' stamp: 'AndreiChis 7/7/2015 15:44'!
signatureFor: aMethod

	^ {aMethod methodClass . aMethod selector}! !

GTSpotterProcessorFilter subclass: #GTSpotterNullProcessorFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterNullProcessorFilter commentStamp: 'AndreiChis 7/7/2015 16:36' prior: 0!
I implement a filtering strategy for processors that always returns true. Use me by default instead of adding null checks to determnine if a filter is present.!

!GTSpotterNullProcessorFilter methodsFor: 'testing' stamp: 'AndreiChis 9/24/2015 17:25'!
configurationBlockForProcessorsCreatedBy: aMethod
	"No need to configure anything."
	
	^ [ :processor | ]! !

!GTSpotterNullProcessorFilter methodsFor: 'testing' stamp: 'AndreiChis 7/7/2015 16:43'!
shouldEnableProcessorsCreateBy: aMethod
	"Enable everything."
	
	^ true! !

!GTSpotterProcessorFilter methodsFor: 'accessing' stamp: 'AndreiChis 9/24/2015 18:16'!
configurationBlockForProcessorsCreatedBy: aMethod
	"Return a block that takes one parameter (i.e., the processor) and
	can configure that processor before being used in Spotter."
	
	self subclassResponsibility! !

!GTSpotterProcessorFilter methodsFor: 'testing' stamp: 'AndreiChis 7/7/2015 16:37'!
shouldEnableProcessorsCreateBy: aMethod
	"Return weather or not the processor created by the given method
	should be enabled in Spotter."
	
	self subclassResponsibility! !

Object subclass: #GTSpotterStep
	instanceVariableNames: 'announcer processors origin context selected stream candidates asyncTask spotter lastSearchContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterStep commentStamp: 'TudorGirba 11/26/2014 15:13' prior: 0!
It models one step in the spotter search.

A step knows:
- the origin object 
- the active processors that handle the query, and the candidates
- the selected candidate, and
- the list of all filtered candidates

It also knows the stream through which the list of candidates is affected.

The key method is process:!

!GTSpotterStep class methodsFor: 'example' stamp: 'TudorGirba 4/10/2015 11:05'!
gtExampleBasic
	<gtExample>
	^ self new! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:31'!
actDueTo: anEventType
	self selected ifNil: [ ^ self ].
	self spotter
		historize: self selected;
		notifyActOn: self selectedCandidate for: anEventType.
	self selected processor actOn: self selectedCandidate for: self
! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/18/2014 21:07'!
addProcessor: aProcessor

	self processors add: aProcessor! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:26'!
announcer

	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'StefanReichhart 3/12/2015 12:46'!
asyncTask

	^ asyncTask ifNil: [ asyncTask := self defaultTask ]! !

!GTSpotterStep methodsFor: 'private' stamp: 'StefanReichhart 3/17/2015 15:10'!
basicRelevantProcessorsProcess: aSpotterContext
	self basicRelevantProcessorsProcess: aSpotterContext do: [ :processor | 
		aSpotterContext processor: processor.
		processor filterInContext: aSpotterContext ]! !

!GTSpotterStep methodsFor: 'private' stamp: 'StefanReichhart 3/17/2015 15:08'!
basicRelevantProcessorsProcess: aSpotterContext do: aBlock
	aSpotterContext text substrings 
		detect: [ :each | each beginsWith: '#' ]
		ifFound: [ :categoryQuery | 
			| categoryQueryPrefix |
			aSpotterContext text: (aSpotterContext text copyReplaceAll: categoryQuery with: '').
			categoryQueryPrefix := categoryQuery allButFirst asLowercase.
			self processors 
				select: [ :each | each title asLowercase beginsWith: categoryQueryPrefix ]
				thenDo: aBlock ]
		ifNone: [ 
			self processors do: aBlock ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'TudorGirba 12/1/2014 14:32'!
canDiveIn: aCandidate
	| newFakeStep |
	newFakeStep := self spotter newStep origin: self origin.
	aCandidate spotterProcessorsFor: newFakeStep.
	^ newFakeStep processors notEmpty! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 12:34'!
canDiveInSelectedCandidate

	^ self canDiveIn: self selectedCandidate! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/25/2015 14:29'!
candidates

	^ candidates ifNil: [
		candidates := GTSpotterCandidatesList new.
		candidates announcer weak subscribe: GTSpotterCandidateAdded do: [ self candidates hasOnlyOneItem ifTrue: [ self selectFirst ] ].
		candidates announcer weak subscribe: GTSpotterAllCandidatesAdded do: [ self selectFirst ].
		candidates announcer weak subscribe: GTSpotterAllCandidatesRemoved do: [ self selected: nil ].
		candidates ]! !

!GTSpotterStep methodsFor: 'processing' stamp: 'AndreiChis 9/24/2015 17:20'!
configureProcessorsStartingAt: anIndex with: aConfigurationBlock
	"Execute aConfigurationBlock with all processors starting at anIndex.
	(this assumes processors are stored in an OrderedCollection that captures the
	orderin which they are added to the step.)"
	
	(anIndex > self processors size) ifTrue: [ ^ self ].
	anIndex to: self processors size do: [ :processorIndex |
		aConfigurationBlock value: (self processors at: processorIndex) ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'StefanReichhart 2/24/2015 17:07'!
context

	^ context ifNil: [ context := self newContextForQuery: nil ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AndreiChis 2/28/2015 18:27'!
context: aGTSpotterContext
	context := aGTSpotterContext! !

!GTSpotterStep methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 12:46'!
defaultStream
	^ GTSpotterUIThreadStream new! !

!GTSpotterStep methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/12/2015 12:46'!
defaultTask
	^ GLMAsyncTask new! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:26'!
diveIn
	self diveInDueTo: #undefined! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 20:00'!
diveInCategory

	^ self diveInCategoryDueTo: #unknown
	! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:28'!
diveInCategoryDueTo: anEventType

	self spotter
		requestNextCategoryStepWith: self selected processorLink;
		notifyDiveInCategory: self selected processor for: anEventType
	! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AndreiChis 3/20/2015 19:25'!
diveInDueTo: anEventType
	self canDiveInSelectedCandidate ifTrue: [ 
		self spotter
			historize: self selected;
			requestNextStepWith: self selectedCandidate;
			notifyDiveIn: self selectedCandidate for: anEventType ]! !

!GTSpotterStep methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 3/22/2015 18:47'!
exceptionHandler
	^ GTCurrentSpotterExceptionHandler value ifNil: [ self spotter exceptionHandler ]
	" #ifNil: is necessary because the sender chain of #spotterProcessorsFor:pragma: may have multiple callees outside of the exception handler (async) ... so we have to provide a global but yet easy fallback "! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 2/24/2015 12:24'!
exit

	self spotter exit! !

!GTSpotterStep methodsFor: 'inspecting' stamp: 'TudorGirba 4/10/2015 10:59'!
gtInspectorProcessorsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Processors';
		display: [ self processors ];
		format: #gtDisplayString! !

!GTSpotterStep methodsFor: 'testing' stamp: 'AndreiChis 7/8/2015 16:47'!
hasPreviousNavigationFromClass: aClass

	^ self hasPreviousStep and: [
		self previousStep origin isKindOf: aClass ]! !

!GTSpotterStep methodsFor: 'testing' stamp: 'AndreiChis 7/8/2015 14:41'!
hasPreviousStep
	
	^ (self spotter steps indexOf: self) > 1! !

!GTSpotterStep methodsFor: 'testing' stamp: 'AliakseiSyrel 11/14/2014 23:51'!
isEmpty

	^ self candidates isEmpty! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
listProcessor
	| processor |
	processor := GTSpotterCandidatesListProcessor new.
	self addProcessor: processor.
	^ processor! !

!GTSpotterStep methodsFor: 'processing' stamp: 'StefanReichhart 2/24/2015 17:06'!
newContextForQuery: aString
	^ GTSpotterContext new 
		step: self;
		stream: self stream;
		text: aString;
		yourself! !

!GTSpotterStep methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 19:08'!
notifySelectedCandidateChanged: aDoubleLink
	
	^ self notifySelectedCandidateChanged: aDoubleLink for: #unknown! !

!GTSpotterStep methodsFor: 'notifying' stamp: 'AndreiChis 3/20/2015 19:08'!
notifySelectedCandidateChanged: aDoubleLink for: anEventType
	|candidate|
	
	candidate := aDoubleLink ifNotNil: [ :o | o value ].
	self announcer announce: (GTSpotterSelectedCandidateChanged new selected: candidate).
	self spotter notifyCandidateSelected: candidate for: anEventType! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:26'!
origin

	^ origin! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 17:13'!
origin: anObject

	origin := anObject! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 3/22/2015 14:31'!
previousProcessorFrom: aCollection
	aCollection do: [ :each | 
		each asSpotterCandidateLink processor ifNotNil: [ ^ each processor ] ]. " we assume they are all identical "
	^ GTSpotterCandidatesListProcessor new
		title: 'Items';
		filter: GTFilterSubstring;
		yourself! !

!GTSpotterStep methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 7/8/2015 14:49'!
previousStep
	
	^ self spotter steps at: 
			(self spotter steps indexOf: self) - 1! !

!GTSpotterStep methodsFor: 'processing' stamp: 'StefanReichhart 3/18/2015 12:58'!
process: aString
	"I do not accept empty queries or the same queries as before.
	If nil is passed, than an empty string will be processed. This approach is used to
	destinguish when user deletes last character in the search and when search field became
	empty after spawning new step"
	
	"no need to search for the same query"
	(self context matches: aString) ifTrue: [ ^ self ].
	self context: (self newContextForQuery: aString).
	
	" updating timestamp in a stream, to prevent candidates from old process being shown "
	self stream updateTimestamp.
	
	self asyncTask
		execute: [ :aCurrentContext |
			self spotter notifyContextChangedFrom: lastSearchContext to: self context.
			self processContext: aCurrentContext ]
		withArguments: { self context. }
		callback: [
			lastSearchContext := self context. 
			self spotter notifySearchFinishedFor: aString processors: self processors ]
		"added small delay before actual searching. It makes spotter faster :)"
		delay: 200! !

!GTSpotterStep methodsFor: 'processing' stamp: 'StefanReichhart 3/18/2015 14:52'!
processContext: aSpotterContext
	self spotter handleExceptionsDuring: [ 
		self stream removeAllCandidates.
		self relevantProcessorsProcess: aSpotterContext  ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 23:21'!
processors

	^ processors ifNil: [ 
		processors := OrderedCollection new.
		self origin spotterProcessorsFor: self.
		"this is a hack. we do it here just because we need to store the
		category name in the brick after the processors have been created"
		processors do: [ :each | 				
			self candidates addProcessor: each ].
		processors ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:27'!
processors: aCollection

	processors := aCollection! !

!GTSpotterStep methodsFor: 'accessing-dynamic' stamp: 'AndreiChis 7/7/2015 16:08'!
processorsFilter

	^ self spotter processorsFilter! !

!GTSpotterStep methodsFor: 'private' stamp: 'StefanReichhart 3/17/2015 15:19'!
relevantProcessorsProcess: aSpotterContext
	[ self basicRelevantProcessorsProcess: aSpotterContext ]
		on: Error
		do: [ :exception | 
			self exceptionHandler 
				handleException: exception 
				do: [ ('[Spotter] Exception in process: ', exception asString) logCr ] ]! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 2/24/2015 11:05'!
selectFirst
	
	self candidates isEmpty ifTrue: [ ^ self ].
	self selected: self candidates head! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 2/24/2015 11:06'!
selectNextCategory
	|currentCategory nextCategory|
	self selected ifNil: [ ^ self ].
	
	currentCategory := self candidates getProcessorLinkByCandidateLink: self selected.
	nextCategory := self candidates nextProcessorLinkOf: currentCategory.
	
	self selected: ((currentCategory = nextCategory)
		ifTrue: [ nextCategory tailLink ]
		ifFalse: [ nextCategory headLink ])
	
	! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AndreiChis 3/20/2015 19:20'!
selectNextDueTo: anEventType
	
	self selected ifNil: [ ^ self ].
	self selected: self selected nextLink dueTo: anEventType
	
	! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 2/24/2015 11:06'!
selectPreviousCategory
	|currentCategory previousCategory|
	self selected ifNil: [ ^ self ].
	
	currentCategory := self candidates getProcessorLinkByCandidateLink: self selected.
	previousCategory := self candidates previousProcessorLinkOf: currentCategory.
	
	self selected: previousCategory headLink! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AndreiChis 3/20/2015 19:21'!
selectPreviousDueTo: anEventType

	self selected ifNil: [ ^ self ].
	self selected: self selected previousLink dueTo: anEventType! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/25/2015 14:11'!
selected

	^ selected ifNil: [
		selected := (self candidates isEmpty
			ifTrue: [ ^ nil ]
			ifFalse: [ self candidates head ]).
		self notifySelectedCandidateChanged: selected.
		selected ifNotNil: [ self spotter notifyCategorySelected: self selected processor ].
		selected ]! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AndreiChis 3/20/2015 19:19'!
selected: aDoubleLink
	
	^ self selected: aDoubleLink dueTo: #unknown
	
	! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AndreiChis 3/20/2015 19:19'!
selected: aDoubleLink dueTo: anEvenType
	
	self selected = aDoubleLink ifTrue: [ ^ self ].
	
	self spotter
		after: [
			selected := aDoubleLink.
			self notifySelectedCandidateChanged: selected for: anEvenType]
		do: [ self spotter notifyCategorySelected: self selected processor ]
		ifTrue: [ aDoubleLink
			ifNotNil: [ self selected
				ifNotNil: [ (self selected processor = aDoubleLink processor) not ]
				ifNil: [ true ] ]
			ifNil: [ false ] ]
	
	! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 16:00'!
selectedCandidate

	^ self selected
		ifNotNil: [ self selected value ]
		ifNil: [ nil ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/11/2014 12:15'!
selectedCategory

	^ self selected processor! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/24/2015 12:13'!
spotter

	^ spotter! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 10:14'!
spotter: aSpotter
	spotter := aSpotter ! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'StefanReichhart 3/12/2015 12:46'!
stream

	^ stream ifNil: [
		stream := self defaultStream.
		stream
			onAddedSelector: #addCandidate:in:;
			onRemoveSelector: #removeAllCandidatesOf:;
			receiver: self candidates.
		stream ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 11/30/2014 21:02'!
terminateProcessors

	self asyncTask terminate! !

Object subclass: #GTSpotterUIThreadStream
	instanceVariableNames: 'onAddedSelector onRemoveSelector receiver timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:11'!
addObject: firstObject inProcessor: secondObject

	self performSymbol: self onAddedSelector withArguments: { firstObject. secondObject }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:12'!
addObjects: aCollection inProcessor: aProcessor

	self performSymbol: #addAllCandidates:in: withArguments: { aCollection . aProcessor }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
onAddedSelector
	^ onAddedSelector! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
onAddedSelector: anObject
	onAddedSelector := anObject! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:54'!
onRemoveSelector
	^ onRemoveSelector! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:54'!
onRemoveSelector: anObject
	onRemoveSelector := anObject! !

!GTSpotterUIThreadStream methodsFor: 'performing' stamp: 'AliakseiSyrel 11/30/2014 22:44'!
performSymbol: aSymbol withArguments: aCollection
	|time|
	"we save current timestamp here, so that defer block can check if it belongs to the correct task"
	time := self timestamp.
	"UI manages commands for us"
	Processor yield.
	"if timestamp is wrong just skip command"
	UIManager default defer: [ time = self timestamp ifTrue: [ self receiver perform: aSymbol withEnoughArguments: aCollection ] ]! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
receiver
	^ receiver! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
receiver: anObject
	receiver := anObject! !

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:12'!
removeAllCandidates

	self performSymbol: #removeAllCandidates withArguments: { }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 22:38'!
timestamp
	^ timestamp! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 22:38'!
timestamp: anObject
	timestamp := anObject! !

!GTSpotterUIThreadStream methodsFor: 'updating' stamp: 'AliakseiSyrel 11/30/2014 22:39'!
updateTimestamp

	self timestamp: Time microsecondClockValue! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterCandidateLink

	^ GTSpotterCandidateLink value: self! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterProcessorLink

	^ GTSpotterProcessorLink value: self! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 2/24/2015 14:51'!
gtFilter
	^ GTFilterBlock gtFilter
		! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/20/2015 11:29'!
gtIterator
	^ Error signal: 'This is not a spotter iterator'! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/22/2015 16:58'!
gtListFilter
	^ GTFilterSubstring new! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/20/2015 11:48'!
hasDynamicItems
	^ false! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self inspect! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/23/2015 18:27'!
spotterActDefault: aStep
	aStep exit.
	self spotterActDefault! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 3/22/2015 13:54'!
spotterPreviewIn: aComposite inContext: aSpotter

	| pragmas |
	pragmas := Pragma 
				allNamed: #spotterPreview: 
				from: self class 
				to: Object
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	"We iterate through all pragmas and execute the corresponding methods
	to ensure that all possible previews are taken into account.
	Even though at this moment we only display one preview, we still have to go through
	all pragmas because it can happen that the method has a guarding if and thus, the actual
	preview would not be triggered."
	pragmas do: [ :eachPragma | 
		(eachPragma selector findTokens: $:) size = 1 
			ifTrue: [ self perform: eachPragma selector with: aComposite ]. 
		(eachPragma selector findTokens: $:) size = 2
			ifTrue: [ self perform: eachPragma selector with: aComposite with: aSpotter ].
		aComposite hasSubbricks ifTrue: [ ^ self ]]! !

!Object methodsFor: '*GT-Spotter' stamp: 'AliakseiSyrel 3/21/2015 23:43'!
spotterPreviewRawIn: aComposite
	<spotterPreview: 40>

	aComposite table
		title: [ self gtDisplayString ];
		display: [ :anObject | (anObject gtInspectorVariableValuePairs asSortedCollection asOrderedCollection yourself) addFirst: 'self' -> anObject; yourself ];
		column: 'Variable'
			evaluated: [:assoc |	GTObjectPrinter new asNonTruncatedTextFrom: assoc key ]
			styled: [ :aBrick | aBrick textPosition: #rightCenter; margin: #(0 15 0 0); textColor: aComposite themer textLightColor; height: 30 ];
		column: 'Value'
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ]
			styled: [ :aBrick | aBrick margin: #(0 0 0 15); height: 30 ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!Object methodsFor: '*GT-Spotter' stamp: 'AndreiChis 9/24/2015 18:14'!
spotterProcessorsFor: aSpotterStep
	"This is a utility method that collects all extensions (processors) for the current object.
	By default, it simply looks for the #spotterOrder: pragma.
	The step can decice whether or not an extension should be enabled.
	The step can also configure each extension (e.g. override any property)"
	
	^ (((Pragma 
		allNamed: #spotterOrder:
		from: self class 
		to: Object)
			select: [:pragma | aSpotterStep processorsFilter shouldEnableProcessorsCreateBy: pragma method])
			sort: [ :first :second | (first argumentAt: 1) < (second argumentAt: 1) ])
			do: [ :pragma ||currentSize|
				currentSize := aSpotterStep processors size.
				self spotterProcessorsFor: aSpotterStep pragma: pragma.
				aSpotterStep "configure the new processors if required"
					configureProcessorsStartingAt: currentSize+1 
					with: (aSpotterStep processorsFilter configurationBlockForProcessorsCreatedBy: pragma method)]! !

!Object methodsFor: '*GT-Spotter' stamp: 'StefanReichhart 3/17/2015 15:48'!
spotterProcessorsFor: aSpotterStep pragma: aPragma
	" if there is a problem with the definition of one or more processors, let the other processors continue to work "
	 [ self perform: aPragma selector with: aSpotterStep ]
		on: Error 
		do: [ :exception | 
			aSpotterStep exceptionHandler
				handleException: exception
				do: [ 	('[Spotter] Exception while collecting processors for <', self class name, '>: ', exception asString) logCr ] ]! !

GLMInteractableBrick subclass: #GTSpotterCategoryTitleBrick
	instanceVariableNames: 'nameBrick amountBrick actionbarBrick stepModel categoryProcessor diveInButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:26'!
actionbarBrick
	^ actionbarBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:39'!
actionbarBrick: anObject
	actionbarBrick := anObject.

	self actionbarBrick
		vSpaceFill;
		hShrinkWrap.! !

!GTSpotterCategoryTitleBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 3/22/2015 11:52'!
addDiveInButton
	
	diveInButton := self newActionbarButton.
	self diveInButton
		icon: self themer spotterThemer iconDiveInCategory;
		pressedColor: (self themer spotterThemer itemActionSelectedBackgroundColor alpha: 0.5);
		action: [ self stepModel diveInCategoryDueTo: #actionButton ];
		beHelp;
		hintTitle: 'Show all';
		hintText: '<cmd+shift+right>'.
		
	self pushActionButton: self diveInButton
	! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:26'!
amountBrick

	^ amountBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
amountBrick: aBrick

	amountBrick ifNotNil: [self removeBrick: amountBrick].
	amountBrick := aBrick.
	
	self themer spotterThemer categoryAmountStyleFor: amountBrick.
	
	self addBrickBack: amountBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:45'!
categoryProcessor
	^ categoryProcessor! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:45'!
categoryProcessor: anObject
	categoryProcessor := anObject! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:58'!
diveInButton
	^ diveInButton! !

!GTSpotterCategoryTitleBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/18/2015 15:44'!
hideActionbar

	(self hasSubbrick: self actionbarBrick) ifTrue: [ 
		self removeBrick: self actionbarBrick ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:33'!
nameBrick

	^ nameBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
nameBrick: aBrick

	nameBrick ifNotNil: [self removeBrick: nameBrick].
	nameBrick := aBrick.
	
	self themer spotterThemer categoryTitleNameStyleFor: nameBrick.
	
	self addBrickBack: nameBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/18/2015 15:33'!
newActionbarBrick

	^ GLMBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/18/2015 15:32'!
newActionbarButton

	^ GLMHintableActionButtonBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/19/2014 23:28'!
newAmountBrick

	^ GLMLabelBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/18/2014 23:33'!
newNameBrick

	^ GLMLabelBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'TudorGirba 1/10/2016 16:32'!
on: aStepModel category: aProcessor

	self stepModel: aStepModel.
	self categoryProcessor: aProcessor.
	
	self nameBrick: self newNameBrick.
	self nameBrick text: '#', aProcessor title.
			
	self amountBrick: self newAmountBrick.
	self amountBrick text: '0/0'.
	
	self actionbarBrick: self newActionbarBrick.
	self addDiveInButton.
	
	self onCandidateSelected.
	
	self nameBrick wrappedBounds markWidthDirty.
	self nameBrick label wrappedBounds markWidthDirty.
	self doLayoutForce.

	^ self! !

!GTSpotterCategoryTitleBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/25/2015 14:06'!
onCandidateSelected
	
	self stepModel selected ifNil: [ ^ self ].
	self stepModel selectedCategory = self categoryProcessor
		ifTrue: [ self showActionbar ]
		ifFalse: [ self hideActionbar ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/28/2015 00:59'!
onHideHints

	(self hasSubbrick: self actionbarBrick) ifFalse: [ ^ self ].
	self themer spotterThemer hintHideStyleFor: self diveInButton! !

!GTSpotterCategoryTitleBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/2/2014 00:47'!
onLayoutEvent: aLayoutEvent
	super onLayoutEvent: aLayoutEvent.
	
	(aLayoutEvent isKindOf: GLMBrickLayoutStacked) ifTrue: [ "self enable" ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/28/2015 00:58'!
onRevealHints

	(self hasSubbrick: self actionbarBrick) ifFalse: [ ^ self ].
	self themer spotterThemer hintRevealStyleFor: self diveInButton! !

!GTSpotterCategoryTitleBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/23/2015 17:47'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer categoryTitleWidgetStyleFor: self.
	self themer spotterThemer categoryAmountWidgetStyleFor: self amountBrick.
	self themer spotterThemer categoryTitleNameWidgetStyleFor: self nameBrick.! !

!GTSpotterCategoryTitleBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 2/28/2015 00:59'!
pushActionButton: aButton

	aButton
		width: [ :b | b icon width * 1.5 ];
		vSpaceFill.
		
	self actionbarBrick addBrickBack: aButton.
	
	self stepModel spotter isShiftPressed
		ifTrue: [ self themer spotterThemer hintRevealStyleFor: aButton ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:38'!
setAmountVisible: visible all: all

	self amountBrick text: (visible asString, '/', all asString).
	self amountBrick wrappedBounds markWidthDirty.
	self amountBrick doLayout.
	self doLayoutForce! !

!GTSpotterCategoryTitleBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/28/2015 01:02'!
showActionbar

	(self hasSubbrick: self actionbarBrick) ifFalse: [ 
		self addBrickBack: self actionbarBrick.
		self toggleHints ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 15:40'!
stepModel

	^ stepModel! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
stepModel: anObject
	stepModel := anObject.
	
	self stepModel announcer weak when: GTSpotterSelectedCandidateChanged send: #onCandidateSelected to: self.
	self stepModel spotter announcer weak when: GTSpotterRevealHints send: #onRevealHints to: self.
	self stepModel spotter announcer weak when: GTSpotterHideHints send: #onHideHints to: self.! !

!GTSpotterCategoryTitleBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/28/2015 01:02'!
toggleHints

	(self hasSubbrick: self actionbarBrick) ifFalse: [ ^ self ].
	self stepModel spotter isShiftPressed
		ifTrue: [ self onRevealHints ]
		ifFalse: [ self onHideHints ]! !

GLMInteractableBrick subclass: #GTSpotterItemBrick
	instanceVariableNames: 'iconBrick labelBrick stepModel candidateLink actionbarBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 11:31'!
actionbarBrick
	^ actionbarBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
actionbarBrick: aBrick

	actionbarBrick ifNotNil: [self removeBrick: actionbarBrick].
	actionbarBrick := aBrick.
	
	self themer spotterThemer itemActionbarStyleFor: aBrick.
	
	self addBrickBack: actionbarBrick! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 11:49'!
beSelected
	self stepModel selected: self candidateLink
	! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:13'!
candidateLink

	^ candidateLink! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/28/2015 00:14'!
candidateLink: aDoubleLink 

	candidateLink := aDoubleLink.
	
	self actionbarBrick candidateLink: self candidateLink! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/11/2014 12:37'!
check

	self showActionbar.
	super check.
	self notifySelected! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/27/2014 12:57'!
checkOrUncheck

	self stepModel selected = self candidateLink
		ifTrue: [ self isChecked ifFalse: [ self check ] ]
		ifFalse: [ self isChecked ifTrue: [ self uncheck ] ]! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AndreiChis 3/20/2015 19:30'!
doubleClick: evt

	self stepModel actDueTo: #doubleClick! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/23/2014 20:02'!
handlesMouseDown: evt
	^ true! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/4/2015 19:58'!
hideActionbar
		
	self actionbarBrick visible: false! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'StefanReichhart 2/24/2015 17:10'!
highlightQuery
	self labelBrick label highlight: self stepModel context text! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 09:57'!
icon: aForm

	self iconBrick normalImage: aForm.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:26'!
iconBrick
	^ iconBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
iconBrick: aBrick

	iconBrick ifNotNil: [self removeBrick: iconBrick].
	iconBrick := aBrick.
	
	self themer spotterThemer itemIconStyleFor: iconBrick.
	
	self addBrickBack: iconBrick! !

!GTSpotterItemBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
initialize
	super initialize.
	self enable.
	
	self themer spotterThemer itemNormalStyleFor: self.
	
	self iconBrick: self newIconBrick.
	self labelBrick: self newLabelBrick.
	self actionbarBrick: self newActionbarBrick.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:26'!
labelBrick
	^ labelBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
labelBrick: aBrick

	labelBrick ifNotNil: [self removeBrick: labelBrick].
	labelBrick := aBrick.
	
	self themer spotterThemer itemLabelStyleFor: labelBrick.
	
	self addBrickBack: labelBrick! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AndreiChis 1/23/2015 17:33'!
mouseDown: evt
	|selectors|
	
	self isEnabled ifFalse: [ ^ self ].
	
	selectors := Array
				with: #singleClick:
				with: #doubleClick:
				with: nil
				with: nil.
				
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: selectors
		threshold: 10
	! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/27/2014 11:32'!
newActionbarBrick

	^ GTSpotterItemActionbarBrick new! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/24/2014 10:27'!
newIconBrick

	^ GLMInteractableBrick new normalImage: ((Form extent: 16@16 depth: 32) fillAlpha: 0)! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'TudorGirba 1/27/2015 23:42'!
newLabelBrick
	self flag: 'find a better number, or at least a better place for the number :)'.

	^ GLMLabelBrick new 
		text: 'Search result with very very long name';
		paddingRight: 16! !

!GTSpotterItemBrick methodsFor: 'notifying' stamp: 'AliakseiSyrel 1/25/2015 19:17'!
notifySelected

	self stepModel spotter announce: (GTSpotterCandidateSelected new candidateBrick: self)! !

!GTSpotterItemBrick methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/10/2015 14:30'!
onLayouted
	super onLayouted.
	
	self isChecked ifTrue: [ self stepModel spotter announce: GTSpotterCandidateSelectedMoved new ]! !

!GTSpotterItemBrick methodsFor: 'brick-structure-events' stamp: 'AliakseiSyrel 1/29/2015 01:34'!
onRemovedFrom: aBrick
	super onRemovedFrom: aBrick.
	
	"I must not receive any announcements as soon as i'm removed from dom"
	self stepModel ifNotNil: [
		self stepModel announcer unsubscribe: self.
		self stepModel spotter announcer unsubscribe: self  ]! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/27/2014 12:55'!
onSelectedChanged: ann

	self checkOrUncheck! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/29/2015 00:21'!
onStepPopped

	
	(self stepModel spotter steps last = self stepModel) & self isChecked ifTrue: [
		self notifySelected ]! !

!GTSpotterItemBrick methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 22:06'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer itemNormalWidgetStyleFor: self! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 2/4/2015 19:58'!
showActionbar

	self actionbarBrick visible: true! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AndreiChis 3/20/2015 19:20'!
singleClick: evt

	self stepModel selected: self candidateLink dueTo: #singleClick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:28'!
stepModel

	^ stepModel! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'CyrilFerlicot 9/11/2015 20:29'!
stepModel: aModel

	stepModel := aModel.
	
	stepModel announcer weak when: GTSpotterSelectedCandidateChanged send: #onSelectedChanged: to: self.
	stepModel spotter announcer weak when: GTSpotterStepPopped send: #onStepPopped to: self.
	
	self actionbarBrick stepModel: aModel.
	
	self
		highlightQuery;
		checkOrUncheck.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 10/25/2014 18:34'!
text: aString

	self labelBrick text: aString.! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/1/2014 23:20'!
uncheck
	
	super uncheck.
	
	self hideActionbar! !

GLMInteractableBrick subclass: #GTSpotterStepBreadcrumbItem
	instanceVariableNames: 'labelBrick triangleBrick stepModel isTriangleVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 2/18/2015 14:19'!
click: evt
	super click: evt.
	
	self stepModel spotter popUntil: self stepModel.
	^ true! !

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 2/18/2015 15:12'!
deselect
	
	self invalidateWith: [
		self labelBrick label customFont; beRegular ]! !

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 3/21/2015 22:54'!
hideTriangle

	isTriangleVisible := false.
	self themer spotterThemer breadcrumbItemTriangleWidgetStyleFor: self triangleBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/18/2015 14:19'!
initialize
	super initialize.
	
	self
		useVerticalLinearLayout;
		labelBrick: self newLabelBrick;
		triangleBrick: self newTriangleBrick;
		enable
	! !

!GTSpotterStepBreadcrumbItem methodsFor: 'testing' stamp: 'AliakseiSyrel 3/21/2015 22:50'!
isTriangleVisible

	^ isTriangleVisible ifNil: [ isTriangleVisible := true ]! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:25'!
labelBrick

	^ labelBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
labelBrick: aBrick

	labelBrick := aBrick.
	
	self themer spotterThemer breadcrumbItemLabelStyleFor: self labelBrick.
	self addBrickBack: self labelBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 14:14'!
newLabelBrick

	^ GLMLabelBrick new! !

!GTSpotterStepBreadcrumbItem methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 14:14'!
newTriangleBrick

	^ GLMBrick new! !

!GTSpotterStepBreadcrumbItem methodsFor: 'brick-properties-events' stamp: 'AliakseiSyrel 3/21/2015 22:30'!
onThemerChanged
	super onThemerChanged.
	
	self themer spotterThemer breadcrumbItemLabelWidgetStyleFor: self labelBrick.
	self themer spotterThemer breadcrumbItemTriangleWidgetStyleFor: self triangleBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 2/18/2015 15:12'!
select
	
	self invalidateWith: [
		self labelBrick label customFont; beBold ]! !

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 3/21/2015 22:54'!
showTriangle

	isTriangleVisible := true.
	self themer spotterThemer breadcrumbItemTriangleWidgetStyleFor: self triangleBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 14:13'!
stepModel
	^ stepModel! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/18/2015 14:13'!
stepModel: anObject
	stepModel := anObject! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/26/2015 00:30'!
text: aString

	self labelBrick text: aString.
	self doLayoutForce! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 14:09'!
triangleBrick

	^ triangleBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/30/2015 16:07'!
triangleBrick: aBrick

	triangleBrick := aBrick.
	
	self themer spotterThemer breadcrumbItemTriangleStyleFor: self triangleBrick.
	self addBrickBack: self triangleBrick! !

!VirtualMachine methodsFor: '*GT-Spotter' stamp: 'TudorGirba 3/30/2015 22:29'!
canHandleShiftPressed
	^ self interpreterSourceDate < 2015 asYear ! !
